
#include <AttributeHandleSetImpl.h>

  AttributeHandleSetImpl::AttributeHandleSetImpl(RTI::ULong _sz)  
  {
     _size = _sz;
      number_of_elements = 0;
      eles = new RTI::AttributeHandle[_size];
   };


  RTI::ULong AttributeHandleSetImpl::size() const { return number_of_elements;};

  RTI::AttributeHandle 
  AttributeHandleSetImpl::getHandle(RTI::ULong i) const throw ( RTI::ArrayIndexOutOfBounds) 
  { return getElementAt(i); };
  
  void AttributeHandleSetImpl::add(RTI::AttributeHandle h) throw ( RTI::ArrayIndexOutOfBounds) 
  { put(h); };

  // not guaranteed safe while iterating
  void AttributeHandleSetImpl::remove(RTI::AttributeHandle h) throw ( RTI::AttributeNotDefined) 
  { 
     RTI::ULong ind;
     if(findIndexOf(h,&ind)) rmAt(ind);
  };
  
  // Empty the Set
  void AttributeHandleSetImpl::empty() {  freeUpElements(); }; 

  //is set empty?
  RTI::Boolean AttributeHandleSetImpl::isEmpty() const 
  { return (_size==0?RTI::RTI_TRUE:RTI::RTI_FALSE); };  

  //is set empty?
  RTI::Boolean AttributeHandleSetImpl::isMember(RTI::AttributeHandle h) const 
  { 
     RTI::ULong index;
     return (findIndexOf(h,&index)==1?RTI::RTI_TRUE:RTI::RTI_FALSE); 
  };

//  AttributeHandleSet setUnion(const AttributeHandleSet &) const;
//  AttributeHandleSet setIntersection(const AttributeHandleSet &) const;
//  AttributeHandleSet removeSetIntersection(const AttributeHandleSet &) const;

RTI::AttributeHandle
AttributeHandleSetImpl::getElementAt( RTI::ULong index) const
    throw ( RTI::ArrayIndexOutOfBounds)
{
     if(index<0 || index > (_size-1) )
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
     return eles[index];
}

void AttributeHandleSetImpl::put(RTI::AttributeHandle _newele)
    throw (RTI::ArrayIndexOutOfBounds)
{
   if(number_of_elements>(_size-1))
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
   eles[number_of_elements] = _newele;
   number_of_elements++;

};//

void AttributeHandleSetImpl::rmAt(RTI::ULong index)
     throw (RTI::ArrayIndexOutOfBounds)

{
   if(index<0 || index > (_size-1))
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
   for(RTI::ULong i=index;i<_size-1;i++) eles[i] = eles[i+1];
   number_of_elements--;
};//


void AttributeHandleSetImpl::freeUpElements()
{ number_of_elements = 0; };

AttributeHandleSetImpl::findIndexOf(RTI::AttributeHandle _sele, RTI::ULong *index) const
{
   int found = 0;
   RTI::ULong i=0;
   int j;
   while(!found && i<_size)
   {
      found = ( _sele == eles[i]) ;
      if(!found) i++;
   }// end of while
   *index = i;

   return found;

};//


