#ifndef _ATTRIBUTEHANDLESETIMPL_H
#define _ATTRIBUTEHANDLESETIMPL_H

#ifndef _RTI_HH_
#define _RTI_HH_
#include <RTI.hh>
#endif

// typedef HandleValuePairSet AttributeHandleValuePairSet;

class AttributeHandleSetImpl : public RTI::AttributeHandleSet
{
 
private:
  RTI::ULong _size;
  RTI::ULong number_of_elements;
  RTI::AttributeHandle *eles;

public:

  AttributeHandleSetImpl(RTI::ULong _size) ; 
       

  RTI::ULong size() const ;

  RTI::AttributeHandle 
  getHandle(RTI::ULong i) const throw ( RTI::ArrayIndexOutOfBounds) ;
  
  void add(RTI::AttributeHandle h) throw ( RTI::ArrayIndexOutOfBounds) ;

  // not guaranteed safe while iterating
  void remove(RTI::AttributeHandle h) throw ( RTI::AttributeNotDefined) ;
  
  // Empty the Set
  void empty() ;

  //is set empty?
  RTI::Boolean isEmpty() const  ;

  //is set empty?
  RTI::Boolean isMember(RTI::AttributeHandle h) const ;

//  AttributeHandleSet setUnion(const AttributeHandleSet &) const;
//  AttributeHandleSet setIntersection(const AttributeHandleSet &) const;
//  AttributeHandleSet removeSetIntersection(const AttributeHandleSet &) const;

   void freeUpElements();
   findIndexOf(RTI::AttributeHandle _sele, RTI::ULong *index) const;
   void rmAt(RTI::ULong index) throw (RTI::ArrayIndexOutOfBounds);
   void put(RTI::AttributeHandle _newele) throw (RTI::ArrayIndexOutOfBounds);
   RTI::AttributeHandle getElementAt( RTI::ULong index) const
    throw ( RTI::ArrayIndexOutOfBounds);





};

#endif
