
#ifndef _RTI_HH
#define _RTI_HH
#include <RTI.hh>
#endif

#include <RegionImpl.h>
#include <AttributeHandleValuePairSetImpl.h>

#include "debug.h"


/**
*/
AttributeHandleValuePairSetImpl::AttributeHandleValuePairSetImpl(RTI::ULong _sz) 
{
  //st = new mySet<AttributeHandleValuePair,RTI::ULong>(_size);
  _size = _sz;
  number_of_elements = 0;
  eles = new AttributeHandleValuePair[_size];
  if(DEBUG1) cout << " size : " << (int)_sz << " is defined! " << endl;
} 

/**
*/
AttributeHandleValuePairSetImpl::AttributeHandleValuePairSetImpl(const
AttributeHandleValuePairSetImpl& RHS) 
{
  _size = RHS._size;
  number_of_elements = RHS.number_of_elements;
  eles = new AttributeHandleValuePair[_size];
  if(DEBUG1)
     cout << " in COPY CONSTRUCTOR size : " << (int)_size << " is defined! " << endl;

  for(int i=0;i<number_of_elements;i++) eles[i] = RHS.eles[i];
  
}// end of COPY CONSTRUCTOR  

/**
*/
AttributeHandleValuePairSetImpl::~AttributeHandleValuePairSetImpl() 
{ delete[] eles; }; 

/**
*/
RTI::ULong AttributeHandleValuePairSetImpl::size() const 
{ return number_of_elements; };
  
/**
*/
RTI::Handle 
AttributeHandleValuePairSetImpl::getHandle( RTI::ULong i) const throw ( RTI::ArrayIndexOutOfBounds) 
{
    AttributeHandleValuePair ret = getElementAt(i);
    return ret.handle;
}

/**
*/
RTI::ULong 
AttributeHandleValuePairSetImpl::getValueLength( RTI::ULong i) const 
                throw ( RTI::ArrayIndexOutOfBounds) 
{
    AttributeHandleValuePair ret = getElementAt(i);
    return ret.size;
}
  
/** 
* Get the CORBA::UnboundedSequence and put the values in char array.
*/
void 
AttributeHandleValuePairSetImpl::getValue( RTI::ULong i, char* buff, RTI::ULong& valueLength) const
       throw ( RTI::ArrayIndexOutOfBounds) 
{
     AttributeHandleValuePair ret = getElementAt(i);

     valueLength = ret.size;

     for(int j=0;j<ret.size;j++) buff[j] = ret.buf[j];
    
}// end of getValue()
  
/**
*/
char *
AttributeHandleValuePairSetImpl::getValuePointer( RTI::ULong i, RTI::ULong&  valueLength) const
       throw ( RTI::ArrayIndexOutOfBounds) 
{
     AttributeHandleValuePair ret = getElementAt(i);

     valueLength = ret.size;

     return ret.buf;

}// end of getValuePointer()
  
/**
*/
RTI::TransportType 
AttributeHandleValuePairSetImpl::getTransportType( RTI::ULong i) const
     throw ( RTI::ArrayIndexOutOfBounds) 
{
     RTI::TransportType ret;

     return ret;

}// end of getTransportType()
   
/**
*/
RTI::OrderType 
AttributeHandleValuePairSetImpl::getOrderType( RTI::ULong i) const
     throw ( RTI::ArrayIndexOutOfBounds) 
{
     RTI::OrderType ret;
  
     return ret;

}// end of getOrderType()
   
/**
*/
RTI::Region* 
AttributeHandleValuePairSetImpl::getRegion( RTI::ULong i) const
     throw ( RTI::ArrayIndexOutOfBounds, RTI::InvalidHandleValuePairSetContext ) 
{
     RTI::Region* ret;

     return ret;

}// end of getRegion()
  

/**
*/
void 
AttributeHandleValuePairSetImpl::add( RTI::Handle h, const char* buff, RTI::ULong valueLength)
       throw ( RTI::ValueLengthExceeded, RTI::ValueCountExceeded ) 
{
     AttributeHandleValuePair ele;
     ele.handle = h;
     ele.size = valueLength;
     if(DEBUG1) cout << " valueLength : " << (int)valueLength << endl;
     ele.buf = new char[valueLength];
     for(int i=0;i<valueLength;i++) ele.buf[i] = buff[i]; //ele.buf[i] = NULL;
     put(ele);

}// end of add
  
/**
// not guaranteed safe while iterating
*/
void 
AttributeHandleValuePairSetImpl::remove( RTI::Handle h) throw ( RTI::ArrayIndexOutOfBounds) 
{
     int found = 0;
     AttributeHandleValuePair ele;

     for(int i=0;!found && i<_size;i++)
     {
        ele = getElementAt(i);
        if(ele.handle==h) found=1;
     }// end of if

     if(found) rmAt(i);

}// end of remove
  
/**
*/
void 
AttributeHandleValuePairSetImpl::moveFrom(const RTI::AttributeHandleValuePairSet& ahvps, RTI::ULong& i)
       throw ( RTI::ValueCountExceeded, RTI::ArrayIndexOutOfBounds) 
{ }
  
/**
// Empty the Set without deallocating space.
*/
void 
AttributeHandleValuePairSetImpl::empty() { freeUpElements() ; }; 

/**
*/
RTI::ULong 
AttributeHandleValuePairSetImpl::start() const
{ return 0; }

/**
*/
RTI::ULong 
AttributeHandleValuePairSetImpl::valid(RTI::ULong i) const
{ return 0; }

/**
*/
RTI::ULong 
AttributeHandleValuePairSetImpl::next(RTI::ULong i) const
{ return 0; }

/**
*/
AttributeHandleValuePair
AttributeHandleValuePairSetImpl::getElementAt( RTI::ULong index) const
    throw ( RTI::ArrayIndexOutOfBounds)
{
     if(index<0 || index > (_size-1) )
      throw new RTI::ArrayIndexOutOfBounds("out of bound");

     return eles[index];

}// end of getElementAt()

/**
*/
void 
AttributeHandleValuePairSetImpl::put(AttributeHandleValuePair _newele)
    throw (RTI::ArrayIndexOutOfBounds)
{
   if(number_of_elements>(_size-1))
      throw new RTI::ArrayIndexOutOfBounds("out of bound");

   eles[number_of_elements] = _newele;

   number_of_elements++;

   if(DEBUG1) 
      cout << " number_of_elements : " << (int)number_of_elements << endl;

}// end of put()

/**
*/
void 
AttributeHandleValuePairSetImpl::rmAt(RTI::ULong index)
     throw (RTI::ArrayIndexOutOfBounds)

{
   if(index<0 || index > (_size-1))
      throw new RTI::ArrayIndexOutOfBounds("out of bound");

   for(RTI::ULong i=index;i<_size-1;i++) eles[i] = eles[i+1];

   number_of_elements--;

}// end of rmAt()

/**
*/
void 
AttributeHandleValuePairSetImpl::freeUpElements()
{ number_of_elements = 0; }

/**
*/
AttributeHandleValuePairSetImpl::findIndexOf(AttributeHandleValuePair _sele, RTI::ULong *index) const
{
   int j, found = 0;
   RTI::ULong i=0;

   while(!found && i<_size)
   {
      found = ( _sele.handle == eles[i].handle) && (_sele.size == eles[i].size) ;
      if(found) 
         for(j=0;found&&j<_sele.size;j++) 
             found = (_sele.buf[j]==eles[i].buf[j]);
      if(!found) i++;
   }// end of while

   *index = i;

   return found;

}// end of findIndexOf()

