
#ifndef _RTI_HH
#define _RTI_HH
#include <RTI.hh>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

const char * RTI::ArrayIndexOutOfBounds::_ex  ;
const char * RTI::ObjectClassNotKnown::_ex  = "ObjectClassNotKnown";
const char * RTI::InteractionClassNotKnown::_ex  = "InteractionClassNotKnown";
const char * RTI::FederateInternalError::_ex  = "FederateInternalError";
const char * RTI::ObjectNotKnown::_ex  = "ObjectNotKnown";
const char * RTI::ObjectClassNotPublished::_ex  = "ObjectClassNotPublished";
const char * RTI::InteractionParameterNotKnown::_ex  = "InteractionParameterNotKnown";
const char * RTI::InteractionClassNotPublished::_ex  = "InteractionClassNotPublished";
const char * RTI::AttributeNotKnown::_ex  = "AttributeNotKnown";
const char * RTI::AttributeNotPublished::_ex  = "AttributeNotPublished";
const char * RTI::RTIinternalError::_ex  = "RTIinternalError";
const char * RTI::FederationExecutionAlreadyExists::_ex  = "FederationExecutionAlreadyExists";
const char * RTI::NameNotFound::_ex  = "NameNotFound";
//const char * RTI::RTIinternalError::_ex  = "InternalError";
const char * RTI::AttributeNotDefined::_ex  = "AttributeNotDefined";
const char * RTI::SaveInProgress::_ex  = "SaveInProgress";
const char * RTI::InteractionClassNotDefined::_ex  = "InteractionClassNotDefined";
const char * RTI::FederationExecutionDoesNotExist::_ex  = "FederationExecutionDoesNotExist";
const char * RTI::FederatesCurrentlyJoined::_ex  = "FederatesCurrentlyJoined";
const char * RTI::AsynchronousDeliveryAlreadyEnabled::_ex  = "AsynchronousDeliveryAlreadyEnabled";
const char * RTI::TimeAdvanceAlreadyInProgress::_ex  = "TimeAdvanceAlreadyInProgress";
const char * RTI::ErrorReadingFED::_ex  = "ErrorReadingFED";
const char * RTI::AsynchronousDeliveryAlreadyDisabled::_ex  = "AsynchronousDeliveryAlreadyDisabled";
const char * RTI::EnableTimeConstrainedPending::_ex  = "EnableTimeConstrainedPending";
const char * RTI::TimeConstrainedAlreadyEnabled::_ex  = "TimeConstrainedAlreadyEnabled";
const char * RTI::InvalidFederationTime::_ex  = "InvalidFederationTime";
const char * RTI::ObjectAlreadyRegistered::_ex  = "ObjectAlreadyRegistered";
const char * RTI::AttributeNotOwned::_ex  = "AttributeNotOwned";
const char * RTI::ObjectClassNotDefined::_ex  = "ObjectClassNotDefined";
const char * RTI::InteractionParameterNotDefined::_ex  = "InteractionParameterNotDefined";
const char * RTI::InvalidResignAction::_ex  = "InvalidResignAction";
const char * RTI::TimeConstrainedWasNotEnabled::_ex  = "TimeConstrainedWasNotEnabled";
const char * RTI::ConcurrentAccessAttempted::_ex  = "ConcurrentAccessAttempted";
const char * RTI::FederateOwnsAttributes::_ex  = "FederateOwnsAttributes";
const char * RTI::FederateLoggingServiceCalls::_ex  = "FederateLoggingServiceCalls";
const char * RTI::InteractionClassNotSubscribed::_ex  = "InteractionClassNotSubscribed";
const char * RTI::CouldNotOpenFED::_ex  = "CouldNotOpenFED";
const char * RTI::FederateNotExecutionMember::_ex  = "FederateNotExecutionMember";
const char * RTI::EnableTimeRegulationPending::_ex  = "EnableTimeRegulationPending";
const char * RTI::ObjectClassNotSubscribed::_ex  = "ObjectClassNotSubscribed";
const char * RTI::RestoreInProgress::_ex  = "RestoreInProgress";
const char * RTI::FederateAlreadyExecutionMember::_ex  = "FederateAlreadyExecutionMember";
const char * RTI::TimeRegulationWasNotEnabled::_ex  = "TimeRegulationWasNotEnabled";
const char * RTI::FederationTimeAlreadyPassed::_ex  = "FederationTimeAlreadyPassed";
const char * RTI::InvalidLookahead::_ex  = "InvalidLookahead";

RTI::Exception::Exception (const char *reason)
{
   _reason = new char[strlen(reason)];
   strncpy(_reason,reason,strlen(reason));
   
}

RTI::Exception::Exception (RTI::ULong serial, const char *reason)
{
   _reason = new char[strlen(reason)];
   strncpy(_reason,reason,strlen(reason));
   _serial = serial;
}

RTI::Exception::Exception (const RTI::Exception &toCopy)
{
  _serial = toCopy._serial;
  _reason = toCopy._reason;
  _name   = toCopy._name;

}

RTI::Exception::~Exception (){}

RTI::Exception& 
RTI::Exception::operator = (const RTI::Exception &toCopy)
{
  _serial = toCopy._serial;
  _reason = toCopy._reason;
  _name   = toCopy._name;

  return (*this);
  
}

ostream& operator<< (ostream &os, RTI::Exception *RHS)
{
   os << RHS->_reason << endl;
   return os;
}

ostream& operator<< (ostream &os, RTI::Exception &RHS)
{
   os << RHS._reason << endl;

   return os;
}

