
#ifndef _FEDTIMEIMPL_H_
#define _FEDTIMEIMPL_H_

#ifndef _RTI_HH
#define _RTI_HH
#include <RTI.hh>
#endif

class FedTimeImpl : public RTI::FedTime 
{

private :
   double tm;
   double epss;

public:

  FedTimeImpl(double t) ;

  FedTimeImpl() ;

  ~FedTimeImpl();

  void setZero() ;

  RTI::Boolean isZero() ;
  
  void setEpsilon() 
   ;

  void setPositiveInfinity() 
  ;

  RTI::Boolean isPositiveInfinity() 
  ;
  
  RTI::FedTime& operator+= (const RTI::FedTime& RHS)
    throw ( RTI::InvalidFederationTime) 
  ;

  RTI::FedTime& operator-= (const RTI::FedTime& RHS)
    throw ( RTI::InvalidFederationTime) 
  ;
  
  RTI::Boolean operator<= (const RTI::FedTime& RHS) const
    throw ( RTI::InvalidFederationTime) 
  ;

  RTI::Boolean operator< (const RTI::FedTime& RHS) const
    throw ( RTI::InvalidFederationTime) 
  ;

  RTI::Boolean operator>= (const RTI::FedTime& RHS) const
    throw ( RTI::InvalidFederationTime) 
  ;
  
  RTI::Boolean operator> (const RTI::FedTime& RHS) const
    throw ( RTI::InvalidFederationTime) 
  ;

  RTI::Boolean operator== (const RTI::FedTime& RHS) const
    throw ( RTI::InvalidFederationTime) 
  ;
  
  RTI::FedTime& operator= (const RTI::FedTime& RHS)
    throw ( RTI::InvalidFederationTime) 
   ;

  //return bytes needed to encode
  int encodedLength() const  ;
  
  //encode into suppled buffer
  void encode(char *buff) const ;
  
  int getPrintableLength() const;

  void getPrintableString(char*) ;
  
};

#endif
