
#include <FederateHandleSetImpl.h>


  FederateHandleSetImpl::FederateHandleSetImpl(RTI::ULong count) 
  {
     _size = count;
     number_of_elements = 0;
     eles = new RTI::FederateHandle[_size];
  };

  RTI::ULong FederateHandleSetImpl::size() const { return number_of_elements; };

  RTI::FederateHandle 
  FederateHandleSetImpl::getHandle(RTI::ULong i) const throw ( RTI::ArrayIndexOutOfBounds) 
  { return getElementAt(i); };
  
  void FederateHandleSetImpl::add(RTI::FederateHandle h) throw ( RTI::ValueCountExceeded) 
  { put(h); };
  
  void FederateHandleSetImpl::remove(RTI::FederateHandle h) throw ( RTI::ArrayIndexOutOfBounds) 
  { 
     RTI::ULong index;
     if(findIndexOf(h,&index)) rmAt(index);
  };
  
  // Empty the set without deallocating space.
  void FederateHandleSetImpl::empty() { freeUpElements(); }; 

  RTI::Boolean FederateHandleSetImpl::isMember(RTI::FederateHandle h) const
  { 
     RTI::ULong val;
     return (findIndexOf(h,&val)?RTI::RTI_TRUE:RTI::RTI_FALSE); 
  };



RTI::FederateHandle
FederateHandleSetImpl::getElementAt( RTI::ULong index) const
    throw ( RTI::ArrayIndexOutOfBounds)
{
     if(index<0 || index > (_size-1) )
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
     return eles[index];
}

void FederateHandleSetImpl::put(RTI::FederateHandle _newele)
    throw (RTI::ArrayIndexOutOfBounds)
{
   if(number_of_elements>(_size-1))
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
   eles[number_of_elements] = _newele;
   number_of_elements++;

};//


void FederateHandleSetImpl::rmAt(RTI::ULong index)
     throw (RTI::ArrayIndexOutOfBounds)

{
   if(index<0 || index > (_size-1))
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
   for(RTI::ULong i=index;i<_size-1;i++) eles[i] = eles[i+1];
   number_of_elements--;
};//


void FederateHandleSetImpl::freeUpElements()
{ number_of_elements = 0; };

FederateHandleSetImpl::findIndexOf(RTI::FederateHandle _sele, RTI::ULong
*index) const
{
   int found = 0;
   RTI::ULong i=0;
   int j;
   while(!found && i<_size)
   {
      found = ( _sele == eles[i]) ;
      if(!found) i++;
   }// end of while
   *index = i;

   return found;

};//



