
#ifndef _FederateHandleSetImpl_H
#define _FederateHandleSetImpl_H

#ifndef _RTI_HH_
#define _RTI_HH_
#include <RTI.hh>
#endif

class FederateHandleSetImpl : public RTI::FederateHandleSet 
{

private:
  RTI::ULong _size;
  RTI::ULong number_of_elements;
  RTI::FederateHandle *eles;

public:
  FederateHandleSetImpl(RTI::ULong count) ;

  RTI::ULong size() const ;

  RTI::FederateHandle 
  getHandle(RTI::ULong i) const throw ( RTI::ArrayIndexOutOfBounds) ;
  
  void add(RTI::FederateHandle h) throw ( RTI::ValueCountExceeded); 
  
  void remove(RTI::FederateHandle h) throw ( RTI::ArrayIndexOutOfBounds) ;
  
  // Empty the set without deallocating space.
  void empty() ;

  RTI::Boolean isMember(RTI::FederateHandle h) const;

   void freeUpElements();
   findIndexOf(RTI::AttributeHandle _sele, RTI::ULong *index) const;
   void rmAt(RTI::ULong index) throw (RTI::ArrayIndexOutOfBounds);
   void put(RTI::FederateHandle _newele) throw (RTI::ArrayIndexOutOfBounds);
   RTI::FederateHandle getElementAt( RTI::ULong index) const
    throw ( RTI::ArrayIndexOutOfBounds);




};

#endif
