

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>

#if defined(__WIN32__)

#include <winsock.h>
#include <sys/types.h>

#define WSVERS             MAKEWORD(2,0)
#define MY_SOCKET          SOCKET
#define RC_INADDR_NONE     INADDR_NONE
#define RC_INVALID_SOCKET  INVALID_SOCKET
#define RC_SOCKET_ERROR    SOCKET_ERROR
#define INETSOCKET         PF_INET
#define CLOSESOCKET(sock)  closesocket(sock)
#define SHUTDOWNSOCKET(sock) ::shutdown(sock,2)
#else

#define MY_SOCKET          int
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/sem.h>
#include <netinet/in.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <ctype.h>
#include <time.h>
#include <curses.h>

#include <unistd.h>
#include <strings.h>

#include <arpa/inet.h>
#include <netdb.h>

#define RC_INADDR_NONE     (-1)
#define RC_INVALID_SOCKET  (-1)
#define RC_SOCKET_ERROR    (-1)
#define INETSOCKET         AF_INET
#define CLOSESOCKET(sock)   close(sock)
#if defined(__sunsos__) && defined(__sparc__) && __OSVERSION__ >= 5
#define SHUTDOWNSOCKET(sock)  ::shutdown(sock,2)
#elif defined(__osf1__) && defined(__alpha__)
#define SHUTDOWNSOCKET(sock)  ::shutdown(sock,2)
#else
  // XXX none of the above, calling shutdown() may not have the
  // desired effect. //
#define SHUTDOWNSOCKET(sock)  ::shutdown(sock,2)
#endif
#endif

#include <sys/types.h>
#include <errno.h>

#define URL      2
#define NEXT     3
#define ADD_ADDR 4

extern int errno;
struct timeval timeout={500,0};


typedef struct head_info
{
  struct date
  {
    int day;
    int mon;
    int year;
  } date,ltime;
  char   encoding[80];
  long   length;
  char	 ctype[80];
  int	 code;
  int   nr_html,nr_refs,nr_imgs,is_form;
  char	title[255],subject[512];
} head_info;

struct sellist
{
  int fdsmask[1];
};

#define error(str) \
{\
   cerr << str << endl; \
   if(SHUTDOWNSOCKET(sock)!=0) cout << "ERROR SHUT SOCKET" << endl; \
   if(CLOSESOCKET(sock)!=0) cout <<"ERROR CLOSING SOCK" << endl; \
   return 0; \
}

#define errDisp(str) \
{\
  cout << str << endl; \
  exit(1);\
}
     
static char header[4096];
static int semid, msgid, msgida;
static char rtd_filename[]="/home/T11D/tapulika/think/final_projs/gather/tmp/urls.tmp";
static long key=989690581l;


#include "Locator.h"
#include "HostPort.h"

/**
*/
Locator::Locator() 
{ 
  strncpy(fileName,DEFAULT_FILE_NAME,255); 
  hosts=NULL;
  index=0;
  flag=1;

}// end of Locator()

/**
*/
Locator::Locator(const char* nFName) 
{ 
  if(nFName!=NULL) strncpy(fileName,nFName,255); 
  else strncpy(fileName,DEFAULT_FILE_NAME,255); 
  hosts=NULL;
  index=0;
  flag=1;

}// end of Locator()

/**
*/
Locator::~Locator() 
{ 
   if(index)
   {
      for(int i=0;i<index;i++) delete hosts[i];
      delete[] hosts;

   }// end of if

}// end of Locator()

/**
*/
Locator::getIOR(char* rIOR)
{
   int found = 0;

   if(flag) readHosts();
    
   int i=0;
   
   while(i<index&&!found)
   {
      if(hosts[i]!=NULL)
      {
         char header[400];
         struct url_str myUrl;
         strcpy(myUrl.path,"/servlet/naming?cmd=getIOR&IDL=IDL:npacrti/RTIKernelInterface:1.0");
         strcpy(myUrl.host,hosts[i]->toString());

         found = get_IOR(&myUrl,header,rIOR);

      }// end of if

      i++;

   }// end of while

   return found;

}// end of getIOR()

/**
*/
void Locator::readHosts()
{
   char h_name[600];
   int  h_port;
   int capacity = 10;

   ifstream in(fileName);

   hosts = new HostPort*[capacity];

   if(in!=NULL)
   while(!in.eof())
   {
      in >> h_name >> h_port;

      if(!in.eof())
      {
         if(index>=capacity) 
         {
             HostPort **Temp = new HostPort*[2*capacity];
             for(int i=0;i<capacity;i++) Temp[i] = hosts[i];
             if(capacity) delete[] hosts;
             hosts = Temp;
             capacity *= 2;

         }// end of if

         hosts[index++] = new HostPort(h_name,h_port); 
         
      }// end of if

   }// end of while()
   else cout << " file["<<fileName<<"] does not exists " << endl;

   in.close();

   flag = 0;

}// end of readHosts()

#ifndef __WIN32__

int Locator::get_IOR(struct url_str *url, char* header, char *IOR)
{
  char  prot[10], host[60], path[255], *tmp, *point;
  char  qstring[530];
  int   sock,length,port=80,urllen,i,fl,tim=0;
  struct sockaddr_in server;
  struct hostent     *hp;
  enum rd_st {HEADER,BODY} rd_st=HEADER;
  struct sellist rsl,wsl,esl;
  int retval, len=0;

  /*zero_buffer();*/
  strcpy(prot,url->prot);
  strcpy(host,url->host);
  strcpy(path,url->path);
  if((tmp = strchr(host , ':'))!=NULL)
  {
    *tmp++=0;			/* read port here if given	    */
    port=atoi(tmp);		/* otherwise assume 80		    */
  }
  /*printf("\n host: %s\n",host);*/

  sock=socket(INETSOCKET,SOCK_STREAM,PF_NS);	/* create a socket  */
  if (sock<0) error("Couldn't create socket");  
  server.sin_family = INETSOCKET;			/* create server    */
  /*server.sin_len = sizeof(server);		/ * structure	    */
  hp = gethostbyname(host);
  if (hp == NULL) error("Couldn't get hostname");
  bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
  server.sin_port = htons(port);
  if (connect(sock, (struct sockaddr*) &server, sizeof(server))!=0) /* connect to http      */
    error("Couldn't connect");			/* server	        */

  if(sock>4) {
    printf("%d high socket number\n",sock);
    sleep(5);
  }
  if(sock>7) exit(1);
  rsl.fdsmask[0]=0;
  wsl.fdsmask[0]=1<<sock;
  esl.fdsmask[0]=1<<sock;
  
  if(select(sock+1,(fd_set *)&rsl,(fd_set *)&wsl,(fd_set *)&esl, &timeout)<=0)
    error("Couldn't write to socket");		/* check if can write   */
  if(path[0]=='/')
    sprintf(qstring,
      "GET %s HTTP/1.1\r\nAccept: text/html\r\nUser-Agent: NPACagent \r\n\r\n",
      path);                /* make the request     */
  else 
    sprintf(qstring,
	  "GET /%s HTTP/1.1\r\nAccept: text/html\r\nUser-Agent: NPACagent \r\n\r\n",
	  path);				/* make the request     */
  if(write(sock,qstring,strlen(qstring))!=strlen(qstring))
    error("Error while writing to socket");     /* write request to sock*/

  /* get document						*/
  strcpy(header,"");

  rsl.fdsmask[0]=1<<sock;
  wsl.fdsmask[0]=0;
  esl.fdsmask[0]=1<<sock;

  do
  {
    if(select(sock+1,(fd_set*)&rsl,NULL,(fd_set*)&esl, &timeout)<=0)
      error("Can't read from socket");       /* check if ready for read */
    retval=read(sock,qstring,512);
    if(retval<0) error("Error occured when reading from socket");
    if(rd_st == HEADER)
    {
      if(strlen(header)>4096-512)
	error("Too long header");
      qstring[retval]='\0';
      strcat(header,qstring);
      /*
      if((point=strstr(header,"\n\n")) || (point=strstr(header,"\r\r")) ||
	 (point=strstr(header,"\r\n\r\n")))
      {
	*point='\0';
	if(add_to_buffer(point+2,strlen(point+2)))
	  error("Error occured buffering document");
	rd_st=BODY;
	len=retval-(point-header)+2;
      }
      */
    }
    else
    {
      /*
      if(add_to_buffer(qstring,retval)!=0)
	error("Error occured buffering document");
      len+=retval;
      */
    }
    if( retval!=0&& qstring[0]=='I'&& qstring[1]=='O'&& qstring[2]=='R'&& 
        qstring[3]==':') 
    { 
        if((tmp = strchr(qstring , '\n'))!=NULL) *tmp++=0;
        /*printf("\n<%s>",qstring); */
        strcpy(IOR,qstring); tim=1; 
    }
  }
  while(retval!=0&&!tim);
  if(SHUTDOWNSOCKET(sock)!=0) printf("ERROR SHUTDOWN SOCKET \n");
  if(CLOSESOCKET(sock)!=0) printf("ERROR CLOSING SOCKET \n");   /* closing of a socket and exiting without    */

  return tim;    	  /* error code					*/
}
#else
int Locator::get_IOR(struct url_str *url, char* header, char *IOR)
{
  char  prot[10], host[60], path[255], *tmp, *point;
  char  qstring[530];
  int   length,port=80,urllen,i,fl,tim=0;
  MY_SOCKET sock;
  struct sockaddr_in server;
  struct hostent     *hp;
  enum rd_st {HEADER,BODY} rd_st=HEADER;
  struct sellist rsl,wsl,esl;
  int retval, len=0;

  /*zero_buffer();*/
  strcpy(prot,url->prot);
  strcpy(host,url->host);
  strcpy(path,url->path);
  char *port_str;
  if((tmp = strchr(host , ':'))!=NULL)
  {
    *tmp++=0;			/* read port here if given	    */
    port=atoi(tmp);		/* otherwise assume 80		    */
  
    port_str = tmp; 
  }

 
  /*printf("\n host: %s\n",host);*/

  WSADATA  wsadata;
  struct protoent *ppe = getprotobyname("tcp");
  if(WSAStartup(WSVERS,&wsadata)!=0) error("WSAStartup Failed");

  sock=connectsock(host,port_str,"tcp");

  if (sock==RC_INVALID_SOCKET) error("1Couldn't create socket");  
  server.sin_family = INETSOCKET;			/* create server    */
  /*server.sin_len = sizeof(server);		/ * structure	    */
  hp = gethostbyname(host);
  if (hp == NULL) error("Couldn't get hostname");
  
  memcpy(hp->h_addr, &server.sin_addr, hp->h_length);

  rsl.fdsmask[0]=0;
  wsl.fdsmask[0]=1<<sock;
  esl.fdsmask[0]=1<<sock;

  if(path[0]=='/')
    sprintf(qstring,
      "GET %s HTTP/1.1\r\nAccept: text/html\r\nUser-Agent: NPACagent \r\n\r\n",
      path);                /* make the request     */
  else 
    sprintf(qstring,
	  "GET /%s HTTP/1.1\r\nAccept: text/html\r\nUser-Agent: NPACagent \r\n\r\n",
	  path);				/* make the request     */

  //if(send(sock,qstring,sizeof(qstring),0)<=0)
  //  error("1Error while writing to socket");     /* write request to sock*/
  int sz = strlen(qstring);
  int csz = 0;
  int left = sz;
  while( left > 0 ) 
  {  csz = send(sock,qstring+sz-left,left,0);
     left -= csz;
  }

  /* get document						*/
  strcpy(header,"");

  rsl.fdsmask[0]=1<<sock;
  wsl.fdsmask[0]=0;
  esl.fdsmask[0]=1<<sock;

  do
  {


    left = 512;
	int stay = 1;
	while(left > 0 && stay )
	{ 
      stay= retval = recv(sock,qstring+512-left,left,0);
	  //if(retval<0) stay=retval;
	  if(retval>0) left -= retval; 
	}
	if(stay<0) error(" receive error!");


    cout << " I received " << qstring << endl;

    cout << " retval: " << retval << endl;
    cout << " qstring " << qstring << endl;
	point = strstr(qstring,"IOR:");
	if(point!=NULL) cout << " point " << point << endl;
    else cout << " point is NULL " << endl;

    if( point != NULL )
    {   cout << " found " << endl;
        //if((tmp = strchr(qstring , '\n'))!=NULL) *tmp++=0;
        /*printf("\n<%s>",qstring); */
		char *point2 = strstr(point,"\n");
		if(point2!=NULL) point[point2-point] = '\0';
		strcpy(IOR,point); tim=1; 
		cout << point << endl;
    }

  } while(retval!=0&&!tim);
  
  if(SHUTDOWNSOCKET(sock)!=0) printf("ERROR SHUTDOWN SOCKET \n");
  if(CLOSESOCKET(sock)!=0) printf("ERROR CLOSING SOCKET \n");   /* closing of a socket and exiting without    */

  return tim;    	  /* error code					*/
}

Locator::connectsock( 
char    *host,      /* name of host to which connection is desired  */
char    *service,   /* service associated with the desired port */
char    *protocol)  /* name of protocol to use ("tcp" or "udp") */
{
    struct hostent  *phe;   /* pointer to host information entry    */
    struct servent  *pse;   /* pointer to service information entry */
    struct protoent *ppe;   /* pointer to protocol information entry*/
    struct sockaddr_in sin; /* an Internet endpoint address     */
    int s, type;    /* socket descriptor and socket type    */

    char   errBuf[1024];  
	 
    memset( (char *)&sin,0,sizeof(sin));

    sin.sin_family = AF_INET;
 
    /* Map service name to port number */
    if ( pse = getservbyname(service, protocol) )
        sin.sin_port = pse->s_port;
    else if ( (sin.sin_port = htons((u_short)atoi(service))) == 0 )
       { 
	     sprintf(errBuf,"can't get \"%s\" service entry\n", service);
	     errDisp(errBuf);    
	     //errexit("can't get \"%s\" service entry\n", service);
       }

    /* Map host name to IP address, allowing for dotted decimal */
    if ( phe = gethostbyname(host) )
        memcpy((char *)&sin.sin_addr, phe->h_addr, phe->h_length);
    else if ( (sin.sin_addr.s_addr = inet_addr(host)) == INADDR_NONE )
        { 
		  //errexit("can't get \"%s\" host entry\n", host);
		  sprintf(errBuf,"can't get \"%s\" host entry\n", host);
          errDisp(errBuf); 
		}

    /* Map protocol name to protocol number */
    if ( (ppe = getprotobyname(protocol)) == 0)
	{
        //errexit("can't get \"%s\" protocol entry\n", protocol);
        sprintf(errBuf,"can't get \"%s\" protocol entry\n", protocol);
	    errDisp(errBuf);
	}
		
    /* Use protocol to choose a socket type */
    if (strcmp(protocol, "udp") == 0)
        type = SOCK_DGRAM;
    else
        type = SOCK_STREAM;
 
    /* Allocate a socket */
    s = socket(PF_INET, type, ppe->p_proto);
    if (s == INVALID_SOCKET)
    {    //errexit("can't create socket: %s\n", sys_errlist[errno]);
        sprintf(errBuf,"can't create socket: %s\n", sys_errlist[errno]);
	    errDisp(errBuf); 
	}
		
    /* Connect the socket */
    if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) == RC_SOCKET_ERROR )
    {    //errexit("can't connect to %s.%s: %s\n", host, service,
        //    sys_errlist[errno]);
        sprintf(errBuf,"1 can't connect to %s.%s: %s\n", host, service,
            sys_errlist[errno]);
		errDisp(errBuf);	    
	}
	return s;
}
#endif
