/**************************************************************************/
/**************************************************************************/
#include <ParameterHandleValuePairSetImpl.h>

/**************************************************************************/
/**************************************************************************/

ParameterHandleValuePairSetImpl::ParameterHandleValuePairSetImpl(RTI::ULong _sz) 
{
   //st = new mySet<ParameterHandleValuePair,RTI::ULong>(_size);
   this->_size = _sz;
   number_of_elements = 0;
   eles = new ParameterHandleValuePair[_size];
} 

/**************************************************************************/
/**************************************************************************/

ParameterHandleValuePairSetImpl::~ParameterHandleValuePairSetImpl() 
{
   delete[] eles;
}

/**************************************************************************/
/**************************************************************************/

RTI::ULong 
ParameterHandleValuePairSetImpl::size() const 
{ return number_of_elements; };

/**************************************************************************/
/**************************************************************************/
RTI::ULong 
ParameterHandleValuePairSetImpl::getValueLength( RTI::ULong i) const 
     throw ( RTI::ArrayIndexOutOfBounds) 
{ 
     ParameterHandleValuePair ret = getElementAt(i);
     return ret.size;
}
   
/**************************************************************************/
/**************************************************************************/
  
void 
ParameterHandleValuePairSetImpl::getValue( RTI::ULong i, char* buff, 
            RTI::ULong& valueLength) const
            throw ( RTI::ArrayIndexOutOfBounds) 
{
     ParameterHandleValuePair ele = getElementAt(i);
     valueLength = ele.size;
     for(int j=0;j<valueLength;j++) buff[j] = ele.buf[j];
}
   
/**************************************************************************/
/**************************************************************************/
  
char* 
ParameterHandleValuePairSetImpl::getValuePointer( RTI::ULong i, 
         RTI::ULong& valueLength) const
         throw ( RTI::ArrayIndexOutOfBounds) 
{
   ParameterHandleValuePair ret = getElementAt(i);
   return ret.buf;
}
   
/**************************************************************************/
/**************************************************************************/
  
RTI::TransportType 
ParameterHandleValuePairSetImpl::getTransportType(void) const 
     throw ( RTI::ArrayIndexOutOfBounds) 
{
   RTI::TransportType ret;
   return ret;
};
   
/**************************************************************************/
/**************************************************************************/
 
  
RTI::Handle 
ParameterHandleValuePairSetImpl::getHandle( RTI::ULong i) const 
    throw ( RTI::ArrayIndexOutOfBounds) 
{ 
     ParameterHandleValuePair ele = getElementAt(i);
     return ele.handle;
}
  
   
/**************************************************************************/
/**************************************************************************/
   
RTI::OrderType 
ParameterHandleValuePairSetImpl::getOrderType(void) const 
     throw ( RTI::ArrayIndexOutOfBounds) 
{
     RTI::OrderType ret;
     return ret;
}
   
/**************************************************************************/
/**************************************************************************/

RTI::Region* 
ParameterHandleValuePairSetImpl::getRegion(void) const 
     throw ( RTI::ArrayIndexOutOfBounds) 
{
     RTI::Region* ret;

     return ret;
}

/**************************************************************************/
/**************************************************************************/
  
void 
ParameterHandleValuePairSetImpl::add( RTI::Handle h, const char* buff, 
       RTI::ULong valueLength)
       throw ( RTI::ValueLengthExceeded, RTI::ValueCountExceeded) 
{
     ParameterHandleValuePair ele;
     ele.handle = h;
     ele.size = valueLength;
     ele.buf = new char[ele.size];
     for(int i=0;i<ele.size;i++) ele.buf[i] = buff[i];
     //ele.buf[i] = NULL;
     put(ele);

}// end of add()

/**************************************************************************/
/**************************************************************************/
  
// not guaranteed safe while iterating
void 
ParameterHandleValuePairSetImpl::remove( RTI::Handle h) 
      throw ( RTI::ArrayIndexOutOfBounds ) 
{
     int found = 0;
     ParameterHandleValuePair ele;
     for(int i=0;!found && i<_size; i++)
     {
        ele = getElementAt(i);
        if(ele.handle==h) found  = 1;

     }// end of for

     if(found) rmAt(i);
}

/**************************************************************************/
/**************************************************************************/
  
void 
ParameterHandleValuePairSetImpl::moveFrom( const RTI::ParameterHandleValuePairSet& phvps, RTI::ULong& i)
       throw ( RTI::ValueCountExceeded, RTI::ArrayIndexOutOfBounds) {};
  
  // Empty the Set without deallocating space.
  void ParameterHandleValuePairSetImpl::empty() { freeUpElements(); }; 

  RTI::ULong ParameterHandleValuePairSetImpl::start() const { return 1; };
  RTI::ULong ParameterHandleValuePairSetImpl::valid(RTI::ULong i) const { return 1; };
  RTI::ULong ParameterHandleValuePairSetImpl::next(RTI::ULong i) const { return 1; };

/**************************************************************************/
/**************************************************************************/

ParameterHandleValuePair 
ParameterHandleValuePairSetImpl::getElementAt( RTI::ULong index) const 
    throw ( RTI::ArrayIndexOutOfBounds) 
{ 
     if(index<0 || index > (_size-1) ) 
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
     return eles[index];
}

/**************************************************************************/
/**************************************************************************/
  
void ParameterHandleValuePairSetImpl::put(ParameterHandleValuePair _newele) 
     throw (RTI::ArrayIndexOutOfBounds)
{
   if(number_of_elements>(_size-1)) 
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
   eles[number_of_elements] = _newele;
   number_of_elements++;

};// 

/**************************************************************************/
/**************************************************************************/

void ParameterHandleValuePairSetImpl::rmAt(RTI::ULong index) 
     throw (RTI::ArrayIndexOutOfBounds)

{
   if(index<0 || index > (_size-1)) 
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
   for(RTI::ULong i=index;i<_size-1;i++) eles[i] = eles[i+1];
   number_of_elements--;
};// 

/**************************************************************************/
/**************************************************************************/

void ParameterHandleValuePairSetImpl::freeUpElements() 
{ number_of_elements = 0; }; 

/**************************************************************************/
/**************************************************************************/

ParameterHandleValuePairSetImpl::findIndexOf(ParameterHandleValuePair
_sele, RTI::ULong *index) const
{
   int found = 0;
   RTI::ULong i=0;
   int j;
   while(!found && i<_size)
   {
      found = ( _sele.handle == eles[i].handle ) && ( _sele.size == eles[i].size );
      if(found)
      {
        for(j=0; found && j<_sele.size;j++) 
            found = ( _sele.buf[j] == eles[i].buf[j] );
      } 
      if(!found) i++; 
   }// end of while
   *index = i;

   return found;

};// 


