#include <RTI.hh>
#include <fedtime.hh>
#include <sys/types.h>
#include <string.h>

/*
class DLL_SYMBOL RTIfedTime : public RTI::FedTime {

//-----------------------------------------------------------------
// Implementation member variables
//-----------------------------------------------------------------
private:
  RTI::Double                 _fedTime;
  RTI::Double                 _zero;
  RTI::Double                 _epsilon;
  RTI::Double                 _positiveInfinity;
};
*/

//-----------------------------------------------------------------
// Constructors and Destructors
//-----------------------------------------------------------------
RTIfedTime::RTIfedTime() 
{
  _fedTime = 0.0;
  _zero = 0.0;
  _epsilon = 0.0;
  _positiveInfinity = 0.0;
}

RTIfedTime::RTIfedTime(const RTI::Double& fedTmValue)
{
  _fedTime = fedTmValue;
  ////cout <<" _fedTime " << _fedTime << endl;
  _zero = 0.0;
  _epsilon = 0.0;
  _positiveInfinity = 0.0;
}

RTIfedTime::RTIfedTime(const RTIfedTime& RHS)
{
   _fedTime = RHS._fedTime ;
   _zero    = RHS._zero ;
   _epsilon = RHS._epsilon ; 
   _positiveInfinity =RHS._positiveInfinity ;

}// COPY CONSTRUCTOR

RTIfedTime::~RTIfedTime() { } // DESTRUCTOR

//-----------------------------------------------------------------
// Overloaded functions from RTI::FedTime
//-----------------------------------------------------------------

void                
RTIfedTime::setZero() { _zero = 0.0; }

RTI::Boolean        
RTIfedTime::isZero() { return (_zero==0.0?RTI::RTI_TRUE:RTI::RTI_FALSE); }

void RTIfedTime::setEpsilon() { }

void RTIfedTime::setPositiveInfinity() {}

RTI::Boolean RTIfedTime::isPositiveInfinity() { return RTI::RTI_FALSE; }

int RTIfedTime::encodedLength() const { return 1; }

void RTIfedTime::encode(char *buff) const
{}

int RTIfedTime::getPrintableLength() const { return 1; }

void RTIfedTime::getPrintableString(char* buff) {}

//-----------------------------------------------------------------
// Overloaded operators from RTI::FedTime
//-----------------------------------------------------------------

RTI::FedTime& RTIfedTime::operator+= (const RTI::FedTime& RHS)
    throw (RTI::InvalidFederationTime) 
{
   RTIfedTime *ret = new RTIfedTime((*this).getTime()+((RTIfedTime&)RHS).getTime());
   _fedTime = ret->getTime();
   return *ret;
}

RTI::FedTime& RTIfedTime::operator-= (const RTI::FedTime& RHS)
    throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTI::Boolean RTIfedTime::operator<= (const RTI::FedTime& RHS) const
    throw (RTI::InvalidFederationTime)
{
   return (RTI::RTI_TRUE);
}

RTI::Boolean RTIfedTime::operator< (const RTI::FedTime& RHS) const
    throw (RTI::InvalidFederationTime)
{
   return (RTI::RTI_TRUE);
}

RTI::Boolean RTIfedTime::operator>= (const RTI::FedTime& RHS) const
    throw (RTI::InvalidFederationTime)
{
   return (RTI::RTI_TRUE);
}
  
RTI::Boolean RTIfedTime::operator> (const RTI::FedTime& RHS) const
    throw (RTI::InvalidFederationTime)
{
   return (RTI::RTI_TRUE);
}

RTI::Boolean RTIfedTime::operator== (const RTI::FedTime& RHS) const
    throw (RTI::InvalidFederationTime)
{
   return (RTI::RTI_TRUE);
}
  
RTI::FedTime& RTIfedTime::operator= (const RTI::FedTime& RHS)
    throw (RTI::InvalidFederationTime)
{
   _fedTime = ((RTIfedTime&)RHS)._fedTime;
   return (*this);
}

//-----------------------------------------------------------------
// Implementation functions
//-----------------------------------------------------------------

RTI::Double         RTIfedTime::getTime() const 
{ 
   //cout << " _fedTime " << _fedTime << endl;
   return _fedTime; 
} 

//-----------------------------------------------------------------
// Implementation operators
//-----------------------------------------------------------------
RTI::FedTime& 
RTIfedTime::operator=(const RTIfedTime& RHS) throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTI::FedTime& 
RTIfedTime::operator=(const RTI::Double& RHS) throw (RTI::InvalidFederationTime)
{
   return (*this);
}

RTI::FedTime& 
RTIfedTime::operator*=(const RTI::FedTime& RHS) 
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTI::FedTime& 
RTIfedTime::operator/= (const RTI::FedTime& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTI::FedTime& 
RTIfedTime::operator+= (const RTI::Double& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTI::FedTime& 
RTIfedTime::operator-= (const RTI::Double& RHS)
            throw (RTI::InvalidFederationTime)
{
   return (*this);
}

RTI::FedTime& 
RTIfedTime::operator*= (const RTI::Double& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTI::FedTime& 
RTIfedTime::operator/= (const RTI::Double& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTIfedTime 
RTIfedTime::operator+ (const RTI::FedTime& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTIfedTime 
RTIfedTime::operator+ (const RTI::Double& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTIfedTime 
RTIfedTime::operator- (const RTI::FedTime& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTIfedTime 
RTIfedTime::operator- (const RTI::Double& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTIfedTime 
RTIfedTime::operator* (const RTI::FedTime& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTIfedTime 
RTIfedTime::operator* (const RTI::Double& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTIfedTime 
RTIfedTime::operator/ (const RTI::FedTime& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}

RTIfedTime 
RTIfedTime::operator/ (const RTI::Double& RHS)
            throw (RTI::InvalidFederationTime) 
{
   return (*this);
}
  
//-----------------------------------------------------------------
// Implementation friends
//-----------------------------------------------------------------

ostream& operator<< (ostream& os, RTI::FedTime& RHS)
{
   return os;
}

//-----------------------------------------------------------------
// Global operators
//-----------------------------------------------------------------

RTIfedTime 
operator+ (const RTI::Double& lft, const RTI::FedTime& rght)
{
   RTIfedTime ret(lft);
   return (ret+rght);
}

RTIfedTime 
operator- (const RTI::Double& lft, const RTI::FedTime& rght)
{
   RTIfedTime ret(lft);
   return (ret-rght);
}

RTIfedTime 
operator* (const RTI::Double& lft, const RTI::FedTime& rght)
{
   RTIfedTime ret(lft);
   return (ret*rght);
}

RTIfedTime 
operator/ (const RTI::Double& lft, const RTI::FedTime& rght)
{
   RTIfedTime ret(lft);
   return (ret/rght);
}

