
#ifndef _RTI_HH_
#define _RTI_HH_
#include <RTI.hh>
#endif

#include <fedtime.hh>

#include "capFederateAmbassadorImpl.h"
#include "debug.h"

/**
*/
capFederateAmbassadorImpl::capFederateAmbassadorImpl ( RTI::FederateAmbassadorPtr _ptr ) 
{ 
   int  argv = 0;
   char **args = NULL;
   appFedAmb = _ptr;
   CORBA::ORB_ptr orb = CORBA::ORB_init(argv,args,"omniORB2");
   CORBA::BOA_ptr boa = orb->BOA_init(argv,args,"omniORB2_BOA"); 
   this->_obj_is_ready(boa);
   boa->impl_is_ready(0,1);

   if(DEBUG3)
       cout << " capFederateAmbassadorImpl is ready for callbacks!! " << endl
            << " IOR : capFederateAmbassadorImpl " 
            << orb->object_to_string(this)<< endl;

}// end of CONSTRUCTOR

/**
*/
capFederateAmbassadorImpl::~capFederateAmbassadorImpl ()
{
   if(DEBUG3)
      cout << " capFederateAmbassadorImpl is deleted for callbacks!! " << endl;

}// end of DESTRUCTOR

/**
*/
RTI::AttributeHandleSet*
capFederateAmbassadorImpl::capAttributeHSetToRTI(
     const RTIcap::AttributeHandleSet& theAttributes)
{
  RTI::AttributeHandleSet *ret = 
       RTI::AttributeHandleSetFactory::create(theAttributes.length());
  for(int i=0;i<theAttributes.length();i++) ret->add(theAttributes[i]);

  return ret;

}// end of capAttributeHSetToRTI()

/**
*/
RTI::AttributeHandleValuePairSet* 
capFederateAmbassadorImpl::capAttributeHVPSToRTI ( 
     const RTIcap::AttributeHandleValuePairSet & theAttributes )
{
  int i,j;
  char *buff ;
  RTI::AttributeHandleValuePairSet *ret = 
       RTI::AttributeSetFactory::create(theAttributes.length());

  for(i=0;i<theAttributes.length();i++)
  {

      buff = new char[theAttributes[i].value.length()]; 
      for(j=0;j<theAttributes[i].value.length();j++) 
          buff[j] = theAttributes[i].value[j];
      //buff[i]=NULL;
      ret->add(theAttributes[i].handle,buff,theAttributes[i].value.length());
      delete[] buff;
      
  }// end of for

  return ret;

}// end of capAttributeHVPSToRTI()

/**
*/
RTI::ParameterHandleValuePairSet* 
capFederateAmbassadorImpl::capParameterHVPSToRTI ( 
    const RTIcap::ParameterHandleValuePairSet & theParameters)
{
  int i,j;
  char *buff ; //= new char[400];
  RTI::ParameterHandleValuePairSet *ret = 
       RTI::ParameterSetFactory::create(theParameters.length());

  for(i=0;i<theParameters.length();i++)
  {

     buff = new char[theParameters[i].value.length()];

     for(j=0;j<theParameters[i].value.length();j++) 
          buff[j] = theParameters[i].value[j];
     //buff[i] = NULL;

     ret->add(theParameters[i].handle,buff,theParameters[i].value.length());

     delete[] buff;
      
  }// end of for

  return ret;

}// end of capParameterHVPSToRTI()

/**
*/
void 
capFederateAmbassadorImpl::synchronizationPointRegistrationSucceeded( 
    const char *  theLabel )
{
   appFedAmb->synchronizationPointRegistrationSucceeded(theLabel);
}// end of synchronizationPointRegistrationSucceeded()

/**
*/
void 
capFederateAmbassadorImpl::synchronizationPointRegistrationFailed( 
    const char *  theLabel )
{
   appFedAmb->synchronizationPointRegistrationFailed(theLabel);
}// end of synchronizationPointRegistrationFailed()

/**
*/
void 
capFederateAmbassadorImpl::announceSynchronizationPoint( 
    const char *  theLabel, const char *theTag )
{
   appFedAmb->announceSynchronizationPoint(theLabel,theTag);
}// end of announceSynchronizationPoint()

/**
*/
void 
capFederateAmbassadorImpl::federationSynchronized( const char *  theLabel)
{
   appFedAmb->federationSynchronized(theLabel);
}// end of federationSynchronized()

/**
*/
void 
capFederateAmbassadorImpl::initiateFederateSave ( const char *  label ) 
{
  appFedAmb->initiateFederateSave(label);
}

/**
*/
void 
capFederateAmbassadorImpl::federationSaved ( ) 
{
   appFedAmb->federationSaved();
}// end of federationSaved()

/**
*/
void 
capFederateAmbassadorImpl::federationNotSaved ( ) 
{
   appFedAmb->federationNotSaved();
}// end of federationNotSaved()

/**
*/
void 
capFederateAmbassadorImpl::requestFederationRestoreSucceeded ( const char* theLabel ) 
{
   appFedAmb->requestFederationRestoreSucceeded(theLabel);
}// end of requestFederationRestoreSucceeded()

/**
*/
void 
capFederateAmbassadorImpl::requestFederationRestoreFailed ( const char* theLabel ) 
{
   appFedAmb->requestFederationRestoreFailed(theLabel,"UNKNOWN");
}// end of requestFederationRestoreFailed()

/**
*/
void 
capFederateAmbassadorImpl::federationRestoreBegun ( ) 
{
   appFedAmb->federationRestoreBegun();
}// end of federationRestoreBegun()

/**
*/
void 
capFederateAmbassadorImpl::initiateFederateRestore ( const char *  label ,      
    RTIcap::FederateHandle  handle ) 
{
   appFedAmb->initiateFederateRestore(label,handle);
}// end of initiateFederateRestore() 

/**
*/
void 
capFederateAmbassadorImpl::federationRestored ( ) 
{
   appFedAmb->federationRestored();
}// end of federationRestored() 

/**
*/
void 
capFederateAmbassadorImpl::startRegistrationForObjectClass ( 
    RTIcap::ObjectClassHandle  theClass ) 
{
   appFedAmb->startRegistrationForObjectClass(theClass);
}// end of startRegistrationForObjectClass() 

/**
*/
void 
capFederateAmbassadorImpl::stopRegistrationForObjectClass ( 
    RTIcap::ObjectClassHandle  theClass ) 
{
   appFedAmb->stopRegistrationForObjectClass(theClass);
}// end of stopRegistrationForObjectClass() 

/**
*/
void 
capFederateAmbassadorImpl::federationNotRestored ( ) 
{
   appFedAmb->federationNotRestored();
}// end of federationNotRestored() 

/**
*/
void 
capFederateAmbassadorImpl::startUpdates ( RTIcap::ObjectClassHandle  theClass, 
                   const RTIcap::AttributeHandleSet & theAttributes ) 
{
  if(DEBUG3)
     cout << " In capFederateAmbassadorImpl::startUpdates " << endl;

  RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(theAttributes);
  appFedAmb->turnUpdatesOnForObjectInstance(theClass,*ret);
  delete ret;

  if(DEBUG3)
     cout << " Out of capFederateAmbassadorImpl::startUpdates " << endl;

}// end of startUpdates() 

/**
*/
void 
capFederateAmbassadorImpl::turnUpdatesOnForObjectInstance ( 
    RTI::ObjectClassHandle  theClass, 
    //unsigned long theClass, 
    const RTIcap::AttributeHandleSet & theAttributes ) 
{
   if(DEBUG3)
      cout << " In capFederateAmbassadorImpl::turnUpdatesOnForObjectInstance " 
           << endl;
  RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(theAttributes);
  appFedAmb->turnUpdatesOnForObjectInstance(theClass,*ret);
  delete ret;

  if(DEBUG3)
     cout << " Out of " 
          << " capFederateAmbassadorImpl::turnUpdatesOnForObjectInstance " 
          << endl;

}// end of turnUpdatesOnForObjectInstance() 

/**
*/
void 
capFederateAmbassadorImpl::stopUpdates ( RTIcap::ObjectClassHandle  theClass, 
                       const RTIcap::AttributeHandleSet & theAttributes )
{

  RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(theAttributes);
  appFedAmb->turnUpdatesOffForObjectInstance(theClass,*ret);
  delete ret;

}// end of stopUpdates() 

/**
*/
void 
capFederateAmbassadorImpl::turnUpdatesOffForObjectInstance ( 
    RTI::ObjectClassHandle  theClass, 
    const RTIcap::AttributeHandleSet & theAttributes )
{

  RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(theAttributes);
  appFedAmb->turnUpdatesOffForObjectInstance(theClass,*ret);
  delete ret;

}// end of turnUpdatesOffForObjectInstance() 

/**
*/
void 
capFederateAmbassadorImpl::turnInteractionsOn ( RTIcap::InteractionClassHandle  theHandle )
{
  appFedAmb->turnInteractionsOn(theHandle);

}// end of startInteractionGeneration 

/**
*/
void 
capFederateAmbassadorImpl::turnInteractionsOff ( RTIcap::InteractionClassHandle  theHandle ) 
{
  appFedAmb->turnInteractionsOff(theHandle);
}// end of stopInteractionGeneration() 

/**
*/
void 
capFederateAmbassadorImpl::discoverObjectInstance ( 
     RTIcap::ObjectHandle  theObject,
     RTIcap::ObjectClassHandle  theObjectClass ) 
{

    appFedAmb->discoverObjectInstance(theObject,theObjectClass);

}// end of discoverObject() 

/**
*/
void 
capFederateAmbassadorImpl::reflectAttributeValuesWithTime ( 
     RTIcap::ObjectHandle  theObject,
     const RTIcap::AttributeHandleValuePairSet & theAttributes,
     RTIcap::FederationTime  theTime, const char *  theTag,
     const RTIcap::EventRetractionHandle & theHandle )
{

  RTI::AttributeHandleValuePairSet *attribs = capAttributeHVPSToRTI(theAttributes); 
  RTIfedTime tm(theTime);

  RTI::EventRetractionHandle evtHandle;
  evtHandle.theSerialNumber = theHandle.theSerialNumber;
  evtHandle.sendingFederate = theHandle.sendingFederate;

  appFedAmb->reflectAttributeValues(theObject,*attribs,tm,theTag,evtHandle);

  delete attribs;

}// end of reflectAttributeValues() 

/**
*/
void 
capFederateAmbassadorImpl::reflectAttributeValues( 
     RTIcap::ObjectHandle  theObject,
     const RTIcap::AttributeHandleValuePairSet & theAttributes,
     const char *  theTag)
{

  RTI::AttributeHandleValuePairSet *attribs = capAttributeHVPSToRTI(theAttributes); 
  appFedAmb->reflectAttributeValues(theObject,*attribs,theTag);
  delete attribs;

}// end of reflectAttributeValues() 

/**
*/
void 
capFederateAmbassadorImpl::receiveInteractionWithTime ( 
    RTIcap::InteractionClassHandle  theInteraction,
    const RTIcap::ParameterHandleValuePairSet & theParameters,
    RTIcap::FederationTime theTime , const char *  theTag,
    const RTIcap::EventRetractionHandle & theHandle )
{

  RTIfedTime tm(theTime);
  RTI::EventRetractionHandle evtHandle;
  evtHandle.theSerialNumber = theHandle.theSerialNumber;
  evtHandle.sendingFederate = theHandle.sendingFederate;

  RTI::ParameterHandleValuePairSet *params = capParameterHVPSToRTI(theParameters);
  appFedAmb->receiveInteraction(theInteraction,*params,tm,theTag,evtHandle);
  delete params;

}// end of receiveInteraction() 

/**
*/
void 
capFederateAmbassadorImpl::receiveInteraction( 
    RTIcap::InteractionClassHandle  theInteraction,
    const RTIcap::ParameterHandleValuePairSet & theParameters,
    const char *  theTag)
{

  RTI::ParameterHandleValuePairSet *params = capParameterHVPSToRTI(theParameters);
  appFedAmb->receiveInteraction(theInteraction,*params,theTag);
  delete params;

}// end of receiveInteraction() 

/**
*/
void 
capFederateAmbassadorImpl::removeObjectInstanceWithTime ( RTIcap::ObjectHandle  theObject, 
         RTIcap::FederationTime  theTime, const char *  theTag, 
         const RTIcap::EventRetractionHandle & theHandle) 
{

  RTIfedTime tm(theTime);

  RTI::EventRetractionHandle evtHandle;
  evtHandle.theSerialNumber = theHandle.theSerialNumber;
  evtHandle.sendingFederate = theHandle.sendingFederate;

  appFedAmb->removeObjectInstance(theObject,tm,theTag,evtHandle);

}// end of removeObjectInstanceWithTime()

/**
*/
void 
capFederateAmbassadorImpl::removeObjectInstance ( RTIcap::ObjectHandle  theObject, const char * theTag ) 
{
   appFedAmb->removeObjectInstance(theObject,theTag);
}// end of removeObjectInstance()

/**
*/
void 
capFederateAmbassadorImpl::attributesInScope ( RTIcap::ObjectHandle  theObject, 
    const RTIcap::AttributeHandleSet & theAttributes  ) 
{
   RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(theAttributes);
   appFedAmb->attributesInScope(theObject,*ret);
   delete ret;
}// end of attributesInScope()

/**
*/
void 
capFederateAmbassadorImpl::attributesOutOfScope(RTIcap::ObjectHandle theObject,
    const RTIcap::AttributeHandleSet & theAttributes  ) 
{
   RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(theAttributes);
   appFedAmb->attributesOutOfScope(theObject,*ret);
   delete ret;
}// end of attributesOutOfScope()


/**
*/
void 
capFederateAmbassadorImpl::provideAttributeValueUpdate ( RTIcap::ObjectHandle  theObject, 
                             const RTIcap::AttributeHandleSet & theAttributes ) 
{
    
  RTI::AttributeHandleSet* att = capAttributeHSetToRTI(theAttributes);
  appFedAmb->provideAttributeValueUpdate(theObject,*att);
  delete att;

}// end of provideAttributeValueUpdate() 

/**
*/
void
capFederateAmbassadorImpl::requestAttributeOwnershipAssumption ( 
         RTIcap::ObjectHandle theObject,
         const RTIcap::AttributeHandleSet & offeredAttributes,
         const char *  theTag )
{
   RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(offeredAttributes);
   appFedAmb->requestAttributeOwnershipAssumption(theObject,*ret,theTag);
   delete ret;
}// end of requestAttributeOwnershipAssumption2() 

/**
*/
void 
capFederateAmbassadorImpl::attributeOwnershipDivestitureNotification ( 
            RTIcap::ObjectHandle  theObject, 
            const RTIcap::AttributeHandleSet & releasedAttributes ) 
{
   RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(releasedAttributes);
   appFedAmb->attributeOwnershipDivestitureNotification(theObject,*ret);
   delete ret;
}// end of attributeOwnershipDivestitureNotification() 

/**
*/
void 
capFederateAmbassadorImpl::attributeOwnershipAcquisitionNotification ( 
     RTIcap::ObjectHandle  theObject, 
     const RTIcap::AttributeHandleSet & securedAttributes ) 
{
   RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(securedAttributes);
   appFedAmb->attributeOwnershipAcquisitionNotification(theObject,*ret);
   delete ret;
}// end of attributeOwnershipAcquisitionNotification() 

/**
*/
void 
capFederateAmbassadorImpl::attributeOwnershipUnavailable ( 
    RTIcap::ObjectHandle  theObject, 
    const RTIcap::AttributeHandleSet & securedAttributes ) 
{
   RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(securedAttributes);
   appFedAmb->attributeOwnershipUnavailable(theObject,*ret);
   delete ret;
}// end of attributeOwnershipUnavailable() 

/**
*/
void
capFederateAmbassadorImpl::requestAttributeOwnershipRelease ( 
      RTIcap::ObjectHandle theObject,
      const RTIcap::AttributeHandleSet & candidateAttributes,
      const char *  theTag ) 
{
   RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(candidateAttributes);
   appFedAmb->requestAttributeOwnershipRelease(theObject,*ret,theTag);
   delete ret;

}// end of requestAttributeOwnershipRelease() 

/**
*/
void
capFederateAmbassadorImpl::confirmAttributeOwnershipAcquisitionCancellation ( 
      RTIcap::ObjectHandle theObject,
      const RTIcap::AttributeHandleSet & candidateAttributes)
{
   RTI::AttributeHandleSet* ret = capAttributeHSetToRTI(candidateAttributes);
   appFedAmb->confirmAttributeOwnershipAcquisitionCancellation(theObject,*ret);
   delete ret;

}// end of confirmAttributeOwnershipAcquisitionCancellation() 

/**
*/
void 
capFederateAmbassadorImpl::informAttributeOwnership ( 
            RTIcap::ObjectHandle  theObject, 
            RTIcap::AttributeHandle  theAttribute, 
            RTIcap::FederateHandle  theOwner ) 
{
    appFedAmb->informAttributeOwnership(theObject,theAttribute,theOwner);
}// end of informAttributeOwnership() 

/**
*/
void 
capFederateAmbassadorImpl::attributeIsNotOwned( RTIcap::ObjectHandle theObject,
    RTIcap::AttributeHandle  theAttribute) 
{
    appFedAmb->attributeIsNotOwned(theObject,theAttribute);
}// end of attributeIsNotOwned() 

/**
*/
void 
capFederateAmbassadorImpl::attributeIsOwnedByRTI(RTIcap::ObjectHandle theObject,
     RTIcap::AttributeHandle  theAttribute) 
{
    //appFedAmb->attributeIsOwnedByRTI(theObject,theAttribute);
}// end of attributeIsOwnedByRTI() 

/**
*/
void 
capFederateAmbassadorImpl::timeAdvanceGrant ( RTIcap::FederationTime  theTime )
{
    
    //FedTime *fTime = RTI::FedTimeFactory::makeZero();

    RTI::FedTime *fTime = new RTIfedTime(theTime);

    if(DEBUG3)
       cout << " Before capFederateAmbassadorImpl::timeAdvanceGrant() " << endl;

    appFedAmb->timeAdvanceGrant(*fTime);

    delete fTime;

    if(DEBUG3)
       cout << " After capFederateAmbassadorImpl::timeAdvanceGrant() " << endl;

}// end of timeAdvanceGrant()

/**
*/
void 
capFederateAmbassadorImpl::timeRegulationEnabled ( RTIcap::FederationTime  theTime ) 
{
    if(DEBUG3)
       cout << " In timeRegulationEnabled() " << endl;

    RTI::FedTime *fTime = new RTIfedTime(theTime);
    appFedAmb->timeRegulationEnabled(*fTime);
    delete fTime;

    if(DEBUG3)
       cout << " Out of timeRegulationEnabled() " << endl;

}// end of timeRegulationEnabled()

/**
*/
void 
capFederateAmbassadorImpl::timeConstrainedEnabled ( RTIcap::FederationTime  theTime )
{
    if(DEBUG3)
       cout << " In timeConstrainedEnabled() " << endl;

    RTI::FedTime *fTime = new RTIfedTime(theTime);
    appFedAmb->timeConstrainedEnabled(*fTime);
    delete fTime;

    if(DEBUG3)
       cout << " Out of timeConstrainedEnabled() " << endl;

}// end of timeConstrainedEnabled()

/**
*/
void 
capFederateAmbassadorImpl::requestRetraction ( const RTIcap::EventRetractionHandle & theHandle ) 
{
   //appFedAmb->requestRetraction();
}// end of requestRetraction()

/**
*/
void 
capFederateAmbassadorImpl::changeThresholds ( const RTIcap::Region & theRegion,
         RTIcap::ThresholdSet & theThresholds ) 
{
}// end of changeThresholds() 


