
#ifndef _RTIambassadorImpl_h
#define _RTIambassadorImpl_h

#ifndef _RTI_HH_
#define _RTI_HH_
#include <RTI.hh>
#endif

#ifndef _RTIcap_HH_
#define _RTIcap_HH_
#include <RTIcap.hh>
#endif

#include <FedTimeImpl.h>

//typedef capFederateAmbassadorImpl *capFederateAmbassadorImplPtr;

class capFederateAmbassadorImpl : public RTIcap::_sk_FederateAmbassador
{
   private :

     RTI::FederateAmbassadorPtr appFedAmb; // Application FederateAmbassador

     RTI::ParameterHandleValuePairSet*
     capParameterHVPSToRTI ( const RTIcap::ParameterHandleValuePairSet & theParameters);

     RTI::AttributeHandleValuePairSet*
     capAttributeHVPSToRTI ( const RTIcap::AttributeHandleValuePairSet & theAttributes );

     RTI::AttributeHandleSet*
     capAttributeHSetToRTI( const RTIcap::AttributeHandleSet& theAttributes);

   public :

    capFederateAmbassadorImpl(RTI::FederateAmbassadorPtr _fed);
    ~capFederateAmbassadorImpl();

    /** FederationAbmassador Interface */

    void synchronizationPointRegistrationSucceeded ( const char *  theLabel );
    void synchronizationPointRegistrationFailed ( const char *  theLabel);
    void announceSynchronizationPoint ( const char *  theLabel, const char *  theTag );
    void federationSynchronized ( const char *  theLabel );
    void initiateFederateSave ( const char *  theLabel );

    void federationSaved (  );

    void federationNotSaved (  );

    void requestFederationRestoreSucceeded ( const char *  theLabel );

    void requestFederationRestoreFailed ( const char *  theLabel );

    void federationRestoreBegun (  );

    void initiateFederateRestore ( const char *  theLabel, 
         RTIcap::FederateHandle  handle ); 

    void federationRestored (  ) ;

    void federationNotRestored (  );

    void startRegistrationForObjectClass ( RTIcap::ObjectClassHandle  theClass );

    void stopRegistrationForObjectClass ( RTIcap::ObjectClassHandle  theClass );

    void turnInteractionsOn ( RTIcap::InteractionClassHandle  theHandle );

    void turnInteractionsOff ( RTIcap::InteractionClassHandle  theHandle );

    void discoverObjectInstance ( RTIcap::ObjectHandle  theObject, 
         RTIcap::ObjectClassHandle  theObjectClass ); 

    void reflectAttributeValuesWithTime ( RTIcap::ObjectHandle  theObject, 
         const RTIcap::AttributeHandleValuePairSet & theAttributes, 
         RTIcap::FederationTime  theTime, const char *  theTag, 
         const RTIcap::EventRetractionHandle & theHandle );

    void reflectAttributeValues ( RTIcap::ObjectHandle  theObject, 
         const RTIcap::AttributeHandleValuePairSet & theAttributes, 
         const char *  theTag );

    void receiveInteractionWithTime ( RTIcap::InteractionClassHandle  theInteraction, 
         const RTIcap::ParameterHandleValuePairSet & theParameters, 
         RTIcap::FederationTime theTime , const char *  theTag, 
         const RTIcap::EventRetractionHandle & theHandle );


    void receiveInteraction ( RTIcap::InteractionClassHandle theInteraction, 
         const RTIcap::ParameterHandleValuePairSet & theParameters, 
         const char *  theTag ) ;

    void removeObjectInstanceWithTime ( RTIcap::ObjectHandle  theObject,
         RTIcap::FederationTime  theTime, const char *  theTag, 
         const RTIcap::EventRetractionHandle & theHandle) ;

    void removeObjectInstance ( RTIcap::ObjectHandle  theObject, 
         const char *  theTag ) ; 

    void attributesInScope ( RTIcap::ObjectHandle  theObject, 
         const RTIcap::AttributeHandleSet & theAttributes ) ;

    void attributesOutOfScope ( RTIcap::ObjectHandle  theObject, 
         const RTIcap::AttributeHandleSet & theAttributes ) ;

    void provideAttributeValueUpdate ( RTIcap::ObjectHandle  theObject,
         const RTIcap::AttributeHandleSet & theAttributes ) ;

    void turnUpdatesOnForObjectInstance ( RTIcap::ObjectHandle  theObject,
         const RTIcap::AttributeHandleSet & theAttributes ) ;

    void turnUpdatesOffForObjectInstance ( RTIcap::ObjectHandle  theObject,
         const RTIcap::AttributeHandleSet & theAttributes ) ;

    void requestAttributeOwnershipAssumption ( RTIcap::ObjectHandle theObject,
         const RTIcap::AttributeHandleSet & offeredAttributes, 
         const char *  theTag ) ;

    void attributeOwnershipDivestitureNotification ( RTIcap::ObjectHandle theObject, 
         const RTIcap::AttributeHandleSet & releasedAttributes ) ;

    void attributeOwnershipAcquisitionNotification ( RTIcap::ObjectHandle theObject, 
         const RTIcap::AttributeHandleSet & securedAttributes ) ;

    void attributeOwnershipUnavailable ( RTIcap::ObjectHandle  theObject,
         const RTIcap::AttributeHandleSet & theAttributes ) ;

    void requestAttributeOwnershipRelease ( RTIcap::ObjectHandle theObject, 
         const RTIcap::AttributeHandleSet & candidateAttributes, 
         const char *  theTag ) ;

    void confirmAttributeOwnershipAcquisitionCancellation ( 
         RTIcap::ObjectHandle theObject, 
         const RTIcap::AttributeHandleSet & theAttributes ) ;

    void informAttributeOwnership ( RTIcap::ObjectHandle  theObject,
         RTIcap::AttributeHandle  theAttribute, 
         RTIcap::FederateHandle  theOwner ) ;

    void attributeIsNotOwned ( RTIcap::ObjectHandle  theObject,
         RTIcap::AttributeHandle theAttribute ) ;

    void attributeIsOwnedByRTI ( RTIcap::ObjectHandle  theObject,
         RTIcap::AttributeHandle  theAttribute ) ;

    void timeAdvanceGrant ( RTIcap::FederationTime  theTime ) ;

    void timeRegulationEnabled ( RTIcap::FederationTime  theTime ) ;

    void timeConstrainedEnabled ( RTIcap::FederationTime  theTime ) ;

    void requestRetraction ( const RTIcap::EventRetractionHandle & theHandle ) ;

    void changeThresholds ( const RTIcap::Region & theRegion, 
         RTIcap::ThresholdSet & theThresholds ) ;

    void 
    startUpdates ( RTIcap::ObjectClassHandle  theClass, 
                   const RTIcap::AttributeHandleSet & theAttributes ) ;

    void stopUpdates ( RTIcap::ObjectClassHandle  theClass, 
                       const RTIcap::AttributeHandleSet & theAttributes ) ;

    /**
    void initiatePause ( const char *  label ) ;

    void initiateResume (  ) ;

    void initiateFederateSave1 ( const char *  label ) ;

    void initiateFederateSave2 ( const char *  label, RTIcap::FederationTime  theTime ) ;
    void initiateRestore ( const char *  label ) ;

    void 
    startUpdates ( RTIcap::ObjectClassHandle  theClass, 
                   const RTIcap::AttributeHandleSet & theAttributes ) ;

    void stopUpdates ( RTIcap::ObjectClassHandle  theClass, 
                       const RTIcap::AttributeHandleSet & theAttributes ) ;

    void startInteractionGeneration ( RTIcap::InteractionClassHandle  theHandle ) ;

    void stopInteractionGeneration ( RTIcap::InteractionClassHandle  theHandle ) ;

    void 
    discoverObject ( RTIcap::ObjectID  theObject, RTIcap::ObjectClassHandle  theObjectClass, 
                     RTIcap::FederationTime  theTime, const char *  theTag, 
                     const RTIcap::EventRetractionHandle & theHandle ) ;

    void 
    reflectAttributeValues ( RTIcap::ObjectID  theObject, 
                             const RTIcap::AttributeHandleValuePairSet & theAttributes, 
                             RTIcap::FederationTime  theTime, const char *  theTag, 
                             const RTIcap::EventRetractionHandle & theHandle ) ;

    void 
    receiveInteraction ( RTIcap::InteractionClassHandle  theInteraction, 
                         const RTIcap::ParameterHandleValuePairSet & theParameters, 
                         RTIcap::FederationTime  theTime, const char *  theTag, 
                         const RTIcap::EventRetractionHandle & theHandle ) ;

    void removeObject1 ( RTIcap::ObjectID  theObject, RTIcap::ObjectRemovalReason  theReason, 
                         RTIcap::FederationTime  theTime, const char *  theTag, 
                         const RTIcap::EventRetractionHandle & theHandle ) ;

    void removeObject2 ( RTIcap::ObjectID  theObject, RTIcap::ObjectRemovalReason  theReason ) ;

    void removeObjectInstanceWithTime ( RTIcap::ObjectID  theObject, 
         RTIcap::FederationTime  theTime, const char *  theTag, 
         const RTIcap::EventRetractionHandle & theHandle) ;

    void removeObjectInstance ( RTIcap::ObjectID  theObject, const char * theTag ) ;

    void 
    provideAttributeValueUpdate ( RTIcap::ObjectID  theObject, 
                                  const RTIcap::AttributeHandleSet & theAttributes ) ;

    void reflectRetraction ( const RTIcap::EventRetractionHandle & theHandle ) ;

    RTIcap::AttributeHandleSet * 
    requestAttributeOwnershipAssumption1 ( RTIcap::ObjectID  theObject, 
                              const RTIcap::AttributeHandleSet & offeredAttributes, 
                              const char *  theTag ) ;

    RTIcap::AttributeHandleSet * 
    requestAttributeOwnershipAssumption2 ( RTIcap::ObjectID  theObject, 
                              const RTIcap::AttributeHandleSet & offeredAttributes ) ;

    void 
    attributeOwnershipDivestitureNotification ( RTIcap::ObjectID  theObject, 
                              const RTIcap::AttributeHandleSet & releasedAttributes ) ;

    void 
    attributeOwnershipAcquisitionNotification ( RTIcap::ObjectID  theObject, 
                              const RTIcap::AttributeHandleSet & securedAttributes ) ;

    RTIcap::AttributeHandleSet * 
    requestAttributeOwnershipRelease ( RTIcap::ObjectID  theObject, 
                              const RTIcap::AttributeHandleSet & candidateAttributes, 
                              const char *  theTag ) ;

    void 
    informAttributeOwnership ( RTIcap::ObjectID  theObject, 
                               RTIcap::AttributeHandle  theAttribute, 
                               RTIcap::FederateHandle  theOwner ) ;

    void timeAdvanceGrant ( RTIcap::FederationTime  theTime ) ;

    void timeRegulationEnabled ( RTIcap::FederationTime  theTime ) ;

    void timeConstrainedEnabled ( RTIcap::FederationTime  theTime ) ;

    void requestRetraction ( const RTIcap::EventRetractionHandle & theHandle ) ;

    void changeThresholds ( RTIcap::Region  theRegion, RTIcap::ThresholdSet & theThresholds ) ;
    */

};// end of create()

#endif
