//
// Timucin, This objects are written to mapping between C++ RTI objects and
// RTIcap objects.
//
#ifndef _C++_TO_CORBA_H
#define _C++_TO_CORBA_H

template<class T1, class T2>
class mySet
{
   protected :
     T2 size;
     T2 number_of_elements;
     T1 *eles;

     findIndexOf<T1,T2>(T1 _sele, T2* index) 
     {
        int found = 0;
        T2 i=0;
        while(!found && i<size)
        {
          found = ( _sele == eles[i] );
          if(!found) i++; 
        }// end of while
        *index = i;

        return found;

     };// 

   public:

     mySet<T1,T2>(T2 _size)
     {
        size = _size;
        number_of_elements = (T2) 0;
        if(size>0) eles = new T1[size]; 
     };// end of CONSTRUCTOR

     ~mySet<T1,T2>() 
     { if(size>0) delete[] eles; };

     T2 getSize<T1,T2>() const { return number_of_elements; } ;

     T1 getElementAt<T1,T2>(T2 index) throw (ArrayIndexOutOfBounds)
     {
        if(index<0 || index > (size-1) ) throws new ArrayIndexOutOfBounds();
        return eles[index];
     };   

     void put<T1,T2>(T1 _newele) throw (ArrayIndexOutOfBounds)
     {
        if(number_of_elements>(size-1)) throws new ArrayIndexOutOfBounds();
        eles[number_of_elements] = _newele;
        number_of_elements++;
     };// 

     void rm<T1,T2>(T1 _sele) 
     {
        T2 index;
        if(findIndexOf(_sele,&index)) rmAt(index);
     };// 

     void rmAt<T1,T2>(T2 index) throw (ArrayIndexOutOfBounds)
     {
        if(index<0 || index > (size-1)) throws new ArrayIndexOutOfBounds();
        for(T2 i=index;i<size-1;i++) eles[i] = eles[i+1];
        number_of_elements--;
     };// 

     void freeUpElements<T1,T2>() { number_of_elements = 0; }; 

};// end of mySet

#include <RTIcap.hh>

// typedef HandleValuePairSet AttributeHandleValuePairSet;

class AttributeHandleValuePairSet 
{

// Instances of class HandleValuePairSet are the containers used to pass
// object attribute values and interaction parameter values between the
// Fedrate and the RTI.  These containers hold sets of attribute/parameter
// values indexed by their attribute/parameter handle.  Instances of this
// class are provided to the RTI in the Update Attribute Values and Send
// Interaction service invocations.  Instances of this class are provided
// to the Federate in the Reflect Attribute Values and Receive Interaction
// service invocations.  When instances of HandleValuePairSet are provided
// to the Federate by the RTI, the memory used to store attribute/parameter
// values is valid for use by the federate only within the scope of the
// Reflect Attribute Values or Receive Interaction service invocation.
// Symmetrically, for instances of HandleValuePairSet provided by the Federate
// to the RTI, the memory used to store attribute/parameter values is valid for
// use by the RTI only within the scope of the Update Attribute Values or Send
// Interaction service invocation.  

private:
  RTIcap::ULong size;
  RTIcap::ULong number_of_elements;
  AttributeHandleValuePair* pairs;
     

public:

  AttributeHandleValuePairSet(RTIcap::AttributeHandleValuePair* _pairs, RTIcap::ULong _size) 
  {
     size = (_size>0?_size:0);
     if(size)
     { 
        pairs = new AttributeHandleValuePair[_size];
        for(int i=0;i<size;i++) pairs[i] = _pairs[i];
        number_of_elements = size;

     }// end of if

  }// end of CONSTRUCTOR

  ~AttributeHandleValuePairSet() 
   { if(size>0) delete[] pairs; }

  RTIcap::ULong size() const { return size; };
  
  RTIcap::Handle getHandle( RTI::ULong i) throw ( ArrayIndexOutOfBounds) 
  {
    if(i<0 && i>=size) throw new ArrayIndexOutOfBounds();
    return pairs[i].handle;
  };

  RTIcap::ULong getValueLength( RTI::ULong i) const 
                throw ( ArrayIndexOutOfBounds) 
  {
    if(i<0 && i>=size) throw new ArrayIndexOutOfBounds();
    return pairs[i].value.size();

  };
  
  /** 
  * Get the CORBA::UnboundedSequence and put the values in char array.
  */
  void getValue( RTI::ULong i, char* buff, RTIcap::ULong& valueLength) const
       throw ( ArrayIndexOutOfBounds) 
  {
    if(i<0 && i>=size) throw new ArrayIndexOutOfBounds();
    
    
  };
  
  char *getValuePointer( RTI::ULong i, ULong&  valueLength) const
       throw ( ArrayIndexOutOfBounds) {};
  {
    if(i<0 && i>=size) throw new ArrayIndexOutOfBounds();

  }// end of getValuePointer()
  
//   virtual RTI::TransportType getTransportType(
//     RTI::ULong i) const
//     throw (
//       ArrayIndexOutOfBounds) = 0;
//   
//   virtual RTI::OrderType getOrderType(
//     RTI::ULong i) const
//     throw (
//       ArrayIndexOutOfBounds) = 0;
//   
//   virtual RTI::Region getRegion(
//     RTI::ULong i) const
//     throw (
//       ArrayIndexOutOfBounds) = 0;
  
  void add( Handle h, const char* buff, ULong valueLength)
       throw ( ValueLengthExceeded, ValueCountExceeded) {};
  {
  };// end of add
  
  // not guaranteed safe while iterating
  void remove( Handle h) throw ( ArrayIndexOutOfBounds) 
  {
  };// end of remove
  
  void moveFrom(const AttributeHandleValuePairSet& ahvps, RTI::ULong& i)
       throw ( ValueCountExceeded, ArrayIndexOutOfBounds) 
  {
  };
  
  // Empty the Set without deallocating space.
  void empty() 
  {
     number_of_elements = 0;

  }; 

  inline RTI::ULong start() {};
  inline RTI::ULong valid(RTI::ULong i) {};
  inline RTI::ULong next(RTI::ULong i) {};

};


class AttributeSetFactory {
public:
  static AttributeHandleValuePairSet* create( RTIcap::ULong count)
         throw ( MemoryExhausted, ValueCountExceeded, HandleValuePairMaximumExceeded)
  {
     return new AttributeHandleValuePairSet(count);
  }; 
};

class AttributeHandleSet : public mySet<RTIcap::AttributeHandle,RTIcap::ULong> 
{

public:

  AttributeHandleSet(RTIcap::ULong _size) : 
        mySet<RTIcap::AttributeHandle,RTIcap::ULong>(_size) {};

  RTIcap::ULong size() const { return getSize();};

  RTIcap::AttributeHandle 
  getHandle(ULong i) const throw ( ArrayIndexOutOfBounds) 
  { return getElementAt(i); };
  
  void add(RTIcap::AttributeHandle h) throw ( ArrayIndexOutOfBounds) 
  { put(h); };

  // not guaranteed safe while iterating
  void remove(RTIcap::AttributeHandle h) throw ( RTIcap::AttributeNotDefined) 
  { rm(h); };
  
  // Empty the Set
  void empty() {  freeUpElements(); }; 

  //is set empty?
  RTIcap::Boolean isEmpty() const 
  { return (getSize()==0?RTIcap::RTI_TRUE:RTIcap::RTI_FALSE); };  

  //is set empty?
  RTIcap::Boolean isMember(AttributeHandle h) const 
  { return (findIndexOf(h)==1?RTIcap::RTI_TRUE:RTIcap::RTI_FALSE); };

//  AttributeHandleSet setUnion(const AttributeHandleSet &) const;
//  AttributeHandleSet setIntersection(const AttributeHandleSet &) const;
//  AttributeHandleSet removeSetIntersection(const AttributeHandleSet &) const;

};


/** 
*  Defines an AttributeHandleSet objects.
*/
class AttributeHandleSetFactory {

public:

  static AttributeHandleSet* create( RTIcap::ULong count) 
         throw( MemoryExhausted, ValueCountExceeded) 
  {
     return new AttributeHandleSet(count);

  };// end of create()

};

class FederateHandleSet : public mySet<RTIcap::FederateHandle,RTIcap::ULong> {
public:
  FederateHandleSet(RTIcap::ULong count) :
       mySet<RTIcap::FederateHandle,RTIcap::ULong>(count) {};

  RTIcap::ULong size() const { return getSize(); };

  RTIcap::FederateHandle 
  getHandle(RTIcap::ULong i) const throw ( ArrayIndexOutOfBounds) 
  { return getElementAt(i); };
  
  void add(RTIcap::FederateHandle h) throw ( ValueCountExceeded) 
  { put(h); };
  
  void remove(RTIcap::FederateHandle h) throw ( ArrayIndexOutOfBounds) 
  { rm(h); };
  
  // Empty the set without deallocating space.
  void empty() { freeUpElements() }; 

};


class FederateHandleSetFactory {
public:
  static FederateHandleSet* create(RTIcap::ULong count) 
         throw ( MemoryExhausted, ValueCountExceeded)
  { return FederateHandleSet(count); };
};

struct EventRetractionHandle_s {
  FederationTime  theEventTime;
  UniqueID        theSerialNumber;
  FederateHandle  sendingFederate;
};

typedef struct EventRetractionHandle_s EventRetractionHandle;


// typedef HandleValuePairSet ParameterHandleValuePairSet;

class ParameterHandleValuePairSet : 
      public mySet<RTIcap::ParameterHandleValuePair,RTIcap::ULong> 
{

// Instances of class HandleValuePairSet are the containers used to pass
// object attribute values and interaction parameter values between the
// Fedrate and the RTI.  These containers hold sets of attribute/parameter
// values indexed by their attribute/parameter handle.  Instances of this
// class are provided to the RTI in the Update Attribute Values and Send
// Interaction service invocations.  Instances of this class are provided
// to the Federate in the Reflect Attribute Values and Receive Interaction
// service invocations.  When instances of HandleValuePairSet are provided
// to the Federate by the RTI, the memory used to store attribute/parameter
// values is valid for use by the federate only within the scope of the
// Reflect Attribute Values or Receive Interaction service invocation.
// Symmetrically, for instances of HandleValuePairSet provided by the Federate
// to the RTI, the memory used to store attribute/parameter values is valid for
// use by the RTI only within the scope of the Update Attribute Values or Send
// Interaction service invocation.  

private:

public:

  ParameterHandleValuePairSet(RTIcap::ULong _size) : 
     mySet<RTIcap::ParameterHandleValuePair,RTIcap::ULong>(_size) {}; 

  RTIcap::ULong size() const { return getSize(); };
  
  RTIcap::Handle getHandle( RTI::ULong i) const throw ( ArrayIndexOutOfBounds) 
  { 
     RTIcap::ParameterHandleValuePair ele = getElementAt(i);
     return ele.handle;
  };
  
  RTIcap::ULong 
  getValueLength( RTI::ULong i) const throw ( ArrayIndexOutOfBounds) 
  { 
     RTIcap::ParameterHandleValuePair ret = getElementAt(i);
     return ret.value.size();
  };
  
  void 
  getValue( RTI::ULong i, char* buff, RTIcap::ULong& valueLength) const
            throw ( ArrayIndexOutOfBounds) 
  {
     RTIcap::ParameterHandleValuePair ele = getElementAt(i);
     for(int i=0;i<ele.value.size();i++) ((CORBA::Long*)buf)[i] = ele.value[i];
     valueLength = ele.value.size() * sizeof(CORBA::Long);
  };
  
  char * getValuePointer( RTI::ULong i, RTIcap::ULong& valueLength) const
         throw ( ArrayIndexOutOfBounds) 
  {
     RTIcap::ParameterHandleValuePair ele = getElementAt(i);
     char *buf = new char[ele.value.size() * sizeof(CORBA::Long)];
     getValue(i,buf,valueLength);
     return buf;
  };
  
//   virtual RTI::TransportType getTransportType(void)
//     throw (
//       ArrayIndexOutOfBounds) = 0;
//   
//   virtual RTI::OrderType getOrderType(void)
//     throw (
//       ArrayIndexOutOfBounds) = 0;
//   
//   virtual RTI::Region getRegion(void)
//     throw (
//       ArrayIndexOutOfBounds) = 0;
  
  void add( RTIcap::Handle h, const char* buff, RTIcap::ULong valueLength)
       throw ( ValueLengthExceeded, ValueCountExceeded) 
  {
       
  };
  
  // not guaranteed safe while iterating
  void remove( RTIcap::Handle h) throw ( ArrayIndexOutOfBounds ) {};
  
  void moveFrom( const RTIcap::ParameterHandleValuePairSet& phvps, RTI::ULong& i)
       throw ( ValueCountExceeded, ArrayIndexOutOfBounds) {};
  
  void empty() {}; // Empty the Set without deallocating space.

  inline RTI::ULong start() const {};
  inline RTI::ULong valid(RTI::ULong i) const {};
  inline RTI::ULong next(RTI::ULong i) const {};

};


class ParameterSetFactory {
public:
  static ParameterHandleValuePairSet* create(RTIcap::ULong count)
         throw ( MemoryExhausted, ValueCountExceeded, HandleValuePairMaximumExceeded);
  {
      return new ParameterHandleValuePairSet(count);
  };// end of create()
};

class Region {
public:

  ~Region();
  
  RTIcap::ULong getRangeLowerBound( RTIcap::ExtentIndex theExtent, RTIcap::DimensionHandle theDimension) const
        throw ( ArrayIndexOutOfBounds) {};

  RTIcap::ULong getRangeUpperBound( RTIcap::ExtentIndex theExtent, RTIcap::DimensionHandle theDimension) const
        throw ( ArrayIndexOutOfBounds) {};

  void setRangeLowerBound( RTIcap::ExtentIndex theExtent, RTIcap::DimensionHandle theDimension,
                           RTIcap::ULong theLowerBound)
       throw ( ArrayIndexOutOfBounds) {};

  void setRangeUpperBound( RTIcap::ExtentIndex theExtent, RTIcap::DimensionHandle theDimension, RTIcap::ULong theUpperBound)
       throw ( ArrayIndexOutOfBounds) {};

  RTIcap::SpaceHandle getSpaceHandle() const throw () {};

  RTIcap::ULong getNumberOfExtents() const throw () {};

  RTIcap::ULong getRangeLowerBoundNotificationLimit( RTIcap::ExtentIndex theExtent, RTIcap::DimensionHandle theDimension) const
        throw ( ArrayIndexOutOfBounds) {};

  RTIcap::ULong getRangeUpperBoundNotificationLimit( RTIcap::ExtentIndex     theExtent,
    RTIcap::DimensionHandle theDimension) const
    throw ( ArrayIndexOutOfBounds) {};

};

#endif
