//
// Timucin, This objects are written to mapping between C++ RTI objects and
// RTIcap objects.
//
#ifndef  _RTI_HH_
#define  _RTI_HH_
#include <RTI.hh>
#endif
#include <mySet.h>


/****************************************************************************/
/****************************************************************************/
template<class T1, class T2>
mySet<T1,T2>::findIndexOf(T1 _sele, T2* index) const
{
   int found = 0;
   T2 i=0;
   while(!found && i<size)
   {
      found = ( _sele == eles[i] );
      if(!found) i++; 
   }// end of while
   *index = i;

   return found;

};// 

/****************************************************************************/
/****************************************************************************/
template<class T1, class T2>
mySet<T1,T2>::mySet(T2 _size)
{
   size = _size;
   number_of_elements = (T2) 0;
   if(size>0) eles = new T1[size]; 

};// end of CONSTRUCTOR

/****************************************************************************/
/****************************************************************************/
template<class T1, class T2>
mySet<T1,T2>::~mySet() 
{ if(size>0) delete[] eles; }

/****************************************************************************/
/****************************************************************************/
template<class T1, class T2>
T2 mySet<T1,T2>:: getSize() const 
{ return number_of_elements; } 

/****************************************************************************/
/****************************************************************************/
template<class T1, class T2>
T1 mySet<T1,T2>::getElementAt(T2 index) const throw (ArrayIndexOutOfBounds)
{
   if(index<0 || index > (size-1) ) 
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
   return eles[index];
}  

/****************************************************************************/
/****************************************************************************/
template<class T1, class T2>
void mySet<T1,T2>::put(T1 _newele) throw (ArrayIndexOutOfBounds)
{
   if(number_of_elements>(size-1)) 
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
   eles[number_of_elements] = _newele;
   number_of_elements++;

};// 

/****************************************************************************/
/****************************************************************************/
template<class T1, class T2>
void mySet<T1,T2>::rm(T1 _sele) 
{
   T2 index;
   if(findIndexOf(_sele,&index)) rmAt(index);
};// 

/****************************************************************************/
/****************************************************************************/
template<class T1, class T2>
void mySet<T1,T2>::rmAt(T2 index) throw (ArrayIndexOutOfBounds)
{
   if(index<0 || index > (size-1)) 
      throw new RTI::ArrayIndexOutOfBounds("out of bound");
   for(T2 i=index;i<size-1;i++) eles[i] = eles[i+1];
   number_of_elements--;
};// 

/****************************************************************************/
/****************************************************************************/
template<class T1, class T2>
void mySet<T1,T2>::freeUpElements() 
{ number_of_elements = 0; }; 

