#
# Usage:
#   nmake /f dir.mk [<build option>]
#
#  <build option>:
#      all       - build all executables
#      clean     - delete all executables and obj files
#      veryclean - clean plus delete all stub files generated by omniidl2
#        
#
# Pre-requisite:
#
# Make sure that you have environment variable LIB and INCLUDE setup for
# using Developer studio from the command line. Usually, this is accomplished
# by source the vcvars32.bat file.
#
#WIN32 = _WIN32_
# Where is the top of this distribution. All executable, library and include
# directories are relative to this variable.
#
TOP = ..\..\..


##########################################################################
# Essential flags to use omniORB2
#
DIR_CPPFLAGS   = -I. -I$(TOP)\include -I.\include
#
#
CORBA_CPPFLAGS = -D__WIN32__ -D_build_ -D__x86__ -D__NT__ -D__OSVERSION__=4
CORBA_LIB      = omniORB25_rt.lib omnithread2_rt.lib wsock32.lib advapi32.lib \
		 -libpath:$(TOP)\lib\x86_win32
LIBS = UUID.lib Advapi32.lib Ole32.lib oleaut32.lib

CXXFLAGS       = -O2 -MD -GX $(CORBA_CPPFLAGS) $(DIR_CPPFLAGS)
CXXLINKOPTIONS =

.SUFFIXES: .cc
.cc.obj:
  cl /nologo /c $(CXXFLAGS) /Tp$<

########################################################################
# To build debug executables
# Replace the above with the following:
#
#CORBA_CPPFLAGS = -D__WIN32__ -D__x86__ -D__NT__ -D__OSVERSION__=4
#CORBA_LIB      = omniORB25_rtd.lib omnithread2_rtd.lib wsock32.lib \
#                 advapi32.lib -libpath:$(TOP)\lib\x86_win32
#CXXFLAGS       = -MDd -GX -Z7 -Od  $(CORBA_CPPFLAGS) $(DIR_CPPFLAGS)
#CXXLINKOPTIONS = -debug -PDB:NONE      

OBJS = RTIcapSK.obj npacrtiSK.obj RTIambassador.obj RTIfedTimeImpl.obj capFederateAmbassadorImpl.obj \
    AttributeHandleSetFactoryImpl.obj AttributeHandleSetImpl.obj ParameterHandleValuePairSetImpl.obj \
    ParameterSetFactoryImpl.obj exps.obj AttributeHandleValuePairSetImpl.obj \
    FederateHandleSetImpl.obj FederateHandleSetFactoryImpl.obj FedTimeFactory.obj FedTimeImpl.obj \
    AttributeSetFactoryImpl.obj HostPort.obj Locator.obj

all:: RtiCap.lib

RtiCap.lib : $(OBJS) 
	link /DLL $(OBJS) $(LIBS) $(CORBA_LIB) /out:".\RtiCap.dll" /DEF:RtiCap.def
# /implib:".\RtiCap.lib"
 
clean::
  -del *.obj
  -del *.exe


veryclean::
  -del *.obj
  -del RTIcapSK.* RTIcap.hh
  -del npacrtiSK.* npacrti.hh
  -del *.exe


RTIcap.hh RTIcapSK.cc: RTIcap.idl
	$(TOP)\bin\x86_win32\omniidl2 -h .hh -s SK.cc RTIcap.idl

npacrti.hh npacrtiSK.cc: npacrti.idl
	$(TOP)\bin\x86_win32\omniidl2 -h .hh -s SK.cc npacrti.idl
