//File baseTypes.hh
//Included in RTI.hh

#ifndef NULL
#define NULL (0)
#endif

typedef unsigned short UShort;
typedef short          Short;
typedef unsigned long  ULong;
typedef long           Long;
typedef double         Double;
typedef float          Float;

enum Boolean {
    RTI_FALSE = 0,
    RTI_TRUE};

class DLL_SYMBOL Exception {
public:
  //RTI::ULong _serial;
  ULong _serial;
  char *_reason;
  const char *_name;
  Exception (const char *reason);
  //Exception (RTI::ULong serial, const char *reason=NULL);
  Exception (ULong serial, const char *reason=NULL);
  Exception (const Exception &toCopy);
  virtual ~Exception ();
  Exception & operator = (const Exception &);
  friend DLL_SYMBOL ostream& operator<< (ostream &, Exception *);
};

#define RTI_EXCEPT(A)   \
class A : public Exception {       \
public: \
  static const char *_ex;  \
  A (const char *reason) : Exception (reason)  { _name = _ex; }   \
  A (ULong serial, const char *reason=NULL)        \
    : Exception (serial, reason)  { _name = _ex; }        \
  A (const Exception &toCopy) : Exception(toCopy) { _name = _ex; } \
};
