#ifndef __npacrti_hh__
#define __npacrti_hh__

#include <omniORB2/CORBA.h>

#include <RTIcap.hh>
_CORBA_MODULE npacrti {
_CORBA_MODULE_PUBLIC

  enum FederateStateType { RUNNING, SAVE_PENDING, SAVING, RESTORE_PENDING, RESTORING };

  friend inline void operator>>= (FederateStateType _e,NetBufferedStream &s) {
    ::operator>>=((CORBA::ULong)_e,s);
  }

  friend inline void operator<<= (FederateStateType &_e,NetBufferedStream &s) {
    CORBA::ULong __e;
    __e <<= s;
    switch (__e) {
      case RUNNING:
      case SAVE_PENDING:
      case SAVING:
      case RESTORE_PENDING:
      case RESTORING:
        _e = (FederateStateType) __e;
        break;
      default:
        _CORBA_marshal_error();
    }
  }

  friend inline void operator>>= (FederateStateType _e,MemBufferedStream &s) {
    ::operator>>=((CORBA::ULong)_e,s);
  }

  friend inline void operator<<= (FederateStateType &_e,MemBufferedStream &s) {
    CORBA::ULong __e;
    __e <<= s;
    switch (__e) {
      case RUNNING:
      case SAVE_PENDING:
      case SAVING:
      case RESTORE_PENDING:
      case RESTORING:
        _e = (FederateStateType) __e;
        break;
      default:
        _CORBA_marshal_error();
    }
  }

  enum TimeManagerStateType { IDLE, ADVANCE_PENDING };

  friend inline void operator>>= (TimeManagerStateType _e,NetBufferedStream &s) {
    ::operator>>=((CORBA::ULong)_e,s);
  }

  friend inline void operator<<= (TimeManagerStateType &_e,NetBufferedStream &s) {
    CORBA::ULong __e;
    __e <<= s;
    switch (__e) {
      case IDLE:
      case ADVANCE_PENDING:
        _e = (TimeManagerStateType) __e;
        break;
      default:
        _CORBA_marshal_error();
    }
  }

  friend inline void operator>>= (TimeManagerStateType _e,MemBufferedStream &s) {
    ::operator>>=((CORBA::ULong)_e,s);
  }

  friend inline void operator<<= (TimeManagerStateType &_e,MemBufferedStream &s) {
    CORBA::ULong __e;
    __e <<= s;
    switch (__e) {
      case IDLE:
      case ADVANCE_PENDING:
        _e = (TimeManagerStateType) __e;
        break;
      default:
        _CORBA_marshal_error();
    }
  }

#ifndef __npacrti_FederationManagerInterface__
#define __npacrti_FederationManagerInterface__
  class   FederationManagerInterface;
  typedef FederationManagerInterface* FederationManagerInterface_ptr;
  typedef FederationManagerInterface_ptr FederationManagerInterfaceRef;

  class FederationManagerInterface_Helper {
    public:
    static FederationManagerInterface_ptr _nil();
    static CORBA::Boolean is_nil(FederationManagerInterface_ptr p);
    static void release(FederationManagerInterface_ptr p);
    static void duplicate(FederationManagerInterface_ptr p);
    static size_t NP_alignedSize(FederationManagerInterface_ptr obj,size_t initialoffset);
    static void marshalObjRef(FederationManagerInterface_ptr obj,NetBufferedStream &s);
    static FederationManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(FederationManagerInterface_ptr obj,MemBufferedStream &s);
    static FederationManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s);
  };
  typedef _CORBA_ObjRef_Var<FederationManagerInterface,FederationManagerInterface_Helper> FederationManagerInterface_var;

#endif
#define npacrti_FederationManagerInterface_IntfRepoID "IDL:npacrti/FederationManagerInterface:1.0"

  class FederationManagerInterface : public virtual omniObject, public virtual CORBA::Object {
  public:

    virtual void createFederationExecution ( const char *  executionName, const char *  FED ) = 0;
    virtual void destroyFederationExecution ( const char *  executionName, RTIcap::FederateHandle  theFederate ) = 0;
    virtual RTIcap::FederateHandle  joinFederationExecution ( const char *  yourName, const char *  executionName, RTIcap::FederateAmbassador_ptr  fedAmbassador ) = 0;
    virtual void resignFederationExecution ( RTIcap::ResignAction  theAction, const char *  executionName, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void registerFederationSynchronizationPoint ( const char *  label, const char *  tag, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void registerFederationSynchronizationPointWithSet ( const char *  label, const char *  tag, const RTIcap::FederateHandleSet & syncSet, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void synchronizationPointAchieved ( const char *  label, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void requestFederationSaveWithTime ( const char *  label, RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void requestFederationSave ( const char *  label, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void federateSaveBegun ( RTIcap::FederateHandle  theFederate ) = 0;
    virtual void federateSaveComplete ( RTIcap::FederateHandle  theFederate ) = 0;
    virtual void federateSaveNotComplete ( RTIcap::FederateHandle  theFederate ) = 0;
    virtual void requestFederationRestore ( const char *  label, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void federateRestoreComplete ( RTIcap::FederateHandle  theFederate ) = 0;
    virtual void federateRestoreNotComplete ( RTIcap::FederateHandle  theFederate ) = 0;
    static FederationManagerInterface_ptr _duplicate(FederationManagerInterface_ptr);
    static FederationManagerInterface_ptr _narrow(CORBA::Object_ptr);
    static FederationManagerInterface_ptr _nil();

    static inline size_t NP_alignedSize(FederationManagerInterface_ptr obj,size_t initialoffset) {
      return CORBA::AlignedObjRef(obj,npacrti_FederationManagerInterface_IntfRepoID,43,initialoffset);
    }

    static inline void marshalObjRef(FederationManagerInterface_ptr obj,NetBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_FederationManagerInterface_IntfRepoID,43,s);
    }

    static inline FederationManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_FederationManagerInterface_IntfRepoID,s);
      FederationManagerInterface_ptr _result = npacrti::FederationManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static inline void marshalObjRef(FederationManagerInterface_ptr obj,MemBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_FederationManagerInterface_IntfRepoID,43,s);
    }

    static inline FederationManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_FederationManagerInterface_IntfRepoID,s);
      FederationManagerInterface_ptr _result = npacrti::FederationManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

  protected:

    FederationManagerInterface() {
      if (!is_proxy())
        omniObject::PR_IRRepositoryId(npacrti_FederationManagerInterface_IntfRepoID);
      this->PR_setobj(this);
    }
    virtual ~FederationManagerInterface() {}
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

  private:

    FederationManagerInterface(const FederationManagerInterface&);
    FederationManagerInterface &operator=(const FederationManagerInterface&);
  };

  class _sk_FederationManagerInterface :  public virtual FederationManagerInterface {
  public:

    _sk_FederationManagerInterface() {}
    _sk_FederationManagerInterface(const omniORB::objectKey& k);
    virtual ~_sk_FederationManagerInterface() {}
    FederationManagerInterface_ptr _this() { return FederationManagerInterface::_duplicate(this); }
    void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
    CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
    void _dispose() { _boa()->dispose(this); }
    omniORB::objectKey _key();
    virtual void createFederationExecution ( const char *  executionName, const char *  FED ) = 0;
    virtual void destroyFederationExecution ( const char *  executionName, RTIcap::FederateHandle  theFederate ) = 0;
    virtual RTIcap::FederateHandle  joinFederationExecution ( const char *  yourName, const char *  executionName, RTIcap::FederateAmbassador_ptr  fedAmbassador ) = 0;
    virtual void resignFederationExecution ( RTIcap::ResignAction  theAction, const char *  executionName, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void registerFederationSynchronizationPoint ( const char *  label, const char *  tag, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void registerFederationSynchronizationPointWithSet ( const char *  label, const char *  tag, const RTIcap::FederateHandleSet & syncSet, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void synchronizationPointAchieved ( const char *  label, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void requestFederationSaveWithTime ( const char *  label, RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void requestFederationSave ( const char *  label, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void federateSaveBegun ( RTIcap::FederateHandle  theFederate ) = 0;
    virtual void federateSaveComplete ( RTIcap::FederateHandle  theFederate ) = 0;
    virtual void federateSaveNotComplete ( RTIcap::FederateHandle  theFederate ) = 0;
    virtual void requestFederationRestore ( const char *  label, RTIcap::FederateHandle  theFederate ) = 0;
    virtual void federateRestoreComplete ( RTIcap::FederateHandle  theFederate ) = 0;
    virtual void federateRestoreNotComplete ( RTIcap::FederateHandle  theFederate ) = 0;
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return FederationManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  private:
    _sk_FederationManagerInterface (const _sk_FederationManagerInterface&);
    _sk_FederationManagerInterface &operator=(const _sk_FederationManagerInterface&);
  };

  class _proxy_FederationManagerInterface :  public virtual FederationManagerInterface {
  public:

    _proxy_FederationManagerInterface (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
      omniObject(npacrti_FederationManagerInterface_IntfRepoID,r,key,keysize,profiles,release) {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_FederationManagerInterface() {}
    virtual void createFederationExecution ( const char *  executionName, const char *  FED );
    virtual void destroyFederationExecution ( const char *  executionName, RTIcap::FederateHandle  theFederate );
    virtual RTIcap::FederateHandle  joinFederationExecution ( const char *  yourName, const char *  executionName, RTIcap::FederateAmbassador_ptr  fedAmbassador );
    virtual void resignFederationExecution ( RTIcap::ResignAction  theAction, const char *  executionName, RTIcap::FederateHandle  theFederate );
    virtual void registerFederationSynchronizationPoint ( const char *  label, const char *  tag, RTIcap::FederateHandle  theFederate );
    virtual void registerFederationSynchronizationPointWithSet ( const char *  label, const char *  tag, const RTIcap::FederateHandleSet & syncSet, RTIcap::FederateHandle  theFederate );
    virtual void synchronizationPointAchieved ( const char *  label, RTIcap::FederateHandle  theFederate );
    virtual void requestFederationSaveWithTime ( const char *  label, RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFederate );
    virtual void requestFederationSave ( const char *  label, RTIcap::FederateHandle  theFederate );
    virtual void federateSaveBegun ( RTIcap::FederateHandle  theFederate );
    virtual void federateSaveComplete ( RTIcap::FederateHandle  theFederate );
    virtual void federateSaveNotComplete ( RTIcap::FederateHandle  theFederate );
    virtual void requestFederationRestore ( const char *  label, RTIcap::FederateHandle  theFederate );
    virtual void federateRestoreComplete ( RTIcap::FederateHandle  theFederate );
    virtual void federateRestoreNotComplete ( RTIcap::FederateHandle  theFederate );

  protected:

    _proxy_FederationManagerInterface () {}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
      return FederationManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
  private:

    _proxy_FederationManagerInterface (const _proxy_FederationManagerInterface&);
    _proxy_FederationManagerInterface &operator=(const _proxy_FederationManagerInterface&);
  };

  class _nil_FederationManagerInterface :   public virtual FederationManagerInterface {
  public:
    _nil_FederationManagerInterface() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
    virtual ~_nil_FederationManagerInterface() {}
    void createFederationExecution ( const char *  executionName, const char *  FED ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void destroyFederationExecution ( const char *  executionName, RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::FederateHandle  joinFederationExecution ( const char *  yourName, const char *  executionName, RTIcap::FederateAmbassador_ptr  fedAmbassador ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::FederateHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void resignFederationExecution ( RTIcap::ResignAction  theAction, const char *  executionName, RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void registerFederationSynchronizationPoint ( const char *  label, const char *  tag, RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void registerFederationSynchronizationPointWithSet ( const char *  label, const char *  tag, const RTIcap::FederateHandleSet & syncSet, RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void synchronizationPointAchieved ( const char *  label, RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestFederationSaveWithTime ( const char *  label, RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestFederationSave ( const char *  label, RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void federateSaveBegun ( RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void federateSaveComplete ( RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void federateSaveNotComplete ( RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestFederationRestore ( const char *  label, RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void federateRestoreComplete ( RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void federateRestoreNotComplete ( RTIcap::FederateHandle  theFederate ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return FederationManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  };

  class FederationManagerInterface_proxyObjectFactory : public proxyObjectFactory {
  public:
    FederationManagerInterface_proxyObjectFactory () {}
    virtual ~FederationManagerInterface_proxyObjectFactory () {}
    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static FederationManagerInterface_ptr _nil() {
      if (!__nil_FederationManagerInterface) {
        __nil_FederationManagerInterface = new _nil_FederationManagerInterface;
      }
      return __nil_FederationManagerInterface;
    }
  private:
    static FederationManagerInterface_ptr __nil_FederationManagerInterface;
  };

#ifndef __npacrti_FederationManagerInterface1__
#define __npacrti_FederationManagerInterface1__
  class   FederationManagerInterface1;
  typedef FederationManagerInterface1* FederationManagerInterface1_ptr;
  typedef FederationManagerInterface1_ptr FederationManagerInterface1Ref;

  class FederationManagerInterface1_Helper {
    public:
    static FederationManagerInterface1_ptr _nil();
    static CORBA::Boolean is_nil(FederationManagerInterface1_ptr p);
    static void release(FederationManagerInterface1_ptr p);
    static void duplicate(FederationManagerInterface1_ptr p);
    static size_t NP_alignedSize(FederationManagerInterface1_ptr obj,size_t initialoffset);
    static void marshalObjRef(FederationManagerInterface1_ptr obj,NetBufferedStream &s);
    static FederationManagerInterface1_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(FederationManagerInterface1_ptr obj,MemBufferedStream &s);
    static FederationManagerInterface1_ptr unmarshalObjRef(MemBufferedStream &s);
  };
  typedef _CORBA_ObjRef_Var<FederationManagerInterface1,FederationManagerInterface1_Helper> FederationManagerInterface1_var;

#endif
#define npacrti_FederationManagerInterface1_IntfRepoID "IDL:npacrti/FederationManagerInterface1:1.0"

  class FederationManagerInterface1 : public virtual omniObject, public virtual CORBA::Object {
  public:

    virtual void createFederationExecution ( const char *  executionName ) = 0;
    virtual void destroyFederationExecution ( const char *  executionName ) = 0;
    virtual RTIcap::FederateHandle  joinFederationExecution ( const char *  yourName, const char *  executionName, RTIcap::FederateAmbassador_ptr  federateAmbassador ) = 0;
    virtual void resignFederationExecution ( RTIcap::FederateHandle  theFederate, const char *  executionName, RTIcap::ResignAction  theAction ) = 0;
    virtual void resignFederationExecution1 ( RTIcap::FederateHandle  theFederate, RTIcap::ResignAction  theAction ) = 0;
    virtual void requestPause ( RTIcap::FederateHandle  handle, const char *  name, const char *  label ) = 0;
    virtual void pauseAchieved ( const char *  label ) = 0;
    virtual void requestResume ( RTIcap::FederateHandle  handle, const char *  name ) = 0;
    virtual void resumeAchieved (  ) = 0;
    virtual void requestFederationSave1 ( const char *  label, RTIcap::FederationTime  theTime ) = 0;
    virtual void requestFederationSave2 ( const char *  label ) = 0;
    virtual void federateSaveBegun1 (  ) = 0;
    virtual void federateSaveBegun2 ( RTIcap::FederationTime  theTime ) = 0;
    virtual void federateSaveAchieved (  ) = 0;
    virtual void federateSaveNotAchieved (  ) = 0;
    virtual void requestRestore ( const char *  label ) = 0;
    virtual void restoreAchieved ( const char *  label ) = 0;
    virtual void restoreNotAchieved ( const char *  label ) = 0;
    static FederationManagerInterface1_ptr _duplicate(FederationManagerInterface1_ptr);
    static FederationManagerInterface1_ptr _narrow(CORBA::Object_ptr);
    static FederationManagerInterface1_ptr _nil();

    static inline size_t NP_alignedSize(FederationManagerInterface1_ptr obj,size_t initialoffset) {
      return CORBA::AlignedObjRef(obj,npacrti_FederationManagerInterface1_IntfRepoID,44,initialoffset);
    }

    static inline void marshalObjRef(FederationManagerInterface1_ptr obj,NetBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_FederationManagerInterface1_IntfRepoID,44,s);
    }

    static inline FederationManagerInterface1_ptr unmarshalObjRef(NetBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_FederationManagerInterface1_IntfRepoID,s);
      FederationManagerInterface1_ptr _result = npacrti::FederationManagerInterface1::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static inline void marshalObjRef(FederationManagerInterface1_ptr obj,MemBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_FederationManagerInterface1_IntfRepoID,44,s);
    }

    static inline FederationManagerInterface1_ptr unmarshalObjRef(MemBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_FederationManagerInterface1_IntfRepoID,s);
      FederationManagerInterface1_ptr _result = npacrti::FederationManagerInterface1::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

  protected:

    FederationManagerInterface1() {
      if (!is_proxy())
        omniObject::PR_IRRepositoryId(npacrti_FederationManagerInterface1_IntfRepoID);
      this->PR_setobj(this);
    }
    virtual ~FederationManagerInterface1() {}
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

  private:

    FederationManagerInterface1(const FederationManagerInterface1&);
    FederationManagerInterface1 &operator=(const FederationManagerInterface1&);
  };

  class _sk_FederationManagerInterface1 :  public virtual FederationManagerInterface1 {
  public:

    _sk_FederationManagerInterface1() {}
    _sk_FederationManagerInterface1(const omniORB::objectKey& k);
    virtual ~_sk_FederationManagerInterface1() {}
    FederationManagerInterface1_ptr _this() { return FederationManagerInterface1::_duplicate(this); }
    void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
    CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
    void _dispose() { _boa()->dispose(this); }
    omniORB::objectKey _key();
    virtual void createFederationExecution ( const char *  executionName ) = 0;
    virtual void destroyFederationExecution ( const char *  executionName ) = 0;
    virtual RTIcap::FederateHandle  joinFederationExecution ( const char *  yourName, const char *  executionName, RTIcap::FederateAmbassador_ptr  federateAmbassador ) = 0;
    virtual void resignFederationExecution ( RTIcap::FederateHandle  theFederate, const char *  executionName, RTIcap::ResignAction  theAction ) = 0;
    virtual void resignFederationExecution1 ( RTIcap::FederateHandle  theFederate, RTIcap::ResignAction  theAction ) = 0;
    virtual void requestPause ( RTIcap::FederateHandle  handle, const char *  name, const char *  label ) = 0;
    virtual void pauseAchieved ( const char *  label ) = 0;
    virtual void requestResume ( RTIcap::FederateHandle  handle, const char *  name ) = 0;
    virtual void resumeAchieved (  ) = 0;
    virtual void requestFederationSave1 ( const char *  label, RTIcap::FederationTime  theTime ) = 0;
    virtual void requestFederationSave2 ( const char *  label ) = 0;
    virtual void federateSaveBegun1 (  ) = 0;
    virtual void federateSaveBegun2 ( RTIcap::FederationTime  theTime ) = 0;
    virtual void federateSaveAchieved (  ) = 0;
    virtual void federateSaveNotAchieved (  ) = 0;
    virtual void requestRestore ( const char *  label ) = 0;
    virtual void restoreAchieved ( const char *  label ) = 0;
    virtual void restoreNotAchieved ( const char *  label ) = 0;
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return FederationManagerInterface1::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  private:
    _sk_FederationManagerInterface1 (const _sk_FederationManagerInterface1&);
    _sk_FederationManagerInterface1 &operator=(const _sk_FederationManagerInterface1&);
  };

  class _proxy_FederationManagerInterface1 :  public virtual FederationManagerInterface1 {
  public:

    _proxy_FederationManagerInterface1 (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
      omniObject(npacrti_FederationManagerInterface1_IntfRepoID,r,key,keysize,profiles,release) {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_FederationManagerInterface1() {}
    virtual void createFederationExecution ( const char *  executionName );
    virtual void destroyFederationExecution ( const char *  executionName );
    virtual RTIcap::FederateHandle  joinFederationExecution ( const char *  yourName, const char *  executionName, RTIcap::FederateAmbassador_ptr  federateAmbassador );
    virtual void resignFederationExecution ( RTIcap::FederateHandle  theFederate, const char *  executionName, RTIcap::ResignAction  theAction );
    virtual void resignFederationExecution1 ( RTIcap::FederateHandle  theFederate, RTIcap::ResignAction  theAction );
    virtual void requestPause ( RTIcap::FederateHandle  handle, const char *  name, const char *  label );
    virtual void pauseAchieved ( const char *  label );
    virtual void requestResume ( RTIcap::FederateHandle  handle, const char *  name );
    virtual void resumeAchieved (  );
    virtual void requestFederationSave1 ( const char *  label, RTIcap::FederationTime  theTime );
    virtual void requestFederationSave2 ( const char *  label );
    virtual void federateSaveBegun1 (  );
    virtual void federateSaveBegun2 ( RTIcap::FederationTime  theTime );
    virtual void federateSaveAchieved (  );
    virtual void federateSaveNotAchieved (  );
    virtual void requestRestore ( const char *  label );
    virtual void restoreAchieved ( const char *  label );
    virtual void restoreNotAchieved ( const char *  label );

  protected:

    _proxy_FederationManagerInterface1 () {}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
      return FederationManagerInterface1::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
  private:

    _proxy_FederationManagerInterface1 (const _proxy_FederationManagerInterface1&);
    _proxy_FederationManagerInterface1 &operator=(const _proxy_FederationManagerInterface1&);
  };

  class _nil_FederationManagerInterface1 :   public virtual FederationManagerInterface1 {
  public:
    _nil_FederationManagerInterface1() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
    virtual ~_nil_FederationManagerInterface1() {}
    void createFederationExecution ( const char *  executionName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void destroyFederationExecution ( const char *  executionName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::FederateHandle  joinFederationExecution ( const char *  yourName, const char *  executionName, RTIcap::FederateAmbassador_ptr  federateAmbassador ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::FederateHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void resignFederationExecution ( RTIcap::FederateHandle  theFederate, const char *  executionName, RTIcap::ResignAction  theAction ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void resignFederationExecution1 ( RTIcap::FederateHandle  theFederate, RTIcap::ResignAction  theAction ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestPause ( RTIcap::FederateHandle  handle, const char *  name, const char *  label ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void pauseAchieved ( const char *  label ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestResume ( RTIcap::FederateHandle  handle, const char *  name ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void resumeAchieved (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestFederationSave1 ( const char *  label, RTIcap::FederationTime  theTime ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestFederationSave2 ( const char *  label ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void federateSaveBegun1 (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void federateSaveBegun2 ( RTIcap::FederationTime  theTime ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void federateSaveAchieved (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void federateSaveNotAchieved (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestRestore ( const char *  label ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void restoreAchieved ( const char *  label ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void restoreNotAchieved ( const char *  label ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return FederationManagerInterface1::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  };

  class FederationManagerInterface1_proxyObjectFactory : public proxyObjectFactory {
  public:
    FederationManagerInterface1_proxyObjectFactory () {}
    virtual ~FederationManagerInterface1_proxyObjectFactory () {}
    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static FederationManagerInterface1_ptr _nil() {
      if (!__nil_FederationManagerInterface1) {
        __nil_FederationManagerInterface1 = new _nil_FederationManagerInterface1;
      }
      return __nil_FederationManagerInterface1;
    }
  private:
    static FederationManagerInterface1_ptr __nil_FederationManagerInterface1;
  };

#ifndef __npacrti_DeclarationManagerInterface__
#define __npacrti_DeclarationManagerInterface__
  class   DeclarationManagerInterface;
  typedef DeclarationManagerInterface* DeclarationManagerInterface_ptr;
  typedef DeclarationManagerInterface_ptr DeclarationManagerInterfaceRef;

  class DeclarationManagerInterface_Helper {
    public:
    static DeclarationManagerInterface_ptr _nil();
    static CORBA::Boolean is_nil(DeclarationManagerInterface_ptr p);
    static void release(DeclarationManagerInterface_ptr p);
    static void duplicate(DeclarationManagerInterface_ptr p);
    static size_t NP_alignedSize(DeclarationManagerInterface_ptr obj,size_t initialoffset);
    static void marshalObjRef(DeclarationManagerInterface_ptr obj,NetBufferedStream &s);
    static DeclarationManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(DeclarationManagerInterface_ptr obj,MemBufferedStream &s);
    static DeclarationManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s);
  };
  typedef _CORBA_ObjRef_Var<DeclarationManagerInterface,DeclarationManagerInterface_Helper> DeclarationManagerInterface_var;

#endif
#define npacrti_DeclarationManagerInterface_IntfRepoID "IDL:npacrti/DeclarationManagerInterface:1.0"

  class DeclarationManagerInterface : public virtual omniObject, public virtual CORBA::Object {
  public:

    virtual void publishObjectClass ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & attributeList, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unpublishObjectClass ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void publishInteractionClass ( RTIcap::InteractionClassHandle  theInteraction, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unpublishInteractionClass ( RTIcap::InteractionClassHandle  theInteraction, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void subscribeObjectClassAttributes ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & attributeList, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unsubscribeObjectClass ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void subscribeInteractionClass ( RTIcap::InteractionClassHandle  theClass, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unsubscribeInteractionClass ( RTIcap::InteractionClassHandle  theClass, RTIcap::FederateHandle  theHandle ) = 0;
    static DeclarationManagerInterface_ptr _duplicate(DeclarationManagerInterface_ptr);
    static DeclarationManagerInterface_ptr _narrow(CORBA::Object_ptr);
    static DeclarationManagerInterface_ptr _nil();

    static inline size_t NP_alignedSize(DeclarationManagerInterface_ptr obj,size_t initialoffset) {
      return CORBA::AlignedObjRef(obj,npacrti_DeclarationManagerInterface_IntfRepoID,44,initialoffset);
    }

    static inline void marshalObjRef(DeclarationManagerInterface_ptr obj,NetBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_DeclarationManagerInterface_IntfRepoID,44,s);
    }

    static inline DeclarationManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_DeclarationManagerInterface_IntfRepoID,s);
      DeclarationManagerInterface_ptr _result = npacrti::DeclarationManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static inline void marshalObjRef(DeclarationManagerInterface_ptr obj,MemBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_DeclarationManagerInterface_IntfRepoID,44,s);
    }

    static inline DeclarationManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_DeclarationManagerInterface_IntfRepoID,s);
      DeclarationManagerInterface_ptr _result = npacrti::DeclarationManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

  protected:

    DeclarationManagerInterface() {
      if (!is_proxy())
        omniObject::PR_IRRepositoryId(npacrti_DeclarationManagerInterface_IntfRepoID);
      this->PR_setobj(this);
    }
    virtual ~DeclarationManagerInterface() {}
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

  private:

    DeclarationManagerInterface(const DeclarationManagerInterface&);
    DeclarationManagerInterface &operator=(const DeclarationManagerInterface&);
  };

  class _sk_DeclarationManagerInterface :  public virtual DeclarationManagerInterface {
  public:

    _sk_DeclarationManagerInterface() {}
    _sk_DeclarationManagerInterface(const omniORB::objectKey& k);
    virtual ~_sk_DeclarationManagerInterface() {}
    DeclarationManagerInterface_ptr _this() { return DeclarationManagerInterface::_duplicate(this); }
    void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
    CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
    void _dispose() { _boa()->dispose(this); }
    omniORB::objectKey _key();
    virtual void publishObjectClass ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & attributeList, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unpublishObjectClass ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void publishInteractionClass ( RTIcap::InteractionClassHandle  theInteraction, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unpublishInteractionClass ( RTIcap::InteractionClassHandle  theInteraction, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void subscribeObjectClassAttributes ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & attributeList, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unsubscribeObjectClass ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void subscribeInteractionClass ( RTIcap::InteractionClassHandle  theClass, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unsubscribeInteractionClass ( RTIcap::InteractionClassHandle  theClass, RTIcap::FederateHandle  theHandle ) = 0;
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return DeclarationManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  private:
    _sk_DeclarationManagerInterface (const _sk_DeclarationManagerInterface&);
    _sk_DeclarationManagerInterface &operator=(const _sk_DeclarationManagerInterface&);
  };

  class _proxy_DeclarationManagerInterface :  public virtual DeclarationManagerInterface {
  public:

    _proxy_DeclarationManagerInterface (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
      omniObject(npacrti_DeclarationManagerInterface_IntfRepoID,r,key,keysize,profiles,release) {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_DeclarationManagerInterface() {}
    virtual void publishObjectClass ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & attributeList, RTIcap::FederateHandle  theHandle );
    virtual void unpublishObjectClass ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateHandle  theHandle );
    virtual void publishInteractionClass ( RTIcap::InteractionClassHandle  theInteraction, RTIcap::FederateHandle  theHandle );
    virtual void unpublishInteractionClass ( RTIcap::InteractionClassHandle  theInteraction, RTIcap::FederateHandle  theHandle );
    virtual void subscribeObjectClassAttributes ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & attributeList, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle );
    virtual void unsubscribeObjectClass ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateHandle  theHandle );
    virtual void subscribeInteractionClass ( RTIcap::InteractionClassHandle  theClass, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle );
    virtual void unsubscribeInteractionClass ( RTIcap::InteractionClassHandle  theClass, RTIcap::FederateHandle  theHandle );

  protected:

    _proxy_DeclarationManagerInterface () {}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
      return DeclarationManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
  private:

    _proxy_DeclarationManagerInterface (const _proxy_DeclarationManagerInterface&);
    _proxy_DeclarationManagerInterface &operator=(const _proxy_DeclarationManagerInterface&);
  };

  class _nil_DeclarationManagerInterface :   public virtual DeclarationManagerInterface {
  public:
    _nil_DeclarationManagerInterface() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
    virtual ~_nil_DeclarationManagerInterface() {}
    void publishObjectClass ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & attributeList, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void unpublishObjectClass ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void publishInteractionClass ( RTIcap::InteractionClassHandle  theInteraction, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void unpublishInteractionClass ( RTIcap::InteractionClassHandle  theInteraction, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void subscribeObjectClassAttributes ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & attributeList, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void unsubscribeObjectClass ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void subscribeInteractionClass ( RTIcap::InteractionClassHandle  theClass, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void unsubscribeInteractionClass ( RTIcap::InteractionClassHandle  theClass, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return DeclarationManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  };

  class DeclarationManagerInterface_proxyObjectFactory : public proxyObjectFactory {
  public:
    DeclarationManagerInterface_proxyObjectFactory () {}
    virtual ~DeclarationManagerInterface_proxyObjectFactory () {}
    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static DeclarationManagerInterface_ptr _nil() {
      if (!__nil_DeclarationManagerInterface) {
        __nil_DeclarationManagerInterface = new _nil_DeclarationManagerInterface;
      }
      return __nil_DeclarationManagerInterface;
    }
  private:
    static DeclarationManagerInterface_ptr __nil_DeclarationManagerInterface;
  };

#ifndef __npacrti_ObjectManagerInterface__
#define __npacrti_ObjectManagerInterface__
  class   ObjectManagerInterface;
  typedef ObjectManagerInterface* ObjectManagerInterface_ptr;
  typedef ObjectManagerInterface_ptr ObjectManagerInterfaceRef;

  class ObjectManagerInterface_Helper {
    public:
    static ObjectManagerInterface_ptr _nil();
    static CORBA::Boolean is_nil(ObjectManagerInterface_ptr p);
    static void release(ObjectManagerInterface_ptr p);
    static void duplicate(ObjectManagerInterface_ptr p);
    static size_t NP_alignedSize(ObjectManagerInterface_ptr obj,size_t initialoffset);
    static void marshalObjRef(ObjectManagerInterface_ptr obj,NetBufferedStream &s);
    static ObjectManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(ObjectManagerInterface_ptr obj,MemBufferedStream &s);
    static ObjectManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s);
  };
  typedef _CORBA_ObjRef_Var<ObjectManagerInterface,ObjectManagerInterface_Helper> ObjectManagerInterface_var;

#endif
#define npacrti_ObjectManagerInterface_IntfRepoID "IDL:npacrti/ObjectManagerInterface:1.0"

  class ObjectManagerInterface : public virtual omniObject, public virtual CORBA::Object {
  public:

    virtual RTIcap::ObjectHandle  registerObjectInstanceWithName ( RTIcap::ObjectClassHandle  theClass, const char *  theName, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::ObjectHandle  registerObjectInstance ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateAmbassador_ptr  theName, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::EventRetractionHandle  updateAttributeValuesWithTime ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleValuePairSet & theAttributes, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void updateAttributeValues ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleValuePairSet & theAttributes, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::EventRetractionHandle  sendInteractionWithTime ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & theParameters, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void sendInteraction ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & theParameters, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::EventRetractionHandle  deleteObjectInstanceWithTime ( RTIcap::ObjectHandle  objectID, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void deleteObjectInstance ( RTIcap::ObjectHandle  objectID, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void localdeleteObjectInstance ( RTIcap::ObjectHandle  objectID, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void changeAttributeTransportType ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::TransportType  theType, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void changeInteractionTransportType ( RTIcap::InteractionClassHandle  theClass, RTIcap::TransportType  theType, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestObjectAttributeValueUpdate1 ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestObjectAttributeValueUpdate2 ( RTIcap::ObjectHandle  theObject, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestClassAttributeValueUpdate1 ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestClassAttributeValueUpdate2 ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void retract ( const RTIcap::EventRetractionHandle & theHandle ) = 0;
    static ObjectManagerInterface_ptr _duplicate(ObjectManagerInterface_ptr);
    static ObjectManagerInterface_ptr _narrow(CORBA::Object_ptr);
    static ObjectManagerInterface_ptr _nil();

    static inline size_t NP_alignedSize(ObjectManagerInterface_ptr obj,size_t initialoffset) {
      return CORBA::AlignedObjRef(obj,npacrti_ObjectManagerInterface_IntfRepoID,39,initialoffset);
    }

    static inline void marshalObjRef(ObjectManagerInterface_ptr obj,NetBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_ObjectManagerInterface_IntfRepoID,39,s);
    }

    static inline ObjectManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_ObjectManagerInterface_IntfRepoID,s);
      ObjectManagerInterface_ptr _result = npacrti::ObjectManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static inline void marshalObjRef(ObjectManagerInterface_ptr obj,MemBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_ObjectManagerInterface_IntfRepoID,39,s);
    }

    static inline ObjectManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_ObjectManagerInterface_IntfRepoID,s);
      ObjectManagerInterface_ptr _result = npacrti::ObjectManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

  protected:

    ObjectManagerInterface() {
      if (!is_proxy())
        omniObject::PR_IRRepositoryId(npacrti_ObjectManagerInterface_IntfRepoID);
      this->PR_setobj(this);
    }
    virtual ~ObjectManagerInterface() {}
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

  private:

    ObjectManagerInterface(const ObjectManagerInterface&);
    ObjectManagerInterface &operator=(const ObjectManagerInterface&);
  };

  class _sk_ObjectManagerInterface :  public virtual ObjectManagerInterface {
  public:

    _sk_ObjectManagerInterface() {}
    _sk_ObjectManagerInterface(const omniORB::objectKey& k);
    virtual ~_sk_ObjectManagerInterface() {}
    ObjectManagerInterface_ptr _this() { return ObjectManagerInterface::_duplicate(this); }
    void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
    CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
    void _dispose() { _boa()->dispose(this); }
    omniORB::objectKey _key();
    virtual RTIcap::ObjectHandle  registerObjectInstanceWithName ( RTIcap::ObjectClassHandle  theClass, const char *  theName, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::ObjectHandle  registerObjectInstance ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateAmbassador_ptr  theName, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::EventRetractionHandle  updateAttributeValuesWithTime ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleValuePairSet & theAttributes, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void updateAttributeValues ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleValuePairSet & theAttributes, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::EventRetractionHandle  sendInteractionWithTime ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & theParameters, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void sendInteraction ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & theParameters, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::EventRetractionHandle  deleteObjectInstanceWithTime ( RTIcap::ObjectHandle  objectID, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void deleteObjectInstance ( RTIcap::ObjectHandle  objectID, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void localdeleteObjectInstance ( RTIcap::ObjectHandle  objectID, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void changeAttributeTransportType ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::TransportType  theType, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void changeInteractionTransportType ( RTIcap::InteractionClassHandle  theClass, RTIcap::TransportType  theType, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestObjectAttributeValueUpdate1 ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestObjectAttributeValueUpdate2 ( RTIcap::ObjectHandle  theObject, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestClassAttributeValueUpdate1 ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestClassAttributeValueUpdate2 ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void retract ( const RTIcap::EventRetractionHandle & theHandle ) = 0;
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return ObjectManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  private:
    _sk_ObjectManagerInterface (const _sk_ObjectManagerInterface&);
    _sk_ObjectManagerInterface &operator=(const _sk_ObjectManagerInterface&);
  };

  class _proxy_ObjectManagerInterface :  public virtual ObjectManagerInterface {
  public:

    _proxy_ObjectManagerInterface (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
      omniObject(npacrti_ObjectManagerInterface_IntfRepoID,r,key,keysize,profiles,release) {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_ObjectManagerInterface() {}
    virtual RTIcap::ObjectHandle  registerObjectInstanceWithName ( RTIcap::ObjectClassHandle  theClass, const char *  theName, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual RTIcap::ObjectHandle  registerObjectInstance ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateAmbassador_ptr  theName, RTIcap::FederateHandle  theHandle );
    virtual RTIcap::EventRetractionHandle  updateAttributeValuesWithTime ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleValuePairSet & theAttributes, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void updateAttributeValues ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleValuePairSet & theAttributes, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual RTIcap::EventRetractionHandle  sendInteractionWithTime ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & theParameters, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void sendInteraction ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & theParameters, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual RTIcap::EventRetractionHandle  deleteObjectInstanceWithTime ( RTIcap::ObjectHandle  objectID, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void deleteObjectInstance ( RTIcap::ObjectHandle  objectID, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void localdeleteObjectInstance ( RTIcap::ObjectHandle  objectID, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void changeAttributeTransportType ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::TransportType  theType, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void changeInteractionTransportType ( RTIcap::InteractionClassHandle  theClass, RTIcap::TransportType  theType, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void requestObjectAttributeValueUpdate1 ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void requestObjectAttributeValueUpdate2 ( RTIcap::ObjectHandle  theObject, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void requestClassAttributeValueUpdate1 ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void requestClassAttributeValueUpdate2 ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle );
    virtual void retract ( const RTIcap::EventRetractionHandle & theHandle );

  protected:

    _proxy_ObjectManagerInterface () {}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
      return ObjectManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
  private:

    _proxy_ObjectManagerInterface (const _proxy_ObjectManagerInterface&);
    _proxy_ObjectManagerInterface &operator=(const _proxy_ObjectManagerInterface&);
  };

  class _nil_ObjectManagerInterface :   public virtual ObjectManagerInterface {
  public:
    _nil_ObjectManagerInterface() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
    virtual ~_nil_ObjectManagerInterface() {}
    RTIcap::ObjectHandle  registerObjectInstanceWithName ( RTIcap::ObjectClassHandle  theClass, const char *  theName, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::ObjectHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::ObjectHandle  registerObjectInstance ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateAmbassador_ptr  theName, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::ObjectHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::EventRetractionHandle  updateAttributeValuesWithTime ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleValuePairSet & theAttributes, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::EventRetractionHandle _0RL_result;
memset((void *)&_0RL_result,0,sizeof(_0RL_result));
      return _0RL_result;
#endif
    }

    void updateAttributeValues ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleValuePairSet & theAttributes, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::EventRetractionHandle  sendInteractionWithTime ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & theParameters, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::EventRetractionHandle _0RL_result;
memset((void *)&_0RL_result,0,sizeof(_0RL_result));
      return _0RL_result;
#endif
    }

    void sendInteraction ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & theParameters, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::EventRetractionHandle  deleteObjectInstanceWithTime ( RTIcap::ObjectHandle  objectID, RTIcap::FederationTime  theTime, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::EventRetractionHandle _0RL_result;
memset((void *)&_0RL_result,0,sizeof(_0RL_result));
      return _0RL_result;
#endif
    }

    void deleteObjectInstance ( RTIcap::ObjectHandle  objectID, const char *  theTag, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void localdeleteObjectInstance ( RTIcap::ObjectHandle  objectID, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void changeAttributeTransportType ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::TransportType  theType, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void changeInteractionTransportType ( RTIcap::InteractionClassHandle  theClass, RTIcap::TransportType  theType, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestObjectAttributeValueUpdate1 ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestObjectAttributeValueUpdate2 ( RTIcap::ObjectHandle  theObject, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestClassAttributeValueUpdate1 ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestClassAttributeValueUpdate2 ( RTIcap::ObjectClassHandle  theClass, RTIcap::FederateAmbassador_ptr  fedAmb, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void retract ( const RTIcap::EventRetractionHandle & theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return ObjectManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  };

  class ObjectManagerInterface_proxyObjectFactory : public proxyObjectFactory {
  public:
    ObjectManagerInterface_proxyObjectFactory () {}
    virtual ~ObjectManagerInterface_proxyObjectFactory () {}
    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static ObjectManagerInterface_ptr _nil() {
      if (!__nil_ObjectManagerInterface) {
        __nil_ObjectManagerInterface = new _nil_ObjectManagerInterface;
      }
      return __nil_ObjectManagerInterface;
    }
  private:
    static ObjectManagerInterface_ptr __nil_ObjectManagerInterface;
  };

#ifndef __npacrti_OwnershipManagerInterface__
#define __npacrti_OwnershipManagerInterface__
  class   OwnershipManagerInterface;
  typedef OwnershipManagerInterface* OwnershipManagerInterface_ptr;
  typedef OwnershipManagerInterface_ptr OwnershipManagerInterfaceRef;

  class OwnershipManagerInterface_Helper {
    public:
    static OwnershipManagerInterface_ptr _nil();
    static CORBA::Boolean is_nil(OwnershipManagerInterface_ptr p);
    static void release(OwnershipManagerInterface_ptr p);
    static void duplicate(OwnershipManagerInterface_ptr p);
    static size_t NP_alignedSize(OwnershipManagerInterface_ptr obj,size_t initialoffset);
    static void marshalObjRef(OwnershipManagerInterface_ptr obj,NetBufferedStream &s);
    static OwnershipManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(OwnershipManagerInterface_ptr obj,MemBufferedStream &s);
    static OwnershipManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s);
  };
  typedef _CORBA_ObjRef_Var<OwnershipManagerInterface,OwnershipManagerInterface_Helper> OwnershipManagerInterface_var;

#endif
#define npacrti_OwnershipManagerInterface_IntfRepoID "IDL:npacrti/OwnershipManagerInterface:1.0"

  class OwnershipManagerInterface : public virtual omniObject, public virtual CORBA::Object {
  public:

    virtual void unconditionalAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void negotiatedAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, const char *  tag, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void attributeOwnershipAcquisition ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, const char *  tag, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void attributeOwnerhsipAcquisitionIfAvailable ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::AttributeHandleSet * attributeOwnershipReleaseResponse ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void cancelNegotiatedAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void cancelAttributeOwnershipAcquisition ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void queryAttributeOwnership ( RTIcap::ObjectHandle  obj, RTIcap::AttributeHandle  attrib, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::Boolean  isAttributeOwnedByFederate ( RTIcap::ObjectHandle  obj, RTIcap::AttributeHandle  attrib, RTIcap::FederateHandle  theHandle ) = 0;
    static OwnershipManagerInterface_ptr _duplicate(OwnershipManagerInterface_ptr);
    static OwnershipManagerInterface_ptr _narrow(CORBA::Object_ptr);
    static OwnershipManagerInterface_ptr _nil();

    static inline size_t NP_alignedSize(OwnershipManagerInterface_ptr obj,size_t initialoffset) {
      return CORBA::AlignedObjRef(obj,npacrti_OwnershipManagerInterface_IntfRepoID,42,initialoffset);
    }

    static inline void marshalObjRef(OwnershipManagerInterface_ptr obj,NetBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_OwnershipManagerInterface_IntfRepoID,42,s);
    }

    static inline OwnershipManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_OwnershipManagerInterface_IntfRepoID,s);
      OwnershipManagerInterface_ptr _result = npacrti::OwnershipManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static inline void marshalObjRef(OwnershipManagerInterface_ptr obj,MemBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_OwnershipManagerInterface_IntfRepoID,42,s);
    }

    static inline OwnershipManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_OwnershipManagerInterface_IntfRepoID,s);
      OwnershipManagerInterface_ptr _result = npacrti::OwnershipManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

  protected:

    OwnershipManagerInterface() {
      if (!is_proxy())
        omniObject::PR_IRRepositoryId(npacrti_OwnershipManagerInterface_IntfRepoID);
      this->PR_setobj(this);
    }
    virtual ~OwnershipManagerInterface() {}
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

  private:

    OwnershipManagerInterface(const OwnershipManagerInterface&);
    OwnershipManagerInterface &operator=(const OwnershipManagerInterface&);
  };

  class _sk_OwnershipManagerInterface :  public virtual OwnershipManagerInterface {
  public:

    _sk_OwnershipManagerInterface() {}
    _sk_OwnershipManagerInterface(const omniORB::objectKey& k);
    virtual ~_sk_OwnershipManagerInterface() {}
    OwnershipManagerInterface_ptr _this() { return OwnershipManagerInterface::_duplicate(this); }
    void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
    CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
    void _dispose() { _boa()->dispose(this); }
    omniORB::objectKey _key();
    virtual void unconditionalAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void negotiatedAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, const char *  tag, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void attributeOwnershipAcquisition ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, const char *  tag, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void attributeOwnerhsipAcquisitionIfAvailable ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::AttributeHandleSet * attributeOwnershipReleaseResponse ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void cancelNegotiatedAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void cancelAttributeOwnershipAcquisition ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void queryAttributeOwnership ( RTIcap::ObjectHandle  obj, RTIcap::AttributeHandle  attrib, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::Boolean  isAttributeOwnedByFederate ( RTIcap::ObjectHandle  obj, RTIcap::AttributeHandle  attrib, RTIcap::FederateHandle  theHandle ) = 0;
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return OwnershipManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  private:
    _sk_OwnershipManagerInterface (const _sk_OwnershipManagerInterface&);
    _sk_OwnershipManagerInterface &operator=(const _sk_OwnershipManagerInterface&);
  };

  class _proxy_OwnershipManagerInterface :  public virtual OwnershipManagerInterface {
  public:

    _proxy_OwnershipManagerInterface (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
      omniObject(npacrti_OwnershipManagerInterface_IntfRepoID,r,key,keysize,profiles,release) {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_OwnershipManagerInterface() {}
    virtual void unconditionalAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle );
    virtual void negotiatedAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, const char *  tag, RTIcap::FederateHandle  theHandle );
    virtual void attributeOwnershipAcquisition ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, const char *  tag, RTIcap::FederateHandle  theHandle );
    virtual void attributeOwnerhsipAcquisitionIfAvailable ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle );
    virtual RTIcap::AttributeHandleSet * attributeOwnershipReleaseResponse ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle );
    virtual void cancelNegotiatedAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle );
    virtual void cancelAttributeOwnershipAcquisition ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle );
    virtual void queryAttributeOwnership ( RTIcap::ObjectHandle  obj, RTIcap::AttributeHandle  attrib, RTIcap::FederateHandle  theHandle );
    virtual RTIcap::Boolean  isAttributeOwnedByFederate ( RTIcap::ObjectHandle  obj, RTIcap::AttributeHandle  attrib, RTIcap::FederateHandle  theHandle );

  protected:

    _proxy_OwnershipManagerInterface () {}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
      return OwnershipManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
  private:

    _proxy_OwnershipManagerInterface (const _proxy_OwnershipManagerInterface&);
    _proxy_OwnershipManagerInterface &operator=(const _proxy_OwnershipManagerInterface&);
  };

  class _nil_OwnershipManagerInterface :   public virtual OwnershipManagerInterface {
  public:
    _nil_OwnershipManagerInterface() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
    virtual ~_nil_OwnershipManagerInterface() {}
    void unconditionalAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void negotiatedAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, const char *  tag, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void attributeOwnershipAcquisition ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, const char *  tag, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void attributeOwnerhsipAcquisitionIfAvailable ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::AttributeHandleSet * attributeOwnershipReleaseResponse ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::AttributeHandleSet * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void cancelNegotiatedAttributeOwnershipDivestiture ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void cancelAttributeOwnershipAcquisition ( RTIcap::ObjectHandle  object, const RTIcap::AttributeHandleSet & attributes, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void queryAttributeOwnership ( RTIcap::ObjectHandle  obj, RTIcap::AttributeHandle  attrib, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::Boolean  isAttributeOwnedByFederate ( RTIcap::ObjectHandle  obj, RTIcap::AttributeHandle  attrib, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::Boolean _0RL_result = RTIcap::RTI_FALSE;
      return _0RL_result;
#endif
    }

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return OwnershipManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  };

  class OwnershipManagerInterface_proxyObjectFactory : public proxyObjectFactory {
  public:
    OwnershipManagerInterface_proxyObjectFactory () {}
    virtual ~OwnershipManagerInterface_proxyObjectFactory () {}
    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static OwnershipManagerInterface_ptr _nil() {
      if (!__nil_OwnershipManagerInterface) {
        __nil_OwnershipManagerInterface = new _nil_OwnershipManagerInterface;
      }
      return __nil_OwnershipManagerInterface;
    }
  private:
    static OwnershipManagerInterface_ptr __nil_OwnershipManagerInterface;
  };

#ifndef __npacrti_TimeManagerInterface__
#define __npacrti_TimeManagerInterface__
  class   TimeManagerInterface;
  typedef TimeManagerInterface* TimeManagerInterface_ptr;
  typedef TimeManagerInterface_ptr TimeManagerInterfaceRef;

  class TimeManagerInterface_Helper {
    public:
    static TimeManagerInterface_ptr _nil();
    static CORBA::Boolean is_nil(TimeManagerInterface_ptr p);
    static void release(TimeManagerInterface_ptr p);
    static void duplicate(TimeManagerInterface_ptr p);
    static size_t NP_alignedSize(TimeManagerInterface_ptr obj,size_t initialoffset);
    static void marshalObjRef(TimeManagerInterface_ptr obj,NetBufferedStream &s);
    static TimeManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(TimeManagerInterface_ptr obj,MemBufferedStream &s);
    static TimeManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s);
  };
  typedef _CORBA_ObjRef_Var<TimeManagerInterface,TimeManagerInterface_Helper> TimeManagerInterface_var;

#endif
#define npacrti_TimeManagerInterface_IntfRepoID "IDL:npacrti/TimeManagerInterface:1.0"

  class TimeManagerInterface : public virtual omniObject, public virtual CORBA::Object {
  public:

    virtual RTIcap::Boolean  tick ( RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::Boolean  tickMinMax ( RTIcap::TickTime  minimum, RTIcap::TickTime  maximum, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void enableTimeRegulation ( RTIcap::FederationTime  theTime, RTIcap::FederationTimeDelta  lookahead, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void disableTimeRegulation ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void enableTimeConstrained ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void disableTimeConstrained ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void timeAdvanceRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void timeAdvanceRequestAvailable ( RTIcap::FederationTime  time, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void nextEventRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void nextEventRequestAvailable ( RTIcap::FederationTime  time, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void flushQueueRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void enableAsynchronousDelivery ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void disableAsynchronousDelivery ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual RTIcap::FederationTime  queryLBTS ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual RTIcap::FederationTime  queryFederateTime ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual RTIcap::FederationTime  queryMinNextEventTime ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void modifyLookahead ( RTIcap::FederationTimeDelta  theLookahead, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual RTIcap::FederationTimeDelta  queryLookahead ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void retract ( const RTIcap::EventRetractionHandle & theHandle, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void changeAttributeOrderType ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::OrderingHandle  theType, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void changeInteractionOrderType ( RTIcap::InteractionClassHandle  theObject, RTIcap::OrderingHandle  theType, RTIcap::FederateHandle  theFedHandle ) = 0;
    static TimeManagerInterface_ptr _duplicate(TimeManagerInterface_ptr);
    static TimeManagerInterface_ptr _narrow(CORBA::Object_ptr);
    static TimeManagerInterface_ptr _nil();

    static inline size_t NP_alignedSize(TimeManagerInterface_ptr obj,size_t initialoffset) {
      return CORBA::AlignedObjRef(obj,npacrti_TimeManagerInterface_IntfRepoID,37,initialoffset);
    }

    static inline void marshalObjRef(TimeManagerInterface_ptr obj,NetBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_TimeManagerInterface_IntfRepoID,37,s);
    }

    static inline TimeManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_TimeManagerInterface_IntfRepoID,s);
      TimeManagerInterface_ptr _result = npacrti::TimeManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static inline void marshalObjRef(TimeManagerInterface_ptr obj,MemBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_TimeManagerInterface_IntfRepoID,37,s);
    }

    static inline TimeManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_TimeManagerInterface_IntfRepoID,s);
      TimeManagerInterface_ptr _result = npacrti::TimeManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

  protected:

    TimeManagerInterface() {
      if (!is_proxy())
        omniObject::PR_IRRepositoryId(npacrti_TimeManagerInterface_IntfRepoID);
      this->PR_setobj(this);
    }
    virtual ~TimeManagerInterface() {}
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

  private:

    TimeManagerInterface(const TimeManagerInterface&);
    TimeManagerInterface &operator=(const TimeManagerInterface&);
  };

  class _sk_TimeManagerInterface :  public virtual TimeManagerInterface {
  public:

    _sk_TimeManagerInterface() {}
    _sk_TimeManagerInterface(const omniORB::objectKey& k);
    virtual ~_sk_TimeManagerInterface() {}
    TimeManagerInterface_ptr _this() { return TimeManagerInterface::_duplicate(this); }
    void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
    CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
    void _dispose() { _boa()->dispose(this); }
    omniORB::objectKey _key();
    virtual RTIcap::Boolean  tick ( RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::Boolean  tickMinMax ( RTIcap::TickTime  minimum, RTIcap::TickTime  maximum, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void enableTimeRegulation ( RTIcap::FederationTime  theTime, RTIcap::FederationTimeDelta  lookahead, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void disableTimeRegulation ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void enableTimeConstrained ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void disableTimeConstrained ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void timeAdvanceRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void timeAdvanceRequestAvailable ( RTIcap::FederationTime  time, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void nextEventRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void nextEventRequestAvailable ( RTIcap::FederationTime  time, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void flushQueueRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void enableAsynchronousDelivery ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void disableAsynchronousDelivery ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual RTIcap::FederationTime  queryLBTS ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual RTIcap::FederationTime  queryFederateTime ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual RTIcap::FederationTime  queryMinNextEventTime ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void modifyLookahead ( RTIcap::FederationTimeDelta  theLookahead, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual RTIcap::FederationTimeDelta  queryLookahead ( RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void retract ( const RTIcap::EventRetractionHandle & theHandle, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void changeAttributeOrderType ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::OrderingHandle  theType, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual void changeInteractionOrderType ( RTIcap::InteractionClassHandle  theObject, RTIcap::OrderingHandle  theType, RTIcap::FederateHandle  theFedHandle ) = 0;
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return TimeManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  private:
    _sk_TimeManagerInterface (const _sk_TimeManagerInterface&);
    _sk_TimeManagerInterface &operator=(const _sk_TimeManagerInterface&);
  };

  class _proxy_TimeManagerInterface :  public virtual TimeManagerInterface {
  public:

    _proxy_TimeManagerInterface (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
      omniObject(npacrti_TimeManagerInterface_IntfRepoID,r,key,keysize,profiles,release) {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_TimeManagerInterface() {}
    virtual RTIcap::Boolean  tick ( RTIcap::FederateHandle  theHandle );
    virtual RTIcap::Boolean  tickMinMax ( RTIcap::TickTime  minimum, RTIcap::TickTime  maximum, RTIcap::FederateHandle  theHandle );
    virtual void enableTimeRegulation ( RTIcap::FederationTime  theTime, RTIcap::FederationTimeDelta  lookahead, RTIcap::FederateHandle  theFedHandle );
    virtual void disableTimeRegulation ( RTIcap::FederateHandle  theFedHandle );
    virtual void enableTimeConstrained ( RTIcap::FederateHandle  theFedHandle );
    virtual void disableTimeConstrained ( RTIcap::FederateHandle  theFedHandle );
    virtual void timeAdvanceRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle );
    virtual void timeAdvanceRequestAvailable ( RTIcap::FederationTime  time, RTIcap::FederateHandle  theFedHandle );
    virtual void nextEventRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle );
    virtual void nextEventRequestAvailable ( RTIcap::FederationTime  time, RTIcap::FederateHandle  theFedHandle );
    virtual void flushQueueRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle );
    virtual void enableAsynchronousDelivery ( RTIcap::FederateHandle  theFedHandle );
    virtual void disableAsynchronousDelivery ( RTIcap::FederateHandle  theFedHandle );
    virtual RTIcap::FederationTime  queryLBTS ( RTIcap::FederateHandle  theFedHandle );
    virtual RTIcap::FederationTime  queryFederateTime ( RTIcap::FederateHandle  theFedHandle );
    virtual RTIcap::FederationTime  queryMinNextEventTime ( RTIcap::FederateHandle  theFedHandle );
    virtual void modifyLookahead ( RTIcap::FederationTimeDelta  theLookahead, RTIcap::FederateHandle  theFedHandle );
    virtual RTIcap::FederationTimeDelta  queryLookahead ( RTIcap::FederateHandle  theFedHandle );
    virtual void retract ( const RTIcap::EventRetractionHandle & theHandle, RTIcap::FederateHandle  theFedHandle );
    virtual void changeAttributeOrderType ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::OrderingHandle  theType, RTIcap::FederateHandle  theFedHandle );
    virtual void changeInteractionOrderType ( RTIcap::InteractionClassHandle  theObject, RTIcap::OrderingHandle  theType, RTIcap::FederateHandle  theFedHandle );

  protected:

    _proxy_TimeManagerInterface () {}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
      return TimeManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
  private:

    _proxy_TimeManagerInterface (const _proxy_TimeManagerInterface&);
    _proxy_TimeManagerInterface &operator=(const _proxy_TimeManagerInterface&);
  };

  class _nil_TimeManagerInterface :   public virtual TimeManagerInterface {
  public:
    _nil_TimeManagerInterface() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
    virtual ~_nil_TimeManagerInterface() {}
    RTIcap::Boolean  tick ( RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::Boolean _0RL_result = RTIcap::RTI_FALSE;
      return _0RL_result;
#endif
    }

    RTIcap::Boolean  tickMinMax ( RTIcap::TickTime  minimum, RTIcap::TickTime  maximum, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::Boolean _0RL_result = RTIcap::RTI_FALSE;
      return _0RL_result;
#endif
    }

    void enableTimeRegulation ( RTIcap::FederationTime  theTime, RTIcap::FederationTimeDelta  lookahead, RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void disableTimeRegulation ( RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void enableTimeConstrained ( RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void disableTimeConstrained ( RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void timeAdvanceRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void timeAdvanceRequestAvailable ( RTIcap::FederationTime  time, RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void nextEventRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void nextEventRequestAvailable ( RTIcap::FederationTime  time, RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void flushQueueRequest ( RTIcap::FederationTime  theTime, RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void enableAsynchronousDelivery ( RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void disableAsynchronousDelivery ( RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::FederationTime  queryLBTS ( RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::FederationTime _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::FederationTime  queryFederateTime ( RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::FederationTime _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::FederationTime  queryMinNextEventTime ( RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::FederationTime _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void modifyLookahead ( RTIcap::FederationTimeDelta  theLookahead, RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::FederationTimeDelta  queryLookahead ( RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::FederationTimeDelta _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void retract ( const RTIcap::EventRetractionHandle & theHandle, RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void changeAttributeOrderType ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::OrderingHandle  theType, RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void changeInteractionOrderType ( RTIcap::InteractionClassHandle  theObject, RTIcap::OrderingHandle  theType, RTIcap::FederateHandle  theFedHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return TimeManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  };

  class TimeManagerInterface_proxyObjectFactory : public proxyObjectFactory {
  public:
    TimeManagerInterface_proxyObjectFactory () {}
    virtual ~TimeManagerInterface_proxyObjectFactory () {}
    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static TimeManagerInterface_ptr _nil() {
      if (!__nil_TimeManagerInterface) {
        __nil_TimeManagerInterface = new _nil_TimeManagerInterface;
      }
      return __nil_TimeManagerInterface;
    }
  private:
    static TimeManagerInterface_ptr __nil_TimeManagerInterface;
  };

#ifndef __npacrti_DataDistributionManagerInterface__
#define __npacrti_DataDistributionManagerInterface__
  class   DataDistributionManagerInterface;
  typedef DataDistributionManagerInterface* DataDistributionManagerInterface_ptr;
  typedef DataDistributionManagerInterface_ptr DataDistributionManagerInterfaceRef;

  class DataDistributionManagerInterface_Helper {
    public:
    static DataDistributionManagerInterface_ptr _nil();
    static CORBA::Boolean is_nil(DataDistributionManagerInterface_ptr p);
    static void release(DataDistributionManagerInterface_ptr p);
    static void duplicate(DataDistributionManagerInterface_ptr p);
    static size_t NP_alignedSize(DataDistributionManagerInterface_ptr obj,size_t initialoffset);
    static void marshalObjRef(DataDistributionManagerInterface_ptr obj,NetBufferedStream &s);
    static DataDistributionManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(DataDistributionManagerInterface_ptr obj,MemBufferedStream &s);
    static DataDistributionManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s);
  };
  typedef _CORBA_ObjRef_Var<DataDistributionManagerInterface,DataDistributionManagerInterface_Helper> DataDistributionManagerInterface_var;

#endif
#define npacrti_DataDistributionManagerInterface_IntfRepoID "IDL:npacrti/DataDistributionManagerInterface:1.0"

  class DataDistributionManagerInterface : public virtual omniObject, public virtual CORBA::Object {
  public:

    virtual RTIcap::Region * createRegion ( RTIcap::SpaceHandle  theSpace, RTIcap::ULong  numberOfExtents, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void notifyAboutRegionModification ( const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void deleteRegion ( const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::ObjectHandle  registerObjectInstanceWithRegionAndName ( RTIcap::ObjectClassHandle  _class, const char *  theName, const RTIcap::AttributeHandleSet & attributes, const RTIcap::RegionSet & regions, RTIcap::ULong  theNumberOfhandles, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::ObjectHandle  registerObjectInstanceWithRegion ( RTIcap::ObjectClassHandle  _class, const RTIcap::AttributeHandleSet & attributes, const RTIcap::RegionSet & regions, RTIcap::ULong  theNumberOfhandles, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void associateRegionForUpdates ( const RTIcap::Region & theRegion, RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unassociateRegionForUpdates ( const RTIcap::Region & theRegion, RTIcap::ObjectHandle  theObject, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void subscribeObjectClassAttributesWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::Region & theRegion, const RTIcap::AttributeHandleSet & attributeList, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unsubscribeObjectClassWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void subscribeInteractionClassWithRegion ( RTIcap::InteractionClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unsubscribeInteractionClassWithRegion ( RTIcap::InteractionClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::EventRetractionHandle  sendInteractionWithRegionAndTime ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & parameters, RTIcap::FederationTime  theTime, const char *  theTag, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void sendInteractionWithRegion ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & parameters, const char *  theTag, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestClassAttributeValueUpdateWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & theAttributes, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestObjectAttributeValueUpdateWithRegion ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    static DataDistributionManagerInterface_ptr _duplicate(DataDistributionManagerInterface_ptr);
    static DataDistributionManagerInterface_ptr _narrow(CORBA::Object_ptr);
    static DataDistributionManagerInterface_ptr _nil();

    static inline size_t NP_alignedSize(DataDistributionManagerInterface_ptr obj,size_t initialoffset) {
      return CORBA::AlignedObjRef(obj,npacrti_DataDistributionManagerInterface_IntfRepoID,49,initialoffset);
    }

    static inline void marshalObjRef(DataDistributionManagerInterface_ptr obj,NetBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_DataDistributionManagerInterface_IntfRepoID,49,s);
    }

    static inline DataDistributionManagerInterface_ptr unmarshalObjRef(NetBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_DataDistributionManagerInterface_IntfRepoID,s);
      DataDistributionManagerInterface_ptr _result = npacrti::DataDistributionManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static inline void marshalObjRef(DataDistributionManagerInterface_ptr obj,MemBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_DataDistributionManagerInterface_IntfRepoID,49,s);
    }

    static inline DataDistributionManagerInterface_ptr unmarshalObjRef(MemBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_DataDistributionManagerInterface_IntfRepoID,s);
      DataDistributionManagerInterface_ptr _result = npacrti::DataDistributionManagerInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

  protected:

    DataDistributionManagerInterface() {
      if (!is_proxy())
        omniObject::PR_IRRepositoryId(npacrti_DataDistributionManagerInterface_IntfRepoID);
      this->PR_setobj(this);
    }
    virtual ~DataDistributionManagerInterface() {}
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

  private:

    DataDistributionManagerInterface(const DataDistributionManagerInterface&);
    DataDistributionManagerInterface &operator=(const DataDistributionManagerInterface&);
  };

  class _sk_DataDistributionManagerInterface :  public virtual DataDistributionManagerInterface {
  public:

    _sk_DataDistributionManagerInterface() {}
    _sk_DataDistributionManagerInterface(const omniORB::objectKey& k);
    virtual ~_sk_DataDistributionManagerInterface() {}
    DataDistributionManagerInterface_ptr _this() { return DataDistributionManagerInterface::_duplicate(this); }
    void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
    CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
    void _dispose() { _boa()->dispose(this); }
    omniORB::objectKey _key();
    virtual RTIcap::Region * createRegion ( RTIcap::SpaceHandle  theSpace, RTIcap::ULong  numberOfExtents, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void notifyAboutRegionModification ( const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void deleteRegion ( const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::ObjectHandle  registerObjectInstanceWithRegionAndName ( RTIcap::ObjectClassHandle  _class, const char *  theName, const RTIcap::AttributeHandleSet & attributes, const RTIcap::RegionSet & regions, RTIcap::ULong  theNumberOfhandles, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::ObjectHandle  registerObjectInstanceWithRegion ( RTIcap::ObjectClassHandle  _class, const RTIcap::AttributeHandleSet & attributes, const RTIcap::RegionSet & regions, RTIcap::ULong  theNumberOfhandles, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void associateRegionForUpdates ( const RTIcap::Region & theRegion, RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unassociateRegionForUpdates ( const RTIcap::Region & theRegion, RTIcap::ObjectHandle  theObject, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void subscribeObjectClassAttributesWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::Region & theRegion, const RTIcap::AttributeHandleSet & attributeList, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unsubscribeObjectClassWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void subscribeInteractionClassWithRegion ( RTIcap::InteractionClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void unsubscribeInteractionClassWithRegion ( RTIcap::InteractionClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual RTIcap::EventRetractionHandle  sendInteractionWithRegionAndTime ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & parameters, RTIcap::FederationTime  theTime, const char *  theTag, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void sendInteractionWithRegion ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & parameters, const char *  theTag, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestClassAttributeValueUpdateWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & theAttributes, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual void requestObjectAttributeValueUpdateWithRegion ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ) = 0;
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return DataDistributionManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  private:
    _sk_DataDistributionManagerInterface (const _sk_DataDistributionManagerInterface&);
    _sk_DataDistributionManagerInterface &operator=(const _sk_DataDistributionManagerInterface&);
  };

  class _proxy_DataDistributionManagerInterface :  public virtual DataDistributionManagerInterface {
  public:

    _proxy_DataDistributionManagerInterface (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
      omniObject(npacrti_DataDistributionManagerInterface_IntfRepoID,r,key,keysize,profiles,release) {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_DataDistributionManagerInterface() {}
    virtual RTIcap::Region * createRegion ( RTIcap::SpaceHandle  theSpace, RTIcap::ULong  numberOfExtents, RTIcap::FederateHandle  theHandle );
    virtual void notifyAboutRegionModification ( const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle );
    virtual void deleteRegion ( const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle );
    virtual RTIcap::ObjectHandle  registerObjectInstanceWithRegionAndName ( RTIcap::ObjectClassHandle  _class, const char *  theName, const RTIcap::AttributeHandleSet & attributes, const RTIcap::RegionSet & regions, RTIcap::ULong  theNumberOfhandles, RTIcap::FederateHandle  theHandle );
    virtual RTIcap::ObjectHandle  registerObjectInstanceWithRegion ( RTIcap::ObjectClassHandle  _class, const RTIcap::AttributeHandleSet & attributes, const RTIcap::RegionSet & regions, RTIcap::ULong  theNumberOfhandles, RTIcap::FederateHandle  theHandle );
    virtual void associateRegionForUpdates ( const RTIcap::Region & theRegion, RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateHandle  theHandle );
    virtual void unassociateRegionForUpdates ( const RTIcap::Region & theRegion, RTIcap::ObjectHandle  theObject, RTIcap::FederateHandle  theHandle );
    virtual void subscribeObjectClassAttributesWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::Region & theRegion, const RTIcap::AttributeHandleSet & attributeList, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle );
    virtual void unsubscribeObjectClassWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle );
    virtual void subscribeInteractionClassWithRegion ( RTIcap::InteractionClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle );
    virtual void unsubscribeInteractionClassWithRegion ( RTIcap::InteractionClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle );
    virtual RTIcap::EventRetractionHandle  sendInteractionWithRegionAndTime ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & parameters, RTIcap::FederationTime  theTime, const char *  theTag, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle );
    virtual void sendInteractionWithRegion ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & parameters, const char *  theTag, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle );
    virtual void requestClassAttributeValueUpdateWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & theAttributes, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle );
    virtual void requestObjectAttributeValueUpdateWithRegion ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle );

  protected:

    _proxy_DataDistributionManagerInterface () {}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
      return DataDistributionManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
  private:

    _proxy_DataDistributionManagerInterface (const _proxy_DataDistributionManagerInterface&);
    _proxy_DataDistributionManagerInterface &operator=(const _proxy_DataDistributionManagerInterface&);
  };

  class _nil_DataDistributionManagerInterface :   public virtual DataDistributionManagerInterface {
  public:
    _nil_DataDistributionManagerInterface() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
    virtual ~_nil_DataDistributionManagerInterface() {}
    RTIcap::Region * createRegion ( RTIcap::SpaceHandle  theSpace, RTIcap::ULong  numberOfExtents, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::Region * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void notifyAboutRegionModification ( const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void deleteRegion ( const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::ObjectHandle  registerObjectInstanceWithRegionAndName ( RTIcap::ObjectClassHandle  _class, const char *  theName, const RTIcap::AttributeHandleSet & attributes, const RTIcap::RegionSet & regions, RTIcap::ULong  theNumberOfhandles, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::ObjectHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::ObjectHandle  registerObjectInstanceWithRegion ( RTIcap::ObjectClassHandle  _class, const RTIcap::AttributeHandleSet & attributes, const RTIcap::RegionSet & regions, RTIcap::ULong  theNumberOfhandles, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::ObjectHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void associateRegionForUpdates ( const RTIcap::Region & theRegion, RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void unassociateRegionForUpdates ( const RTIcap::Region & theRegion, RTIcap::ObjectHandle  theObject, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void subscribeObjectClassAttributesWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::Region & theRegion, const RTIcap::AttributeHandleSet & attributeList, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void unsubscribeObjectClassWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void subscribeInteractionClassWithRegion ( RTIcap::InteractionClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::Boolean  active, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void unsubscribeInteractionClassWithRegion ( RTIcap::InteractionClassHandle  theClass, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::EventRetractionHandle  sendInteractionWithRegionAndTime ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & parameters, RTIcap::FederationTime  theTime, const char *  theTag, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::EventRetractionHandle _0RL_result;
memset((void *)&_0RL_result,0,sizeof(_0RL_result));
      return _0RL_result;
#endif
    }

    void sendInteractionWithRegion ( RTIcap::InteractionClassHandle  theInteraction, const RTIcap::ParameterHandleValuePairSet & parameters, const char *  theTag, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestClassAttributeValueUpdateWithRegion ( RTIcap::ObjectClassHandle  theClass, const RTIcap::AttributeHandleSet & theAttributes, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void requestObjectAttributeValueUpdateWithRegion ( RTIcap::ObjectHandle  theObject, const RTIcap::AttributeHandleSet & theAttributes, const RTIcap::Region & theRegion, RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return DataDistributionManagerInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  };

  class DataDistributionManagerInterface_proxyObjectFactory : public proxyObjectFactory {
  public:
    DataDistributionManagerInterface_proxyObjectFactory () {}
    virtual ~DataDistributionManagerInterface_proxyObjectFactory () {}
    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static DataDistributionManagerInterface_ptr _nil() {
      if (!__nil_DataDistributionManagerInterface) {
        __nil_DataDistributionManagerInterface = new _nil_DataDistributionManagerInterface;
      }
      return __nil_DataDistributionManagerInterface;
    }
  private:
    static DataDistributionManagerInterface_ptr __nil_DataDistributionManagerInterface;
  };

#ifndef __npacrti_RTIServicesInterface__
#define __npacrti_RTIServicesInterface__
  class   RTIServicesInterface;
  typedef RTIServicesInterface* RTIServicesInterface_ptr;
  typedef RTIServicesInterface_ptr RTIServicesInterfaceRef;

  class RTIServicesInterface_Helper {
    public:
    static RTIServicesInterface_ptr _nil();
    static CORBA::Boolean is_nil(RTIServicesInterface_ptr p);
    static void release(RTIServicesInterface_ptr p);
    static void duplicate(RTIServicesInterface_ptr p);
    static size_t NP_alignedSize(RTIServicesInterface_ptr obj,size_t initialoffset);
    static void marshalObjRef(RTIServicesInterface_ptr obj,NetBufferedStream &s);
    static RTIServicesInterface_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(RTIServicesInterface_ptr obj,MemBufferedStream &s);
    static RTIServicesInterface_ptr unmarshalObjRef(MemBufferedStream &s);
  };
  typedef _CORBA_ObjRef_Var<RTIServicesInterface,RTIServicesInterface_Helper> RTIServicesInterface_var;

#endif
#define npacrti_RTIServicesInterface_IntfRepoID "IDL:npacrti/RTIServicesInterface:1.0"

  class RTIServicesInterface : public virtual omniObject, public virtual CORBA::Object {
  public:

    virtual RTIcap::FederateHandle  getFederateHandle ( const char *  theName ) = 0;
    virtual char *  getFederateName ( RTIcap::FederateHandle  theHandle ) = 0;
    virtual void turnRegulationOn (  ) = 0;
    virtual RTIcap::FederationTime  turnRegulationOnNow (  ) = 0;
    virtual void turnRegulationOff (  ) = 0;
    virtual void setTimeConstrained ( RTIcap::Boolean  state ) = 0;
    virtual RTIcap::ObjectClassHandle  getObjectClassHandle ( const char *  theName ) = 0;
    virtual char *  getObjectClassName ( RTIcap::ObjectClassHandle  theHandle ) = 0;
    virtual RTIcap::AttributeHandle  getAttributeHandle ( const char *  theName, RTIcap::ObjectClassHandle  whichClass ) = 0;
    virtual char *  getAttributeName ( RTIcap::AttributeHandle  theHandle, RTIcap::ObjectClassHandle  whichClass ) = 0;
    virtual RTIcap::InteractionClassHandle  getInteractionClassHandle ( const char *  theName ) = 0;
    virtual char *  getInteractionClassName ( RTIcap::InteractionClassHandle  theHandle ) = 0;
    virtual RTIcap::ParameterHandle  getParameterHandle ( const char *  theName, RTIcap::InteractionClassHandle  whichClass ) = 0;
    virtual char *  getParameterName ( RTIcap::ParameterHandle  theHandle, RTIcap::InteractionClassHandle  whichClass ) = 0;
    virtual RTIcap::ObjectHandle  getObjectInstanceHandle ( const char *  theName ) = 0;
    virtual char *  getObjectInstanceName ( RTIcap::ObjectHandle  theHandle ) = 0;
    virtual RTIcap::SpaceHandle  getSpaceHandle ( const char *  theName ) = 0;
    virtual char *  getSpaceName ( RTIcap::SpaceHandle  theHandle ) = 0;
    virtual RTIcap::DimensionHandle  getDimensionHandle ( const char *  theName, RTIcap::SpaceHandle  theHandle ) = 0;
    virtual char *  getDimensionName ( RTIcap::DimensionHandle  theDimHandle, RTIcap::SpaceHandle  theSpcHandle ) = 0;
    virtual RTIcap::SpaceHandle  getAttributeRoutingSpaceHandle ( RTIcap::AttributeHandle  theHandle, RTIcap::ObjectClassHandle  whichClass ) = 0;
    virtual RTIcap::ObjectClassHandle  getObjectClass ( RTIcap::ObjectHandle  theHandle ) = 0;
    virtual RTIcap::SpaceHandle  getInteractionRoutingSpaceHandle ( RTIcap::InteractionClassHandle  theHandle ) = 0;
    virtual RTIcap::TransportationHandle  getTransportationHandle ( const char *  theName ) = 0;
    virtual char *  getTransportationName ( RTIcap::TransportationHandle  theHandle ) = 0;
    virtual RTIcap::OrderingHandle  getOrderingHandle ( const char *  theName ) = 0;
    virtual char *  getOrderingName ( RTIcap::OrderingHandle  theHandle ) = 0;
    virtual void enableClassRelevanceAdvisorySwitch (  ) = 0;
    virtual void disableClassRelevanceAdvisorySwitch (  ) = 0;
    virtual void enableAttributeRelevanceAdvisorySwitch (  ) = 0;
    virtual void disableAttributeRelevanceAdvisorySwitch (  ) = 0;
    virtual void enableAttributeScopeAdvisorySwitch (  ) = 0;
    virtual void disableAttributeScopeAdvisorySwitch (  ) = 0;
    virtual void enableInteractionRelevanceAdvisorySwitch (  ) = 0;
    virtual void disableInteractionRelevanceAdvisorySwitch (  ) = 0;
    static RTIServicesInterface_ptr _duplicate(RTIServicesInterface_ptr);
    static RTIServicesInterface_ptr _narrow(CORBA::Object_ptr);
    static RTIServicesInterface_ptr _nil();

    static inline size_t NP_alignedSize(RTIServicesInterface_ptr obj,size_t initialoffset) {
      return CORBA::AlignedObjRef(obj,npacrti_RTIServicesInterface_IntfRepoID,37,initialoffset);
    }

    static inline void marshalObjRef(RTIServicesInterface_ptr obj,NetBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_RTIServicesInterface_IntfRepoID,37,s);
    }

    static inline RTIServicesInterface_ptr unmarshalObjRef(NetBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_RTIServicesInterface_IntfRepoID,s);
      RTIServicesInterface_ptr _result = npacrti::RTIServicesInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static inline void marshalObjRef(RTIServicesInterface_ptr obj,MemBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_RTIServicesInterface_IntfRepoID,37,s);
    }

    static inline RTIServicesInterface_ptr unmarshalObjRef(MemBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_RTIServicesInterface_IntfRepoID,s);
      RTIServicesInterface_ptr _result = npacrti::RTIServicesInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

  protected:

    RTIServicesInterface() {
      if (!is_proxy())
        omniObject::PR_IRRepositoryId(npacrti_RTIServicesInterface_IntfRepoID);
      this->PR_setobj(this);
    }
    virtual ~RTIServicesInterface() {}
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

  private:

    RTIServicesInterface(const RTIServicesInterface&);
    RTIServicesInterface &operator=(const RTIServicesInterface&);
  };

  class _sk_RTIServicesInterface :  public virtual RTIServicesInterface {
  public:

    _sk_RTIServicesInterface() {}
    _sk_RTIServicesInterface(const omniORB::objectKey& k);
    virtual ~_sk_RTIServicesInterface() {}
    RTIServicesInterface_ptr _this() { return RTIServicesInterface::_duplicate(this); }
    void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
    CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
    void _dispose() { _boa()->dispose(this); }
    omniORB::objectKey _key();
    virtual RTIcap::FederateHandle  getFederateHandle ( const char *  theName ) = 0;
    virtual char *  getFederateName ( RTIcap::FederateHandle  theHandle ) = 0;
    virtual void turnRegulationOn (  ) = 0;
    virtual RTIcap::FederationTime  turnRegulationOnNow (  ) = 0;
    virtual void turnRegulationOff (  ) = 0;
    virtual void setTimeConstrained ( RTIcap::Boolean  state ) = 0;
    virtual RTIcap::ObjectClassHandle  getObjectClassHandle ( const char *  theName ) = 0;
    virtual char *  getObjectClassName ( RTIcap::ObjectClassHandle  theHandle ) = 0;
    virtual RTIcap::AttributeHandle  getAttributeHandle ( const char *  theName, RTIcap::ObjectClassHandle  whichClass ) = 0;
    virtual char *  getAttributeName ( RTIcap::AttributeHandle  theHandle, RTIcap::ObjectClassHandle  whichClass ) = 0;
    virtual RTIcap::InteractionClassHandle  getInteractionClassHandle ( const char *  theName ) = 0;
    virtual char *  getInteractionClassName ( RTIcap::InteractionClassHandle  theHandle ) = 0;
    virtual RTIcap::ParameterHandle  getParameterHandle ( const char *  theName, RTIcap::InteractionClassHandle  whichClass ) = 0;
    virtual char *  getParameterName ( RTIcap::ParameterHandle  theHandle, RTIcap::InteractionClassHandle  whichClass ) = 0;
    virtual RTIcap::ObjectHandle  getObjectInstanceHandle ( const char *  theName ) = 0;
    virtual char *  getObjectInstanceName ( RTIcap::ObjectHandle  theHandle ) = 0;
    virtual RTIcap::SpaceHandle  getSpaceHandle ( const char *  theName ) = 0;
    virtual char *  getSpaceName ( RTIcap::SpaceHandle  theHandle ) = 0;
    virtual RTIcap::DimensionHandle  getDimensionHandle ( const char *  theName, RTIcap::SpaceHandle  theHandle ) = 0;
    virtual char *  getDimensionName ( RTIcap::DimensionHandle  theDimHandle, RTIcap::SpaceHandle  theSpcHandle ) = 0;
    virtual RTIcap::SpaceHandle  getAttributeRoutingSpaceHandle ( RTIcap::AttributeHandle  theHandle, RTIcap::ObjectClassHandle  whichClass ) = 0;
    virtual RTIcap::ObjectClassHandle  getObjectClass ( RTIcap::ObjectHandle  theHandle ) = 0;
    virtual RTIcap::SpaceHandle  getInteractionRoutingSpaceHandle ( RTIcap::InteractionClassHandle  theHandle ) = 0;
    virtual RTIcap::TransportationHandle  getTransportationHandle ( const char *  theName ) = 0;
    virtual char *  getTransportationName ( RTIcap::TransportationHandle  theHandle ) = 0;
    virtual RTIcap::OrderingHandle  getOrderingHandle ( const char *  theName ) = 0;
    virtual char *  getOrderingName ( RTIcap::OrderingHandle  theHandle ) = 0;
    virtual void enableClassRelevanceAdvisorySwitch (  ) = 0;
    virtual void disableClassRelevanceAdvisorySwitch (  ) = 0;
    virtual void enableAttributeRelevanceAdvisorySwitch (  ) = 0;
    virtual void disableAttributeRelevanceAdvisorySwitch (  ) = 0;
    virtual void enableAttributeScopeAdvisorySwitch (  ) = 0;
    virtual void disableAttributeScopeAdvisorySwitch (  ) = 0;
    virtual void enableInteractionRelevanceAdvisorySwitch (  ) = 0;
    virtual void disableInteractionRelevanceAdvisorySwitch (  ) = 0;
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return RTIServicesInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  private:
    _sk_RTIServicesInterface (const _sk_RTIServicesInterface&);
    _sk_RTIServicesInterface &operator=(const _sk_RTIServicesInterface&);
  };

  class _proxy_RTIServicesInterface :  public virtual RTIServicesInterface {
  public:

    _proxy_RTIServicesInterface (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
      omniObject(npacrti_RTIServicesInterface_IntfRepoID,r,key,keysize,profiles,release) {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_RTIServicesInterface() {}
    virtual RTIcap::FederateHandle  getFederateHandle ( const char *  theName );
    virtual char *  getFederateName ( RTIcap::FederateHandle  theHandle );
    virtual void turnRegulationOn (  );
    virtual RTIcap::FederationTime  turnRegulationOnNow (  );
    virtual void turnRegulationOff (  );
    virtual void setTimeConstrained ( RTIcap::Boolean  state );
    virtual RTIcap::ObjectClassHandle  getObjectClassHandle ( const char *  theName );
    virtual char *  getObjectClassName ( RTIcap::ObjectClassHandle  theHandle );
    virtual RTIcap::AttributeHandle  getAttributeHandle ( const char *  theName, RTIcap::ObjectClassHandle  whichClass );
    virtual char *  getAttributeName ( RTIcap::AttributeHandle  theHandle, RTIcap::ObjectClassHandle  whichClass );
    virtual RTIcap::InteractionClassHandle  getInteractionClassHandle ( const char *  theName );
    virtual char *  getInteractionClassName ( RTIcap::InteractionClassHandle  theHandle );
    virtual RTIcap::ParameterHandle  getParameterHandle ( const char *  theName, RTIcap::InteractionClassHandle  whichClass );
    virtual char *  getParameterName ( RTIcap::ParameterHandle  theHandle, RTIcap::InteractionClassHandle  whichClass );
    virtual RTIcap::ObjectHandle  getObjectInstanceHandle ( const char *  theName );
    virtual char *  getObjectInstanceName ( RTIcap::ObjectHandle  theHandle );
    virtual RTIcap::SpaceHandle  getSpaceHandle ( const char *  theName );
    virtual char *  getSpaceName ( RTIcap::SpaceHandle  theHandle );
    virtual RTIcap::DimensionHandle  getDimensionHandle ( const char *  theName, RTIcap::SpaceHandle  theHandle );
    virtual char *  getDimensionName ( RTIcap::DimensionHandle  theDimHandle, RTIcap::SpaceHandle  theSpcHandle );
    virtual RTIcap::SpaceHandle  getAttributeRoutingSpaceHandle ( RTIcap::AttributeHandle  theHandle, RTIcap::ObjectClassHandle  whichClass );
    virtual RTIcap::ObjectClassHandle  getObjectClass ( RTIcap::ObjectHandle  theHandle );
    virtual RTIcap::SpaceHandle  getInteractionRoutingSpaceHandle ( RTIcap::InteractionClassHandle  theHandle );
    virtual RTIcap::TransportationHandle  getTransportationHandle ( const char *  theName );
    virtual char *  getTransportationName ( RTIcap::TransportationHandle  theHandle );
    virtual RTIcap::OrderingHandle  getOrderingHandle ( const char *  theName );
    virtual char *  getOrderingName ( RTIcap::OrderingHandle  theHandle );
    virtual void enableClassRelevanceAdvisorySwitch (  );
    virtual void disableClassRelevanceAdvisorySwitch (  );
    virtual void enableAttributeRelevanceAdvisorySwitch (  );
    virtual void disableAttributeRelevanceAdvisorySwitch (  );
    virtual void enableAttributeScopeAdvisorySwitch (  );
    virtual void disableAttributeScopeAdvisorySwitch (  );
    virtual void enableInteractionRelevanceAdvisorySwitch (  );
    virtual void disableInteractionRelevanceAdvisorySwitch (  );

  protected:

    _proxy_RTIServicesInterface () {}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
      return RTIServicesInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
  private:

    _proxy_RTIServicesInterface (const _proxy_RTIServicesInterface&);
    _proxy_RTIServicesInterface &operator=(const _proxy_RTIServicesInterface&);
  };

  class _nil_RTIServicesInterface :   public virtual RTIServicesInterface {
  public:
    _nil_RTIServicesInterface() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
    virtual ~_nil_RTIServicesInterface() {}
    RTIcap::FederateHandle  getFederateHandle ( const char *  theName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::FederateHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getFederateName ( RTIcap::FederateHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void turnRegulationOn (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::FederationTime  turnRegulationOnNow (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::FederationTime _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void turnRegulationOff (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void setTimeConstrained ( RTIcap::Boolean  state ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    RTIcap::ObjectClassHandle  getObjectClassHandle ( const char *  theName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::ObjectClassHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getObjectClassName ( RTIcap::ObjectClassHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::AttributeHandle  getAttributeHandle ( const char *  theName, RTIcap::ObjectClassHandle  whichClass ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::AttributeHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getAttributeName ( RTIcap::AttributeHandle  theHandle, RTIcap::ObjectClassHandle  whichClass ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::InteractionClassHandle  getInteractionClassHandle ( const char *  theName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::InteractionClassHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getInteractionClassName ( RTIcap::InteractionClassHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::ParameterHandle  getParameterHandle ( const char *  theName, RTIcap::InteractionClassHandle  whichClass ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::ParameterHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getParameterName ( RTIcap::ParameterHandle  theHandle, RTIcap::InteractionClassHandle  whichClass ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::ObjectHandle  getObjectInstanceHandle ( const char *  theName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::ObjectHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getObjectInstanceName ( RTIcap::ObjectHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::SpaceHandle  getSpaceHandle ( const char *  theName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::SpaceHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getSpaceName ( RTIcap::SpaceHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::DimensionHandle  getDimensionHandle ( const char *  theName, RTIcap::SpaceHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::DimensionHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getDimensionName ( RTIcap::DimensionHandle  theDimHandle, RTIcap::SpaceHandle  theSpcHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::SpaceHandle  getAttributeRoutingSpaceHandle ( RTIcap::AttributeHandle  theHandle, RTIcap::ObjectClassHandle  whichClass ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::SpaceHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::ObjectClassHandle  getObjectClass ( RTIcap::ObjectHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::ObjectClassHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::SpaceHandle  getInteractionRoutingSpaceHandle ( RTIcap::InteractionClassHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::SpaceHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::TransportationHandle  getTransportationHandle ( const char *  theName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::TransportationHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getTransportationName ( RTIcap::TransportationHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::OrderingHandle  getOrderingHandle ( const char *  theName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::OrderingHandle _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getOrderingName ( RTIcap::OrderingHandle  theHandle ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void enableClassRelevanceAdvisorySwitch (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void disableClassRelevanceAdvisorySwitch (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void enableAttributeRelevanceAdvisorySwitch (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void disableAttributeRelevanceAdvisorySwitch (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void enableAttributeScopeAdvisorySwitch (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void disableAttributeScopeAdvisorySwitch (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void enableInteractionRelevanceAdvisorySwitch (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void disableInteractionRelevanceAdvisorySwitch (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return RTIServicesInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  };

  class RTIServicesInterface_proxyObjectFactory : public proxyObjectFactory {
  public:
    RTIServicesInterface_proxyObjectFactory () {}
    virtual ~RTIServicesInterface_proxyObjectFactory () {}
    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static RTIServicesInterface_ptr _nil() {
      if (!__nil_RTIServicesInterface) {
        __nil_RTIServicesInterface = new _nil_RTIServicesInterface;
      }
      return __nil_RTIServicesInterface;
    }
  private:
    static RTIServicesInterface_ptr __nil_RTIServicesInterface;
  };

#ifndef __npacrti_RTIKernelInterface__
#define __npacrti_RTIKernelInterface__
  class   RTIKernelInterface;
  typedef RTIKernelInterface* RTIKernelInterface_ptr;
  typedef RTIKernelInterface_ptr RTIKernelInterfaceRef;

  class RTIKernelInterface_Helper {
    public:
    static RTIKernelInterface_ptr _nil();
    static CORBA::Boolean is_nil(RTIKernelInterface_ptr p);
    static void release(RTIKernelInterface_ptr p);
    static void duplicate(RTIKernelInterface_ptr p);
    static size_t NP_alignedSize(RTIKernelInterface_ptr obj,size_t initialoffset);
    static void marshalObjRef(RTIKernelInterface_ptr obj,NetBufferedStream &s);
    static RTIKernelInterface_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(RTIKernelInterface_ptr obj,MemBufferedStream &s);
    static RTIKernelInterface_ptr unmarshalObjRef(MemBufferedStream &s);
  };
  typedef _CORBA_ObjRef_Var<RTIKernelInterface,RTIKernelInterface_Helper> RTIKernelInterface_var;

#endif
#define npacrti_RTIKernelInterface_IntfRepoID "IDL:npacrti/RTIKernelInterface:1.0"

  class RTIKernelInterface : public virtual omniObject, public virtual CORBA::Object {
  public:

    virtual FederationManagerInterface_ptr  getFederationManager ( const char *  fedName ) = 0;
    virtual DeclarationManagerInterface_ptr  getDeclarationManager ( const char *  fedName ) = 0;
    virtual ObjectManagerInterface_ptr  getObjectManager ( const char *  fedName ) = 0;
    virtual OwnershipManagerInterface_ptr  getOwnershipManager ( const char *  fedName ) = 0;
    virtual DataDistributionManagerInterface_ptr  getDataDistributionManager ( const char *  fedName ) = 0;
    virtual TimeManagerInterface_ptr  getTimeManager ( const char *  fedName ) = 0;
    virtual RTIServicesInterface_ptr  getRTIServices ( const char *  fedName ) = 0;
    virtual char *  getVersion (  ) = 0;
    virtual RTIcap::RTIambassador_ptr  createRTIAmbassador (  ) = 0;
    virtual void createFederationExecution ( const char *  executionName, const char *  FED ) = 0;
    virtual void destroyFederationExecution ( const char *  executionName ) = 0;
    static RTIKernelInterface_ptr _duplicate(RTIKernelInterface_ptr);
    static RTIKernelInterface_ptr _narrow(CORBA::Object_ptr);
    static RTIKernelInterface_ptr _nil();

    static inline size_t NP_alignedSize(RTIKernelInterface_ptr obj,size_t initialoffset) {
      return CORBA::AlignedObjRef(obj,npacrti_RTIKernelInterface_IntfRepoID,35,initialoffset);
    }

    static inline void marshalObjRef(RTIKernelInterface_ptr obj,NetBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_RTIKernelInterface_IntfRepoID,35,s);
    }

    static inline RTIKernelInterface_ptr unmarshalObjRef(NetBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_RTIKernelInterface_IntfRepoID,s);
      RTIKernelInterface_ptr _result = npacrti::RTIKernelInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static inline void marshalObjRef(RTIKernelInterface_ptr obj,MemBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_RTIKernelInterface_IntfRepoID,35,s);
    }

    static inline RTIKernelInterface_ptr unmarshalObjRef(MemBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_RTIKernelInterface_IntfRepoID,s);
      RTIKernelInterface_ptr _result = npacrti::RTIKernelInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

  protected:

    RTIKernelInterface() {
      if (!is_proxy())
        omniObject::PR_IRRepositoryId(npacrti_RTIKernelInterface_IntfRepoID);
      this->PR_setobj(this);
    }
    virtual ~RTIKernelInterface() {}
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

  private:

    RTIKernelInterface(const RTIKernelInterface&);
    RTIKernelInterface &operator=(const RTIKernelInterface&);
  };

  class _sk_RTIKernelInterface :  public virtual RTIKernelInterface {
  public:

    _sk_RTIKernelInterface() {}
    _sk_RTIKernelInterface(const omniORB::objectKey& k);
    virtual ~_sk_RTIKernelInterface() {}
    RTIKernelInterface_ptr _this() { return RTIKernelInterface::_duplicate(this); }
    void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
    CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
    void _dispose() { _boa()->dispose(this); }
    omniORB::objectKey _key();
    virtual FederationManagerInterface_ptr  getFederationManager ( const char *  fedName ) = 0;
    virtual DeclarationManagerInterface_ptr  getDeclarationManager ( const char *  fedName ) = 0;
    virtual ObjectManagerInterface_ptr  getObjectManager ( const char *  fedName ) = 0;
    virtual OwnershipManagerInterface_ptr  getOwnershipManager ( const char *  fedName ) = 0;
    virtual DataDistributionManagerInterface_ptr  getDataDistributionManager ( const char *  fedName ) = 0;
    virtual TimeManagerInterface_ptr  getTimeManager ( const char *  fedName ) = 0;
    virtual RTIServicesInterface_ptr  getRTIServices ( const char *  fedName ) = 0;
    virtual char *  getVersion (  ) = 0;
    virtual RTIcap::RTIambassador_ptr  createRTIAmbassador (  ) = 0;
    virtual void createFederationExecution ( const char *  executionName, const char *  FED ) = 0;
    virtual void destroyFederationExecution ( const char *  executionName ) = 0;
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return RTIKernelInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  private:
    _sk_RTIKernelInterface (const _sk_RTIKernelInterface&);
    _sk_RTIKernelInterface &operator=(const _sk_RTIKernelInterface&);
  };

  class _proxy_RTIKernelInterface :  public virtual RTIKernelInterface {
  public:

    _proxy_RTIKernelInterface (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
      omniObject(npacrti_RTIKernelInterface_IntfRepoID,r,key,keysize,profiles,release) {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_RTIKernelInterface() {}
    virtual FederationManagerInterface_ptr  getFederationManager ( const char *  fedName );
    virtual DeclarationManagerInterface_ptr  getDeclarationManager ( const char *  fedName );
    virtual ObjectManagerInterface_ptr  getObjectManager ( const char *  fedName );
    virtual OwnershipManagerInterface_ptr  getOwnershipManager ( const char *  fedName );
    virtual DataDistributionManagerInterface_ptr  getDataDistributionManager ( const char *  fedName );
    virtual TimeManagerInterface_ptr  getTimeManager ( const char *  fedName );
    virtual RTIServicesInterface_ptr  getRTIServices ( const char *  fedName );
    virtual char *  getVersion (  );
    virtual RTIcap::RTIambassador_ptr  createRTIAmbassador (  );
    virtual void createFederationExecution ( const char *  executionName, const char *  FED );
    virtual void destroyFederationExecution ( const char *  executionName );

  protected:

    _proxy_RTIKernelInterface () {}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
      return RTIKernelInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
  private:

    _proxy_RTIKernelInterface (const _proxy_RTIKernelInterface&);
    _proxy_RTIKernelInterface &operator=(const _proxy_RTIKernelInterface&);
  };

  class _nil_RTIKernelInterface :   public virtual RTIKernelInterface {
  public:
    _nil_RTIKernelInterface() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
    virtual ~_nil_RTIKernelInterface() {}
    FederationManagerInterface_ptr  getFederationManager ( const char *  fedName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      FederationManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    DeclarationManagerInterface_ptr  getDeclarationManager ( const char *  fedName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      DeclarationManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    ObjectManagerInterface_ptr  getObjectManager ( const char *  fedName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      ObjectManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    OwnershipManagerInterface_ptr  getOwnershipManager ( const char *  fedName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      OwnershipManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    DataDistributionManagerInterface_ptr  getDataDistributionManager ( const char *  fedName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      DataDistributionManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    TimeManagerInterface_ptr  getTimeManager ( const char *  fedName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      TimeManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIServicesInterface_ptr  getRTIServices ( const char *  fedName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIServicesInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    char *  getVersion (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      char * _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIcap::RTIambassador_ptr  createRTIAmbassador (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIcap::RTIambassador_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    void createFederationExecution ( const char *  executionName, const char *  FED ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

    void destroyFederationExecution ( const char *  executionName ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      return;
#endif
    }

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return RTIKernelInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  };

  class RTIKernelInterface_proxyObjectFactory : public proxyObjectFactory {
  public:
    RTIKernelInterface_proxyObjectFactory () {}
    virtual ~RTIKernelInterface_proxyObjectFactory () {}
    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static RTIKernelInterface_ptr _nil() {
      if (!__nil_RTIKernelInterface) {
        __nil_RTIKernelInterface = new _nil_RTIKernelInterface;
      }
      return __nil_RTIKernelInterface;
    }
  private:
    static RTIKernelInterface_ptr __nil_RTIKernelInterface;
  };

#ifndef __npacrti_FederationExecutionInterface__
#define __npacrti_FederationExecutionInterface__
  class   FederationExecutionInterface;
  typedef FederationExecutionInterface* FederationExecutionInterface_ptr;
  typedef FederationExecutionInterface_ptr FederationExecutionInterfaceRef;

  class FederationExecutionInterface_Helper {
    public:
    static FederationExecutionInterface_ptr _nil();
    static CORBA::Boolean is_nil(FederationExecutionInterface_ptr p);
    static void release(FederationExecutionInterface_ptr p);
    static void duplicate(FederationExecutionInterface_ptr p);
    static size_t NP_alignedSize(FederationExecutionInterface_ptr obj,size_t initialoffset);
    static void marshalObjRef(FederationExecutionInterface_ptr obj,NetBufferedStream &s);
    static FederationExecutionInterface_ptr unmarshalObjRef(NetBufferedStream &s);
    static void marshalObjRef(FederationExecutionInterface_ptr obj,MemBufferedStream &s);
    static FederationExecutionInterface_ptr unmarshalObjRef(MemBufferedStream &s);
  };
  typedef _CORBA_ObjRef_Var<FederationExecutionInterface,FederationExecutionInterface_Helper> FederationExecutionInterface_var;

#endif
#define npacrti_FederationExecutionInterface_IntfRepoID "IDL:npacrti/FederationExecutionInterface:1.0"

  class FederationExecutionInterface :  public virtual FederationManagerInterface {
  public:

    virtual FederationManagerInterface_ptr  getFederationManager (  ) = 0;
    virtual DeclarationManagerInterface_ptr  getDeclarationManager (  ) = 0;
    virtual ObjectManagerInterface_ptr  getObjectManager (  ) = 0;
    virtual OwnershipManagerInterface_ptr  getOwnershipManager (  ) = 0;
    virtual DataDistributionManagerInterface_ptr  getDataDistributionManager (  ) = 0;
    virtual TimeManagerInterface_ptr  getTimeManager (  ) = 0;
    virtual RTIServicesInterface_ptr  getRTIServices (  ) = 0;
    static FederationExecutionInterface_ptr _duplicate(FederationExecutionInterface_ptr);
    static FederationExecutionInterface_ptr _narrow(CORBA::Object_ptr);
    static FederationExecutionInterface_ptr _nil();

    static inline size_t NP_alignedSize(FederationExecutionInterface_ptr obj,size_t initialoffset) {
      return CORBA::AlignedObjRef(obj,npacrti_FederationExecutionInterface_IntfRepoID,45,initialoffset);
    }

    static inline void marshalObjRef(FederationExecutionInterface_ptr obj,NetBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_FederationExecutionInterface_IntfRepoID,45,s);
    }

    static inline FederationExecutionInterface_ptr unmarshalObjRef(NetBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_FederationExecutionInterface_IntfRepoID,s);
      FederationExecutionInterface_ptr _result = npacrti::FederationExecutionInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static inline void marshalObjRef(FederationExecutionInterface_ptr obj,MemBufferedStream &s) {
      CORBA::MarshalObjRef(obj,npacrti_FederationExecutionInterface_IntfRepoID,45,s);
    }

    static inline FederationExecutionInterface_ptr unmarshalObjRef(MemBufferedStream &s) {
      CORBA::Object_ptr _obj = CORBA::UnMarshalObjRef(npacrti_FederationExecutionInterface_IntfRepoID,s);
      FederationExecutionInterface_ptr _result = npacrti::FederationExecutionInterface::_narrow(_obj);
      CORBA::release(_obj);
      return _result;
    }

    static CORBA::Boolean _0RL_is_a(const char *base_repoId);

  protected:

    FederationExecutionInterface() {
      if (!is_proxy())
        omniObject::PR_IRRepositoryId(npacrti_FederationExecutionInterface_IntfRepoID);
      this->PR_setobj(this);
    }
    virtual ~FederationExecutionInterface() {}
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id=0);

  private:

    FederationExecutionInterface(const FederationExecutionInterface&);
    FederationExecutionInterface &operator=(const FederationExecutionInterface&);
  };

  class _sk_FederationExecutionInterface :  public virtual _sk_FederationManagerInterface, public virtual FederationExecutionInterface {
  public:

    _sk_FederationExecutionInterface() {}
    _sk_FederationExecutionInterface(const omniORB::objectKey& k);
    virtual ~_sk_FederationExecutionInterface() {}
    FederationExecutionInterface_ptr _this() { return FederationExecutionInterface::_duplicate(this); }
    void _obj_is_ready(CORBA::BOA_ptr boa) { boa->obj_is_ready(this); }
    CORBA::BOA_ptr _boa() { return CORBA::BOA::getBOA(); }
    void _dispose() { _boa()->dispose(this); }
    omniORB::objectKey _key();
    virtual FederationManagerInterface_ptr  getFederationManager (  ) = 0;
    virtual DeclarationManagerInterface_ptr  getDeclarationManager (  ) = 0;
    virtual ObjectManagerInterface_ptr  getObjectManager (  ) = 0;
    virtual OwnershipManagerInterface_ptr  getOwnershipManager (  ) = 0;
    virtual DataDistributionManagerInterface_ptr  getDataDistributionManager (  ) = 0;
    virtual TimeManagerInterface_ptr  getTimeManager (  ) = 0;
    virtual RTIServicesInterface_ptr  getRTIServices (  ) = 0;
    virtual CORBA::Boolean dispatch(GIOP_S &s,const char *op,CORBA::Boolean response);

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return FederationExecutionInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  private:
    _sk_FederationExecutionInterface (const _sk_FederationExecutionInterface&);
    _sk_FederationExecutionInterface &operator=(const _sk_FederationExecutionInterface&);
  };

  class _proxy_FederationExecutionInterface :  public virtual _proxy_FederationManagerInterface, public virtual FederationExecutionInterface {
  public:

    _proxy_FederationExecutionInterface (Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release) :
      omniObject(npacrti_FederationExecutionInterface_IntfRepoID,r,key,keysize,profiles,release) {
        omni::objectIsReady(this);
    }
    virtual ~_proxy_FederationExecutionInterface() {}
    virtual FederationManagerInterface_ptr  getFederationManager (  );
    virtual DeclarationManagerInterface_ptr  getDeclarationManager (  );
    virtual ObjectManagerInterface_ptr  getObjectManager (  );
    virtual OwnershipManagerInterface_ptr  getOwnershipManager (  );
    virtual DataDistributionManagerInterface_ptr  getDataDistributionManager (  );
    virtual TimeManagerInterface_ptr  getTimeManager (  );
    virtual RTIServicesInterface_ptr  getRTIServices (  );

  protected:

    _proxy_FederationExecutionInterface () {}

    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type) {
      return FederationExecutionInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type);
    }
  private:

    _proxy_FederationExecutionInterface (const _proxy_FederationExecutionInterface&);
    _proxy_FederationExecutionInterface &operator=(const _proxy_FederationExecutionInterface&);
  };

  class _nil_FederationExecutionInterface :  public virtual _nil_FederationManagerInterface,   public virtual FederationExecutionInterface {
  public:
    _nil_FederationExecutionInterface() : omniObject(omniObject::nilObjectManager()) { this->PR_setobj(0); }
    virtual ~_nil_FederationExecutionInterface() {}
    FederationManagerInterface_ptr  getFederationManager (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      FederationManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    DeclarationManagerInterface_ptr  getDeclarationManager (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      DeclarationManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    ObjectManagerInterface_ptr  getObjectManager (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      ObjectManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    OwnershipManagerInterface_ptr  getOwnershipManager (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      OwnershipManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    DataDistributionManagerInterface_ptr  getDataDistributionManager (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      DataDistributionManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    TimeManagerInterface_ptr  getTimeManager (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      TimeManagerInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

    RTIServicesInterface_ptr  getRTIServices (  ){
      throw CORBA::BAD_OPERATION(0,CORBA::COMPLETED_NO);
#ifdef NEED_DUMMY_RETURN
      // never reach here! Dummy return to keep some compilers happy.
      RTIServicesInterface_ptr _0RL_result = 0;
      return _0RL_result;
#endif
    }

  protected:
    virtual void *_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id) {
      return FederationExecutionInterface::_widenFromTheMostDerivedIntf(repoId,is_cxx_type_id);
    }
  };

  class FederationExecutionInterface_proxyObjectFactory : public proxyObjectFactory {
  public:
    FederationExecutionInterface_proxyObjectFactory () {}
    virtual ~FederationExecutionInterface_proxyObjectFactory () {}
    virtual const char *irRepoId() const;
    virtual CORBA::Object_ptr newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release);
    virtual CORBA::Boolean is_a(const char *base_repoId) const;
    static FederationExecutionInterface_ptr _nil() {
      if (!__nil_FederationExecutionInterface) {
        __nil_FederationExecutionInterface = new _nil_FederationExecutionInterface;
      }
      return __nil_FederationExecutionInterface;
    }
  private:
    static FederationExecutionInterface_ptr __nil_FederationExecutionInterface;
  };

};

#endif // __npacrti_hh__
