/**
*
* This file reads DIF definition and produces HTML file. 
*
* @date August 15, 1998 ( Last Updated on August 15, 1998 )
* @author H. Timucin Ozdemir
*
*/
import com.microstar.xml.XmlParser; // for org.xml.sax implementation

import java.io.PrintStream;
import java.io.FileOutputStream;

import com.docuverse.freedom.*;    // for org.w3c.dom implementation 

import org.w3c.dom.*;

import owrti.xml.*;                // for owrti.xml.DIFDocument object
import owrti.util.*;               // for owrti.xml.DIFParser object

public class diftohtml 
{

  /** */ 
  public static void 
  main (String args[]) throws Exception
  {
    /** Default output media is stamdard output */
    PrintStream out = System.out;

    if (args.length < 1) 
    {
      System.err.println("Usage: java diftohml <file> [<output_file_name>]");
      System.exit(1);
    }

    /** Define the output file stream */
    if(args.length >1 )
    {
      out = new PrintStream( new FileOutputStream(args[1])); 
    }

    System.out.println("~~~~Let's see~~~~~");

    /** Define the DIFDocument object which extract the info from dom */
    DIFParser   parser = new DIFParser();
    DIFDocument dif = parser.parseFile(args[0]);

    System.out.println(" Federation Name: "+dif.getFederationName());

    /** Let's see what it looks like in HLAML format */
    DIFtoHTMLProcessor.processDIF(dif,out);

  }// end of main()

}// end of diftohml
