/**
*
* This file reads HLAML definition and produces DIF file. 
*
* @date August 11, 1998 ( Last Updated on August 12, 1998 )
* @author H. Timucin Ozdemir
*
*/
import com.microstar.xml.XmlParser; // for org.xml.sax implementation

import java.io.PrintStream;
import java.io.FileOutputStream;

import com.docuverse.freedom.*;    // for org.w3c.dom implementation 

import org.w3c.dom.*;

import owrti.xml.*;                // for owrti.xml.DIFDocument object

public class hmltodif 
{

  /** */ 
  public static void 
  main (String args[]) throws Exception
  {
    /** Default output media is stamdard output */
    PrintStream out = System.out;

    if (args.length < 1) 
    {
      System.err.println("Usage: java hmltodif <file> [<output_file_name>]");
      System.exit(1);
    }

    /** Define the output file stream */
    if(args.length >1 )
    {
      out = new PrintStream( new FileOutputStream(args[1])); 
    }

    /** Define the dom object */
    Freedom dom = new Freedom("com.docuverse.freedom.SAXDriver");

    /** Define the XMLParser object */
    dom.setProperty("sax.driver","com.microstar.xml.SAXDriver");

    /** Note that for file names 'makeAbsoluteURL' is critical */
    Document doc = dom.openDocument(DIFDocument.makeAbsoluteURL(args[0]));

    System.out.println("~~~~Let's see~~~~~");

    /** Define the DIFDocument object which extract the info from dom */
    DIFDocument dif = new DIFDocument(doc);

    System.out.println(" Federation Name: "+dif.getFederationName());

    /** Let's see what it looks like in DIF format */
    dif.printDIF(out);

  }// end of main()

}// end of hmltodif
