package owrti;
/**
*
*/

import RTIcap.*;
import java.util.*;

/**
*/
public class 
AttributeInfoNaming  extends GlbNaming implements RTIDebug
{
   ObjectInstanceRecord father;

   /**
   */ 
   public
   AttributeInfoNaming(ObjectInstanceRecord _boss) 
   { father = _boss; }

   /**
   */ 
   public Enumeration getAllNames() { return nameToId.keys(); }

   /**
   */ 
   public short[]
   getAllHandles() 
   { 
      short[] ret = new short[idToName.size()];
      Enumeration e = idToName.keys();
      int i, number_of_handles=0;
      Short ky;

      for(;e.hasMoreElements();)
      {
         ky = (Short) e.nextElement();
         if( ky != null ) ret[number_of_handles++] = ky.shortValue();

      }// end of for

      if(number_of_handles!=idToName.size())
      {
         short[] rt1 = new short[number_of_handles];
         for(i=0;i<number_of_handles;i++) rt1[i] = ret[i];
         ret = rt1;

      }// end of if

      return ret;

   }// end of getAllHandles()

   /**
   */
   public String 
   getAttributeName(short theHandle) throws RTIcap.AttributeNotDefined 
   {
       String ret = getName(new Short(theHandle));

       if(ret==null) throw new RTIcap.AttributeNotDefined();

       return ret;

   }// end of getAttributeName()

   /**
   */
   public short 
   getAttributeHandle(String theName) throws RTIcap.NameNotFound 
   {
       Short ret= (Short) getID(theName);

       if(ret==null) throw new RTIcap.NameNotFound();

       return ret.shortValue();

   }// end of getAttributeHandle()

   /**
   */
   public short 
   addAttributeInfo(AttributeInfo att)
   {
       addEntry(new Short(att.getHandle()),att.getName(),att);
       return att.getHandle();

   }// end of addAttribute()

   /**
   */
   public int 
   getNumberOfAttributes() { return nameToId.size(); }

   /**
   */
   public AttributeInfo 
   getAttributeInfo(String theName) throws RTIcap.NameNotFound 
   {
       Short ret= (Short) getID(theName);

       if(ret==null) throw new RTIcap.NameNotFound();

       return (AttributeInfo) getRecord(ret);

   }// end of getAttributeInfo()

   /**
   */
   public AttributeInfo 
   getAttributeInfo(short theHandle) 
   {
       return (AttributeInfo) getRecord(new Short(theHandle));

   }// end of getAttributeInfo()

}// end of class AttributeInfoNaming

