/**
*
*/
package owrti;

import RTIcap.*;
import java.util.*;

/**
*/
public class AttributeNaming  implements RTIDebug
{
   ObjectRecord father;
   Hashtable idToName = new Hashtable();
   Hashtable nameToId = new Hashtable();

   /**
   */ 
   public
   AttributeNaming(ObjectRecord _boss) 
   { father = _boss; }

   /**
   */ 
   public Enumeration
   getAllNames() { return nameToId.keys(); }

   /**
   */ 
   public short[]
   getAllHandles() 
   { 
      short[] ret = new short[idToName.size()];
      Enumeration e = idToName.keys();
      int i, number_of_handles=0;
      Short ky;

      for(;e.hasMoreElements();)
      {
         ky = (Short) e.nextElement();
         if( ky != null ) ret[number_of_handles++] = ky.shortValue();

      }// end of for

      if(number_of_handles!=idToName.size())
      {
         short[] rt1 = new short[number_of_handles];
         for(i=0;i<number_of_handles;i++) rt1[i] = ret[i];
         ret = rt1;

      }// end of if

      return ret;

   }// end of getAllHandles()

   /**
   */
   public String 
   getAttributeName(short theHandle) throws RTIcap.AttributeNotDefined 
   {
       String ret = (String) idToName.get( new Short(theHandle)); 

       if(ret==null) throw new RTIcap.AttributeNotDefined();

       return ret;

   }// end of getAttributeName()

   /**
   */
   public short 
   getAttributeHandle(String theName) throws RTIcap.NameNotFound 
   {
       Short ret= (Short) nameToId.get(theName);

       if(ret==null) throw new RTIcap.NameNotFound();

       return ret.shortValue();

   }// end of getAttributeHandle()

   /**
   */
   public short 
   addAttribute(String theName)
   {
       if(DEBUG) System.out.println(" in addAttribute() of AttributeNaming ");

       short cnt = (short) (nameToId.size()+1);
       
       idToName.put(new Short(cnt),theName);
       nameToId.put(theName, new Short(cnt)); 

       if(DEBUG) System.out.println(" cnt "+cnt);

       return cnt;

   }// end of addAttribute()

   public int getNumberOfAttributes() { return nameToId.size(); }


}// end of class AttributeNaming

