package owrti;

import RTIcap.*;
import java.util.*;

/**
*
* @date May 02, 1998 ( Updated at May 02, 1998 )
* @author H. Timucin Ozdemir
*
*/
public class 
DimensionNaming extends GlbNaming implements RTIDebug
{

   public 
   DimensionNaming() {}

   /**
   */
   public int 
   getDimensionHandle(String theName) throws RTIcap.NameNotFound
   {
       Integer ret = (Integer) getID(theName);

       if ( ret==null) throw new RTIcap.NameNotFound();

       return ret.intValue();

   }// end of getDimensionHandle()

   /**
   */
   public String 
   getDimensionName(int theHandle) throws RTIcap.DimensionNotDefined
   {
       String ret = (String) getName(new Integer(theHandle));

       if ( ret==null) throw new RTIcap.DimensionNotDefined();

       return ret;

   }// end of getDimensionName()

   /**
   */
   public DimensionInfo 
   getDimensionInfo(int theHandle) throws RTIcap.NameNotFound
   {
       DimensionInfo ret = (DimensionInfo) getRecord(new Integer(theHandle));

       if ( ret==null) throw new RTIcap.NameNotFound();

       return ret;

   }// end of getDimensionInfo()

   /**
   */
   public void 
   addDimensionInfo(int theHandle, String Name)
   {
       addEntry(new Integer(theHandle),Name, new DimensionInfo((short)theHandle,Name,0,1.0));
   }// end of addDimensionInfo()

   /**
   */
   public void 
   addDimensionInfo(DimensionInfo rec)
   {
       addEntry( new Integer(rec.getHandle()), rec.getName(), rec ); 
   }// end of addDimensionInfo()

   public int getSize() { return idToName.size(); }

   public Enumeration getKeys() { return idToName.keys(); }

}// end of class DimensionNaming
