package owrti;

import RTIcap.*;

/**
* Requires ObjectID, ClassID
*/
public class 
EvtAttributeOwnershipDivestitureNotification implements RTIEvent, RTIDebug 
{

   int ObjectID;
   double timeStamp;
   short  theFederate;
   short[] attribs;

   /**
   */
   public EvtAttributeOwnershipDivestitureNotification( int _ObjectID, 
          short [] _attribs, short _theFederate )
   {
      theFederate = _theFederate;
      ObjectID = _ObjectID;
      timeStamp = -1;
      attribs = _attribs; 
   }// end of CONSTRUCTOR
   
   /**
   */
   public EvtAttributeOwnershipDivestitureNotification( int _ObjectID, 
          short [] _attribs, short _theFederate, double _timeStamp )
   {
      theFederate = _theFederate;
      ObjectID = _ObjectID;
      timeStamp = _timeStamp;
      attribs = _attribs; 
   }// end of CONSTRUCTOR

   /**
   */
   public EvtAttributeOwnershipDivestitureNotification( int _ObjectID, 
          short  _attribs, short _theFederate )
   {
      theFederate = _theFederate;
      ObjectID = _ObjectID;
      timeStamp = -1;
      attribs = new short[1];
      attribs[0] = _attribs; 
   }// end of CONSTRUCTOR
   
   /**
   */
   public EvtAttributeOwnershipDivestitureNotification( int _ObjectID, 
          short _attribs, short _theFederate, double _timeStamp )
   {
      theFederate = _theFederate;
      ObjectID = _ObjectID;
      timeStamp = _timeStamp;
      attribs = new short[1];
      attribs[0] = _attribs; 
   }// end of CONSTRUCTOR

   /**
   */
   public double
   getTimeStamp() {  return timeStamp; }

   /**
   */
   public void 
   execute(RTIcap.FederateAmbassador fed) 
   {
      try
      {
         fed.attributeOwnershipDivestitureNotification(ObjectID,attribs);

      } catch(RTIcap.ObjectNotKnown fie) {}
        catch(RTIcap.AttributeNotKnown cnd) {}
        catch(RTIcap.FederateInternalError cnd) {}
        catch(RTIcap.AttributeDivestitureWasNotRequested adwnr) {}
        catch(RTIcap.AttributeNotOwned ano) {}

   }// end of execute()

}// end of class EvtAttributeOwnershipDivestitureNotification

