package owrti;

import RTIcap.*;

/**
* Requires ObjectID, ClassID
*/
public class EvtDiscoverObject implements RTIEvent, RTIDebug 
{

   int ObjectID;
   int ClassID;
   double timeStamp;
   short  theFederate;

   /**
   */
   public EvtDiscoverObject( int _ObjectID, int _ClassID, short _theFederate )
   {
      theFederate = _theFederate;
      ObjectID = _ObjectID;
      ClassID  = _ClassID;
      timeStamp = -1;
   }// end of CONSTRUCTOR
   
   /**
   */
   public EvtDiscoverObject( int _ObjectID, int _ClassID, short _theFederate, 
                             double _timeStamp )
   {
      theFederate = _theFederate;
      ObjectID = _ObjectID;
      ClassID  = _ClassID;
      timeStamp = _timeStamp;
   }// end of CONSTRUCTOR

   /**
   */
   public double
   getTimeStamp() {  return timeStamp; }

   /**
   */
   public void 
   execute(RTIcap.FederateAmbassador fed) 
   {
      RTIcap.EventRetractionHandle retract = 
                new RTIcap.EventRetractionHandle(timeStamp,0,theFederate);

      String tag  = new String("discover");

      try
      {
         fed.discoverObjectInstance(ObjectID,(short)ClassID);
//,timeStamp,tag,retract);

      } catch(RTIcap.FederateInternalError fie) {}
        catch(RTIcap.CouldNotDiscover cnd) {}
        catch(RTIcap.ObjectClassNotKnown ocnk) {}
        catch(RTIcap.InvalidFederationTime ift) {}

   }// end of execute()

   /**
   */
   public String
   toString()
   {
      return new String(" discoverObjectInstance cID : "+ClassID+" oID : "+ObjectID);

   }// end of toString()

}// end of class EvtDiscoverObject

