package owrti;

import RTIcap.*;

/**
* Requires ObjectID, ClassID
*/
public class EvtProvideAttributeValueUpdate implements RTIEvent, RTIDebug 
{

   int ObjectID;
   short[] attribs;
   double timeStamp = -1;

   /**
   */
   public 
   EvtProvideAttributeValueUpdate( int _ObjectID, short[] _attribs)
   {
      ObjectID = _ObjectID;
      attribs = _attribs;
   }// end of CONSTRUCTOR
   

   /**
   */
   public double
   getTimeStamp() {  return timeStamp; }

   /**
   */
   public void 
   execute(RTIcap.FederateAmbassador fed) 
   {
      try
      {  fed.provideAttributeValueUpdate(ObjectID, attribs);
      } catch(RTIcap.ObjectNotKnown onk) {}
        catch(RTIcap.FederateInternalError fie) {}
        catch(RTIcap.AttributeNotKnown ank) {}
        catch(RTIcap.AttributeNotOwned ano) {}

   }// end of execute()

   /**
   */
   public String
   toString()
   {
      String ret = new String("provideAttributeValueUpdate oID: "+ObjectID);
      if(attribs.length>0) 
      {
         ret += (" a: "+attribs[0]);
         for(int i=1;i<attribs.length;i++) ret += (","+attribs[i]);

      }// end of if

      return ret;

   }// end of toString()

}// end of class EvtProvideAttributeValueUpdate

