package owrti;

import RTIcap.*;

/**
* Requires ObjectID, ClassID
*/
public class EvtReceiveInteraction implements RTIEvent, RTIDebug 
{

   int InterClassID;
   RTIcap.ParameterHandleValuePair[] attribs;
   double timeStamp;
   String tag;
   RTIcap.EventRetractionHandle evtRetract;

   /**
   */
   public 
   EvtReceiveInteraction( int _InterClassID, 
          RTIcap.ParameterHandleValuePair[] _attribs, String _tag )
   {
      InterClassID = _InterClassID;
      timeStamp = -1;
      evtRetract = null;
      attribs = _attribs;
      tag = _tag;
   }// end of CONSTRUCTOR
   
   /**
   */
   public 
   EvtReceiveInteraction( int _InterClassID, 
          RTIcap.ParameterHandleValuePair[] _attribs, String _tag, 
          RTIcap.EventRetractionHandle _evtRetract, double _timeStamp)
   {
      InterClassID = _InterClassID;
      timeStamp = _timeStamp;
      evtRetract = _evtRetract;
      attribs = _attribs;
      tag = _tag;
   }// end of CONSTRUCTOR

   /**
   */
   public double
   getTimeStamp() {  return timeStamp; }

   /**
   */
   public void 
   execute(RTIcap.FederateAmbassador fed) 
   {

      
      try
      {

         if(timeStamp>0)
          fed.receiveInteractionWithTime((short)InterClassID,attribs,timeStamp,tag,evtRetract);
         else
          fed.receiveInteraction((short)InterClassID,attribs,tag);

      } catch(RTIcap.FederateInternalError fie) {}
        catch(RTIcap.InteractionParameterNotKnown ipnk) {}
        catch(RTIcap.InteractionClassNotKnown icnk) {}
        catch(RTIcap.InvalidFederationTime ift) {}

   }// end of execute()

}// end of class EvtReceiveInteraction

