package owrti;

import RTIcap.*;
import org.omg.CORBA.*;

/**
* Requires ObjectID, ClassID
*/
public class EvtReflectAttributeValues implements RTIEvent, RTIDebug 
{

   int ObjectID;
   RTIcap.AttributeHandleValuePair[] attribs;
   double timeStamp;
   String tag;
   RTIcap.EventRetractionHandle evtRetract;

   /**
   */
   public 
   EvtReflectAttributeValues( int _ObjectID, 
          RTIcap.AttributeHandleValuePair[] _attribs, String tag )
   {
      ObjectID = _ObjectID;
      timeStamp = -1;
      evtRetract = null;
      attribs = _attribs;
   }// end of CONSTRUCTOR
   
   /**
   */
   public 
   EvtReflectAttributeValues( int _ObjectID, 
          RTIcap.AttributeHandleValuePair[] _attribs, String _tag, 
          RTIcap.EventRetractionHandle _evtRetract, double _timeStamp)
   {
      ObjectID = _ObjectID;
      timeStamp = _timeStamp;
      evtRetract = _evtRetract;
      attribs = _attribs;
      tag = _tag;
   }// end of CONSTRUCTOR

   /**
   */
   public double
   getTimeStamp() {  return timeStamp; }

   /**
   */
   public void 
   execute(RTIcap.FederateAmbassador fed) 
   {

      try
      {
         
         if(timeStamp>0)
           fed.reflectAttributeValuesWithTime(ObjectID,attribs,timeStamp,tag,evtRetract);
         else 
           fed.reflectAttributeValues(ObjectID,attribs,tag);

      } catch(RTIcap.ObjectNotKnown onk) {}
        catch(RTIcap.AttributeNotKnown ank) {}
        catch(RTIcap.FederateInternalError fie) {}
        catch(RTIcap.InvalidFederationTime ift) {}
        catch(RTIcap.FederateOwnsAttributes foa) {}
        catch(org.omg.CORBA.SystemException sexp) {}

   }// end of execute()

   /**
   */
   public String
   toString() 
   {  
      String ret = new String(" reflectAttributeValuesWithTime oId :"+ObjectID);
      if(attribs.length>0)
      {
         ret += " a : ";
         for(int i=0;i <attribs.length;i++) 
             ret += (","+attribs[i].handle+" "+toHexStr(attribs[i].value));

      }// end of if

      return ret; 

   }// end of toString()

   final String
   toHexStr(byte[] value)
   {
      String ret = new String();
      char crr[] = new char[2] ;
      
      for(int i=0;i<value.length;i++)
      {
         byte hi = (byte)( ( value[i]>>4 ) & 0x0f );
         byte lo = (byte)( value[i] & 0x0f );

         if(hi<10) crr[0] = (char)hi;
         else crr[0] = (char)(hi-10+'a');

         if(lo<10) crr[1] = (char)lo;
         else crr[1] = (char)(lo-10+'a');

         ret += (crr[0]+crr[1]);

      }// end of for

      return ret;

   }// end of toHexStr()

}// end of class EvtReflectAttributeValues

