package owrti;

import RTIcap.*;

/**
* Requires ObjectID, ClassID
*
* @date April 28, 1998 ( Updated at April 28, 1998)
* @author H. Timucin Ozdemir
*
*/
public class EvtRemoveObjectInstance implements RTIEvent, RTIDebug 
{

   int ObjectID;
   double timeStamp;
   String tag;
   ObjectRemovalReason reason = ObjectRemovalReason.OBJECT_DELETED;
   RTIcap.EventRetractionHandle evtRetract;

   /**
   */
   public EvtRemoveObjectInstance( int _ObjectID, String _tag, 
          RTIcap.EventRetractionHandle _evtRetract)
   {
      ObjectID = _ObjectID;
      timeStamp = -1;
      evtRetract = _evtRetract;
      tag = _tag;
   }// end of CONSTRUCTOR
   
   /**
   */
   public EvtRemoveObjectInstance( int _ObjectID, String _tag, 
          RTIcap.EventRetractionHandle _evtRetract, double _timeStamp)
   {
      ObjectID = _ObjectID;
      timeStamp = _timeStamp;
      evtRetract = _evtRetract;
   }// end of CONSTRUCTOR

   /**
   */
   public double
   getTimeStamp() {  return timeStamp; }

   /**
   */
   public void 
   execute(RTIcap.FederateAmbassador fed) 
   {
       try
       {
         if(timeStamp>=0) 
            fed.removeObjectInstanceWithTime(ObjectID,timeStamp,tag,evtRetract);
         else
            fed.removeObjectInstance(ObjectID,tag);

       } catch(RTIcap.ObjectNotKnown onk) {}
         catch(RTIcap.InvalidFederationTime ift) {}
         catch(RTIcap.FederateInternalError fie) {}

   }// end of execute()

}// end of class EvtRemoveObjectInstance

