package owrti;

import RTIcap.*;

/**
* Requires ObjectID, ClassID
*
* @date May 06, 1998 ( Update at May 06, 1998 )
* @author H. Timucin Ozdemir
*
*/
public class 
EvtRequestAttributeOwnershipRelease implements RTIEvent, RTIDebug 
{

      AttributeInfo  att;
                int  ObjectID;
             double  timeStamp;
              short  theFederate;
              short  attribs;
             String  tag;

   /**
   */
   public EvtRequestAttributeOwnershipRelease( int _ObjectID, short _attribs, 
          String _tag, short _theFederate, AttributeInfo _att )
   {
      theFederate = _theFederate;
      ObjectID = _ObjectID;
      timeStamp = -1;
      attribs = _attribs; 
      att = _att;
      tag = _tag;
   }// end of CONSTRUCTOR

   /**
   */
   public EvtRequestAttributeOwnershipRelease( int _ObjectID, short _attribs, 
          String _tag, short _theFederate, double _timeStamp, AttributeInfo _att )
   {
      theFederate = _theFederate;
      ObjectID = _ObjectID;
      timeStamp = _timeStamp;
      attribs = _attribs; 
      att = _att;
      tag = _tag;

   }// end of CONSTRUCTOR

   /**
   */
   public double
   getTimeStamp() {  return timeStamp; }

   /**
   */
   public void 
   execute(RTIcap.FederateAmbassador fed) 
   {
      short[] attHnds = new short[1];
      attHnds[0] = attribs;

      try
      {
         fed.requestAttributeOwnershipRelease(ObjectID,attHnds,tag);

      } catch(RTIcap.ObjectNotKnown fie) {}
        catch(RTIcap.AttributeNotKnown cnd) {}
        catch(RTIcap.FederateInternalError cnd) {}
        catch(RTIcap.AttributeNotOwned ano) {}

      att.resetOwnershipAcqusitionInProgress();

   }// end of execute()

   /**
   */
   public String
   toString()
   {
      String ret = new String(" requestAttributeOwnershipRelease ");
      ret += (" oID : "+ObjectID+" att : "+attribs+" @ "+timeStamp); 
      return ret;

   }// end of toString()

}// end of class EvtRequestAttributeOwnershipRelease

