package owrti;

import RTIcap.*;

/**
*/
public class 
EvtStartUpdate implements RTIEvent, RTIDebug 
{

   int ClassID;
   short[] attribs;
   double timeStamp;
   short  theFederate;

   /**
   */
   public 
   EvtStartUpdate( int _ClassID, short[] _attribs, short _theFederate )
   {
      theFederate = _theFederate;
      attribs = _attribs;
      ClassID  = _ClassID;
      timeStamp = -1;

   }// end of CONSTRUCTOR
   
   /**
   */
   public 
   EvtStartUpdate( int _ClassID, short[] _attribs, short _theFederate,
                   double _timeStamp )
   {
      theFederate = _theFederate;
      attribs = _attribs;
      ClassID  = _ClassID;
      timeStamp = _timeStamp;

   }// end of CONSTRUCTOR

   /**
   */
   public double
   getTimeStamp() {  return timeStamp; }

   /**
   */
   public void 
   execute(RTIcap.FederateAmbassador fed) 
   {
      try
      {
         fed.startUpdates((short)ClassID,attribs);

      } catch(RTIcap.FederateInternalError fie) {}
        catch(RTIcap.ObjectClassNotPublished ocnk) {}
        catch(RTIcap.AttributeNotPublished ocnk) {}

   }// end of execute()

   /**
   */
   public final String
   toString()
   { 
      String ret = new String( " StartUpdate for fID : "+theFederate+
                               " clID : "+ClassID );

      for(int i=0;i<attribs.length;i++) ret += (" a: "+attribs[i]);
      ret += (" @ "+timeStamp);

      return ret;

   }// end of toString()

}// end of class EvtStartUpdate

