package owrti;

import RTIcap.*;
import java.util.*;

/*
* Defines the RTI Services 
*/
public class ParameterNaming implements RTIDebug
{
    InteractionRecord father;
    Hashtable idToName = new Hashtable();
    Hashtable nameToId = new Hashtable();
    Hashtable idToParamInfo = new Hashtable();

    /**
    */
    public 
    ParameterNaming(InteractionRecord _boss) 
    { father = _boss; }

    /**
    */
    public short 
    getParameterHandle(String theName) throws RTIcap.NameNotFound
    {
       if(DEBUG) System.out.println(" in getParameterHandle("+theName+")");
       Short ret= (Short) nameToId.get(theName);

       if(ret==null) throw new RTIcap.NameNotFound();

       if(DEBUG) System.out.println(" out of getParameterHandle("+theName+")");
       return ret.shortValue();

    }// end of getParameterHandle()

    /**
    */
    public String 
    getParameterName(short theHandle) throws RTIcap.InteractionParameterNotDefined 
    {
       String ret = (String) idToName.get(new Short(theHandle));

       if(ret==null) throw new RTIcap.InteractionParameterNotDefined();

       return ret;

    }// end of getParameterName()

    /**
    */
    public short 
    addParameter(String theName)
    {
       short ret = (short) (idToName.size()+1);

       idToName.put(new Short(ret),theName);
       nameToId.put(theName,new Short(ret));
   
       idToParamInfo.put(new Short(ret),new ParameterInfo(ret,theName,RTIcap.TransportType.RELIABLE,RTIcap.OrderType.RECEIVE));

       return ret;

    }// end of addParameter()

    /**
    */
    public ParameterInfo 
    getParameterInfo(short theHandle)
    {
       return (ParameterInfo) idToParamInfo.get(new Short(theHandle));

    }// end of getParameterInfo()

    public int getNumberOfParameters() { return idToName.size(); }

}// end of ParameterNaming



