/**
*
*  ParameterWatcher is responsible for the subscription/publication of
*  all the particular parameter of the interaction class.
*  It will registers all the puiblishing
*  activities and broadcast this all the subscribed federates.
*
*/
package owrti;

import RTIcap.*;
import java.util.*;

/**
*/
public class ParameterWatcher implements RTIDebug
{
   ParameterInfo father;      // Object 
   Hashtable    subscribers = new Hashtable();  // Subscribers
   Hashtable    publishers  = new Hashtable();  // Publishers

   /**
   *
   */
   public
   ParameterWatcher(ParameterInfo _boss)
   { 
       father = _boss;

   }// end of CONSTRUCTOR

   /**
   *
   */
   public void
   subscribe(RTIcap.FederateAmbassador _fedAmb, short fedHandle)
   {
      subscribers.put(new Short(fedHandle),_fedAmb);
      if(DEBUG) System.out.println(fedHandle+" is added to list of "+father.getName());

   }// end of subscribe()

   /**
   *
   */
   public void
   unsubscribe(short fedHandle)
   {
      subscribers.remove(new Short(fedHandle));

   }// end of subscribe()

   /**
   *
   */
   public void
   publish(short sourceFed)
   {

      Enumeration e = subscribers.keys();
      for(;e.hasMoreElements();)
      {
         Short key = (Short) e.nextElement();
         FederateAmbassador n = (FederateAmbassador) subscribers.get(key);

         if(n!=null && key.shortValue()!=sourceFed) {};

      }// end of for

   }// end of publish()

   /**
   *
   */
   public void
   register_publisher(FederateAmbassador _fedAmb, short fedHandle)
   {
    
      FederateAmbassador n = (FederateAmbassador) publishers.get(new Short(fedHandle));
   
      if(n==null) 
      { 
         publishers.put(new Short(fedHandle),_fedAmb);
         if(DEBUG) System.out.println(fedHandle+" is added to publisher list of "+father.getName());
      } 
      
   }// end of register_publisher()

   /**
   *
   */
   public void
   deregister_publisher(short fedHandle)
   {
    
      FederateAmbassador n = (FederateAmbassador) publishers.get(new Short(fedHandle));
   
      if(n==null) publishers.remove(new Short(fedHandle));
      
   }// end of register_publisher()

   /**
   */
   public void
   broadcast( RTIcap.ParameterHandleValuePair prm, double theTime, 
              String theTag, FederateAmbassador _fedHandle, short _fedId )
   {
      if(DEBUG) System.out.println(" in broadcast() message from "+_fedId);
      /** It has to be publisher Federate */

      FederateAmbassador ret = (FederateAmbassador) publishers.get(new Short(_fedId));
     
      if(ret!=null)
      {
         RTIcap.ParameterHandleValuePair prmSet[] = new RTIcap.ParameterHandleValuePair[1];
         prmSet[0] = prm;

         RTIcap.EventRetractionHandle retract = new RTIcap.EventRetractionHandle(theTime,0,_fedId);

         Enumeration e = subscribers.keys();
         for(;e.hasMoreElements();)
         {
            Short key = (Short) e.nextElement();
            FederateAmbassador n = (FederateAmbassador) subscribers.get(key);

            if(n!=null && key.shortValue()!=_fedId) 
            {
               try {
               n.receiveInteraction(father.getHandle(),prmSet,theTag);
               } catch( RTIcap.InteractionParameterNotKnown ipnk ) {}
                 catch( RTIcap.FederateInternalError fir ) {}
                 catch( RTIcap.InteractionClassNotKnown icnk ) {}

               if(DEBUG) System.out.println(" I sent to "+key.shortValue());

            }// end of if

         }// end of for

      }// end of if

      if(DEBUG) System.out.println(" out of broadcast() ");

   }// end of broadcast()

}// end of class ParameterWatcher

