/**
*
*/
package owrti;

import RTIcap.*;
import npacrti.*;

/*
*
* Defines the RTI Support Services 
*
* @date May 01, 1998 ( Updated at May 02, 1998 )
* @author H. Timucin Ozdemir
*
*/
public class 
RTIServices extends _RTIServicesInterfaceImplBase implements RTIDebug
{
    ObjectClassNaming objNaming;
    InteractionNaming interNaming;
    SpaceNaming       spaceNaming;

    public 
    RTIServices(ObjectClassNaming _objNaming, InteractionNaming _interNaming)
    {
       objNaming = _objNaming;
       interNaming = _interNaming;
    }

    /**
    * returns the Object Id of the particular Object Name
    */
    public short 
    getObjectClassHandle(String theName)
          throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
                 RTIcap.RTIinternalError 
    {
       return objNaming.getObjectClassHandle(theName);
    }

    /**
    */
    public String 
    getObjectClassName(short theHandle)
           throws RTIcap.ObjectClassNotDefined, 
                  RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError 
    {
       return objNaming.getObjectClassName(theHandle);
    } 

    /**
    */
    public short 
    getAttributeHandle(String theName, short whichClass)
          throws RTIcap.ObjectClassNotDefined, RTIcap.NameNotFound, 
                 RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError 
    {
       return objNaming.getAttributeHandle(theName,whichClass);
    }

    /**
    */
    public String 
    getAttributeName(short theHandle, short whichClass)
           throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                  RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError 
    {
       return objNaming.getAttributeName(theHandle,whichClass);
    }

    /**
    */
    public short 
    getInteractionClassHandle(String theName)
          throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
                 RTIcap.RTIinternalError 
    {
       return interNaming.getInteractionClassHandle(theName);
    }

    /**
    */
    public String 
    getInteractionClassName(short theHandle)
           throws RTIcap.InteractionClassNotDefined, 
                  RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError 
    {
       return interNaming.getInteractionClassName(theHandle);
    }

    /**
    */
    public short 
    getParameterHandle(String theName, short whichClass)
          throws RTIcap.InteractionClassNotDefined, RTIcap.NameNotFound, 
                 RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError 
    {
       return interNaming.getParameterHandle(theName,whichClass);
    }//

    /**
    */
    public String 
    getParameterName(short theHandle, short whichClass)
           throws RTIcap.InteractionClassNotDefined, 
                  RTIcap.InteractionParameterNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.RTIinternalError
    {
       return interNaming.getParameterName(theHandle,whichClass);
    }

    /**
    */
    public int 
    getSpaceHandle(String theName)
        throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
               RTIcap.RTIinternalError 
    {
       return spaceNaming.getSpaceHandle(theName);
    }

    /**
    */
    public String 
    getSpaceName(int theHandle)
           throws RTIcap.SpaceNotDefined, RTIcap.FederateNotExecutionMember, 
                  RTIcap.RTIinternalError 
    {
       return spaceNaming.getSpaceName(theHandle);
    }

    /**
    */
    public
    short getFederateHandle(String theName)
          throws RTIcap.FederateDoesNotExist, RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, 
                 RTIcap.RTIinternalError, RTIcap.Deadlock, 
                 RTIcap.UnimplementedService
    {
        short ret=0;
        
        return ret;
    }

    /**
    */
    public
    String getFederateName(short theHandle)
           throws RTIcap.FederateDoesNotExist, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, 
                  RTIcap.RTIinternalError, RTIcap.Deadlock, 
                  RTIcap.UnimplementedService
    {
       String ret = null;

       return ret;
    }

    /**
    */
    public
    void turnRegulationOn()
         throws RTIcap.FederationTimeAlreadyPassed, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }
 

    /**
    */
    public
    double turnRegulationOnNow()
           throws RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       double ret=0;

       return ret;
    }

    /**
    */
    public
    void turnRegulationOff()
         throws RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void setTimeConstrained(RTIcap._Boolean state)
         throws RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public int 
    getObjectInstanceHandle(String theName)
        throws RTIcap.ObjectNotKnown, RTIcap.FederateNotExecutionMember,
               RTIcap.RTIinternalError
    {
       ObjectInstanceRecord rec = objNaming.getObjectInstance(theName);
       if(rec == null ) throw new RTIcap.ObjectNotKnown();
       return rec.getObjectInstanceHandle();

    }// end of getObjectInstanceHandle()

    /**
    */
    public String 
    getObjectInstanceName(int theHandle)
        throws RTIcap.ObjectNotKnown, RTIcap.FederateNotExecutionMember,
               RTIcap.RTIinternalError
    {
       ObjectInstanceRecord rec = objNaming.getObjectInstance(theHandle);
       if(rec == null ) throw new RTIcap.ObjectNotKnown();
       return rec.getObjectName();
    }// end of getObjectInstanceName()

    /**
    */
    public int 
    getDimensionHandle(String theName, int theHandle)
        throws RTIcap.SpaceNotDefined, RTIcap.NameNotFound, 
               RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError
    {
       int ret = -1;
       return ret;
    }// end of getDimensionHandle()

    /**
    */
    public String 
    getDimensionName(int theDimHandle, int theSpcHandle)
        throws RTIcap.SpaceNotDefined, RTIcap.DimensionNotDefined,
               RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError
    {
        String ret = null;
        return ret;
    }// end of getDimensionName()

    /**
    */
    public int 
    getAttributeRoutingSpaceHandle(short theHandle, short whichClass)
        throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined,
               RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError
    {
        ObjectRecord rec = objNaming.getObjectRecord(whichClass);
        if( rec == null ) throw new RTIcap.ObjectClassNotDefined();
        AttributeWatcher att = rec.getAttributeWatcher(theHandle);
        if( att == null ) throw new RTIcap.AttributeNotDefined();
        return att.getRoutingSpaceHandle();
    }// end of getAttributeRoutingSpaceHandle()

    /**
    */
    public short 
    getObjectClass(int theHandle)
        throws RTIcap.ObjectNotKnown, RTIcap.FederateNotExecutionMember,
               RTIcap.RTIinternalError
    {
       ObjectInstanceRecord rec = objNaming.getObjectInstance(theHandle);
       if( rec == null ) throw new RTIcap.ObjectNotKnown();
       return rec.getObjectClassHandle();
    }// end of getObjectClass()

    /**
    */
    public int 
    getInteractionRoutingSpaceHandle(short theHandle)
        throws RTIcap.InteractionClassNotDefined, 
               RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError
    {
       InteractionRecord rec = interNaming.getInteractionRecord(theHandle);
       if( rec == null ) throw new RTIcap.InteractionClassNotDefined();
       return rec.getRoutingSpaceHandle();
    }// end of getInteractionRoutingSpaceHandle()

    /**
    */
    public int 
    getTransportationHandle(String theName)
        throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember,
               RTIcap.RTIinternalError
    {
       int ret = -1;
       return ret;
    }// end of getTransportationHandle()

    /**
    */
    public String 
    getTransportationName(int theHandle)
        throws RTIcap.InvalidTransportationHandle,
               RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError
    {
       String ret = null;
       return ret;
    }// end of getTransportationName()

    /**
    */
    public int 
    getOrderingHandle(String theName)
        throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember,
               RTIcap.RTIinternalError
    {
       int ret = -1;
       return ret;
    }// end of getOrderingHandle()

    /**
    */
    public String 
    getOrderingName(int theHandle)
        throws RTIcap.InvalidOrderingHandle,
               RTIcap.FederateNotExecutionMember, RTIcap.RTIinternalError
    {
       String ret = null;
       return ret;
    }// end of getOrderingName()

    /**
    */
    public void 
    enableClassRelevanceAdvisorySwitch()
        throws RTIcap.FederateNotExecutionMember, RTIcap.SaveInProgress,
               RTIcap.RestoreInProgress, RTIcap.RTIinternalError
    {
    }// end of enableClassRelevanceAdvisorySwitch()

    /**
    */
    public void 
    disableClassRelevanceAdvisorySwitch()
        throws RTIcap.FederateNotExecutionMember, RTIcap.SaveInProgress,
               RTIcap.RestoreInProgress, RTIcap.RTIinternalError
    {
    }// end of disableClassRelevanceAdvisorySwitch()

    /**
    */
    public void 
    enableAttributeRelevanceAdvisorySwitch()
        throws RTIcap.FederateNotExecutionMember, RTIcap.SaveInProgress,
               RTIcap.RestoreInProgress, RTIcap.RTIinternalError
    {
    }// end of enableAttributeRelevanceAdvisorySwitch()

    /**
    */
    public void 
    disableAttributeRelevanceAdvisorySwitch()
        throws RTIcap.FederateNotExecutionMember, RTIcap.SaveInProgress,
               RTIcap.RestoreInProgress, RTIcap.RTIinternalError
    {
    }// end of disableAttributeRelevanceAdvisorySwitch()

    /**
    */
    public void 
    enableAttributeScopeAdvisorySwitch()
        throws RTIcap.FederateNotExecutionMember, RTIcap.SaveInProgress,
        RTIcap.RestoreInProgress, RTIcap.RTIinternalError
    {
    }// end of enableAttributeScopeAdvisorySwitch()

    /**
    */
    public void 
    disableAttributeScopeAdvisorySwitch()
        throws RTIcap.FederateNotExecutionMember, RTIcap.SaveInProgress,
               RTIcap.RestoreInProgress, RTIcap.RTIinternalError
    {
    }// end of disableAttributeScopeAdvisorySwitch()

    /**
    */
    public void 
    enableInteractionRelevanceAdvisorySwitch()
        throws RTIcap.FederateNotExecutionMember, RTIcap.SaveInProgress,
               RTIcap.RestoreInProgress, RTIcap.RTIinternalError
    {
    }// end of enableInteractionRelevanceAdvisorySwitch()

    /**
    */
    public void 
    disableInteractionRelevanceAdvisorySwitch()
        throws RTIcap.FederateNotExecutionMember, RTIcap.SaveInProgress,
               RTIcap.RestoreInProgress, RTIcap.RTIinternalError
    {
    }// end of disableInteractionRelevanceAdvisorySwitch()


}// end of RTIAmb
