package owrti;

import RTIcap.*;
import java.util.*;

public class 
RegionNaming extends GlbNaming implements RTIDebug
{

   int number_of_regions=0;
   public 
   RegionNaming() {}

   /**
   */
   public int 
   getRegionHandle(String theName) throws RTIcap.NameNotFound
   {
       Integer ret = (Integer) getID(theName);

       if ( ret==null) throw new RTIcap.NameNotFound();

       return ret.intValue();

   }// end of getRegionHandle()

   /**
   */
   public String 
   getRegionName(int theHandle) 
   {
       return (String) getName(new Integer(theHandle));

   }// end of getRegionName()

   /**
   */
   public RegionInfo 
   getRegionInfo(int theHandle)
   {
       return (RegionInfo) getRecord(new Integer(theHandle));

   }// end of getDimensionInfo()

   /**
   */
   public RegionInfo 
   get(int theHandle)
   {
       return (RegionInfo) getRecord(new Integer(theHandle));

   }// end of getDimensionInfo()

   /**
   public void 
   addRegionInfo( int theHandle, String Name,  ExtentInfo[] _exts, 
                  SpaceInfo _r_space, short theFederate )
   {
       addEntry(new Integer(theHandle),Name, new RegionInfo((short)theHandle,Name,_exts,_r_space,theFederate));
   }// end of addDimensionInfo()
   */

   /**
   */
   public int 
   addRegionInfo(RegionInfo theRegion)
   {
       number_of_regions++;
       addEntry(new Integer(number_of_regions),"R"+number_of_regions, theRegion);
       return number_of_regions;

   }// end of addDimensionInfo()

   /**
   public int 
   addRegion( RTIcap.Range[] _exts, SpaceInfo _r_space, short theFederate )
   {
       number_of_regions++;
       String Name = new String("Region"+number_of_regions);
       addEntry(new Integer(number_of_regions),Name, new RegionInfo((short)number_of_regions,Name,_exts,_r_space,theFederate));
       return number_of_regions;
   }// end of addRegion()
   */

   /**
   */
   public void
   remove(int theRegion)
   {  
      RegionInfo reg = getRegionInfo(theRegion);
      if(reg!=null) removeEntry(reg);

   }// end of remove()

   /**
   */
   public void
   remove(RegionInfo theRegion)
   {
      removeEntry(theRegion);
   }// end of remove()

}// end of class RegionNaming
