package owrti;

import java.util.*;

/**
*  This table keeps the following information:
*   which federate, which object, which attribute
*  Since the relation is composed of three components.
*
*  We need one table per Federation execution.
*
* @date April 22, 1998 ( Updated at April 22, 1998 )
* @author H. Timucin Ozdemir
*
*/
public class 
RequestOwnershipTable implements RTIDebug 
{

   FederationExecution fedEx;

   Hashtable fedToObject = new Hashtable();

   public
   RequestOwnershipTable(FederationExecution _fedEx) 
   {
      fedEx = _fedEx;
   }

   /**
   */
   public void
   register(short theFederate, int theObject, short theAttribute, int evtId) 
   {
      RequestOwnershipTableEntry ent = new RequestOwnershipTableEntry(theFederate,theObject,theAttribute,evtId);

      Hashtable a = (Hashtable) fedToObject.get(new Short(theFederate));

      if(a==null) 
      {   
         a = new Hashtable(); 
         fedToObject.put(new Short(theFederate),a);
      }

      Hashtable b = (Hashtable) a.get(new Integer(theObject));

      if(b==null) 
      {   
         b = new Hashtable(); 
         a.put(new Integer(theObject),b);
      }

      RequestOwnershipTableEntry e = (RequestOwnershipTableEntry) b.get(new Short(theAttribute));

      if(e==null) b.put(new Short(theAttribute),ent);

   }// end of register()

   /**
   */
   public void
   register(short theFederate, int theObject, short[] theAttributes, int evtId) 
   {

      Hashtable a = (Hashtable) fedToObject.get(new Short(theFederate));

      if(a==null) 
      {   
         a = new Hashtable(); 
         fedToObject.put(new Short(theFederate),a);
      }

      Hashtable b = (Hashtable) a.get(new Integer(theObject));

      if(b==null) 
      {   
         b = new Hashtable(); 
         a.put(new Integer(theObject),b);
      }

      RequestOwnershipTableEntry e ;

      for(int i=0;i<theAttributes.length;i++)
      {
         e = (RequestOwnershipTableEntry) b.get(new Short(theAttributes[i]));

         if(e==null)
             b.put(new Short(theAttributes[i]),new RequestOwnershipTableEntry(theFederate,theObject,theAttributes[i],evtId));

      }// end of for

   }// end of register()

   /**
   */
   final Hashtable
   getAttributeToEntry(short theFederate, int theObject)
   {
      Hashtable ret = null;
      Hashtable a = (Hashtable) fedToObject.get(new Short(theFederate));

      if(a!=null)  ret = (Hashtable) a.get(new Integer(theObject));

      return ret;

   }// end of getAttributeToEntry()

   /**
   */
   public void
   deregister(short theFederate, int theObject, short theAttribute) 
   {
      Hashtable a = getAttributeToEntry(theFederate,theObject);

      if(a!=null) a.remove(new Short(theAttribute));

   }// end of deregister()

   /**
   */
   public void
   deregister(short theFederate, int theObject, short[] theAttributes) 
   {
      Hashtable a = getAttributeToEntry(theFederate,theObject);

      if(a!=null) 
         for(int i=0;i<theAttributes.length;i++)
             a.remove(new Short(theAttributes[i]));

   }// end of deregister()

   /**
   */
   public void
   deregisterWithCancel(short theFederate, int theObject, short theAttribute) 
   {
      Hashtable a = getAttributeToEntry(theFederate,theObject);
      RequestOwnershipTableEntry e ;

      if(a!=null) 
      {
         e = (RequestOwnershipTableEntry) a.get(new Short(theAttribute));

         if(e!=null)
         {
            FederateInfo fedInf = fedEx.getFederateInfo(e.getFederateID());
            //if(fedInf!=null) fedInf.cancelEvent(e.getEventID()); 

         }// end of if

      }// end of if

   }// end of deregisterWithCancel()

   /**
   */
   public void
   deregisterWithCancel(short theFederate, int theObject, short[] theAttributes) 
   {

      Hashtable a = getAttributeToEntry(theFederate,theObject);
      RequestOwnershipTableEntry e ;

      if(a!=null) 
      {
         for(int i=0;i<theAttributes.length;i++)
         {
            e = (RequestOwnershipTableEntry) a.get(new Short(theAttributes[i]));

            if(e!=null)
            {
               FederateInfo fedInf = fedEx.getFederateInfo(e.getFederateID());
               //if(fedInf!=null) fedInf.cancelEvent(e.getEventID()); 

            }// end of if

         }// end of for

      }// end of if

   }// end of deregisterWithCancel()

   /**
   */
   public FederateInfo
   getAttributeRequester(int tehObject, short theAttribute) 
   {
      FederateInfo ret = null;
      return null;

   }// end of deregister()

}// end of class  RequestOwnershipTable

