/**
*/

import RTIcap.*;


/**
*/
public class 
ExtentInfo implements RTIDebug
{

   short  theHandle;
   String theName;
   double ext_lower_bound;
   double ext_upper_bound;
   DimensionInfo dim;

   /**
   */
   public
   ExtentInfo( short _theHandle, String _theName, double _ext_lower_bound, 
               double _ext_upper_bound, DimensionInfo _dim)
   {

      theHandle = _theHandle;
      theName   = _theName;
      ext_lower_bound = Math.min(_ext_lower_bound,_ext_upper_bound);
      ext_upper_bound = Math.max(_ext_lower_bound,_ext_upper_bound);
      dim = _dim;

   }// end of CONSTRUCTOR

   /**
   */
   public
   ExtentInfo( double _ext_lower_bound, double _ext_upper_bound )
   {
      ext_lower_bound = Math.min(_ext_lower_bound,_ext_upper_bound);
      ext_upper_bound = Math.max(_ext_lower_bound,_ext_upper_bound);
   }// end of CONSTRUCTOR

   /**
   */
   public short 
   getHandle() { return theHandle; }

   /**
   */
   public String 
   getName() { return theName; }

   /**
   */
   public double
   getLowerBound() { return ext_lower_bound; }

   /**
   */
   public double
   getUpperBound() { return ext_upper_bound; }

   /**
   */
   public DimensionInfo
   getDimension() { return dim; }

}// end of ExtentInfo



