import RTIcap.*;

/*
*/

public class RTIKernel 
{

    DeclarationManager      decManager ;
    FederationManager       fedManager ;
    ObjectManager           objManager ;
    OwnershipManager        ownManager ;
    TimeManager             timManager ;
    DataDistributionManager datManager ;

    /**
    */
    public
    RTIKernel()
    {

       decManager = new DeclarationManager();
       fedManager = new FederationManager();
       objManager = new ObjectManager();
       ownManager = new OwnershipManager();
       timManager = new TimeManager();
       datManager = new DataDistributionManager();
        
    }// end of RTIAmb

    /**
    */
    public
    void beginTicking(int sleepTime) throws RTIcap.TickingPreviouslyStarted
    {
    }

    /**
    */
    public
    void endTicking() throws RTIcap.TickingNotEnabled
    {
    }

    /**
    */
    public
    void createFederationExecution(String executionName)
         throws RTIcap.FederationExecutionAlreadyExists, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
        fedManager.createFederationExecution(executionName);
    }

    /**
    */
    public
    void destroyFederationExecution(String executionName)
         throws RTIcap.FederatesCurrentlyJoined, 
                RTIcap.FederationExecutionDoesNotExist, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
        fedManager.destroyFederationExecution(executionName);
    } 

    /**
    */
    public
    short joinFederationExecution(String yourName, String executionName, 
                 RTIcap.FederateAmbassador federateAmbassador)
          throws RTIcap.FederateAlreadyExecutionMember, 
                 RTIcap.FederationExecutionDoesNotExist, RTIcap.CouldNotOpenFED, 
                 RTIcap.ErrorReadingFED, RTIcap.ConcurrentAccessAttempted, 
                 RTIcap.RTIinternalError, RTIcap.Deadlock
    {
       return fedManager.joinFederationExecution(yourName,executionName,federateAmbassador);
    }

    /**
    */
    public
    void resignFederationExecution1(RTIcap.ResignAction theAction)
         throws RTIcap.FederateOwnsAttributes, 
                RTIcap.FederateNotExecutionMember, RTIcap.InvalidResignAction, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
         fedManager.resignFederationExecution1(theAction); 
    }

    /**
    */
    public
    void resignFederationExecution(short FederateId, String FederationName,
                                    RTIcap.ResignAction theAction)
         throws RTIcap.FederateOwnsAttributes, 
                RTIcap.FederateNotExecutionMember, RTIcap.InvalidResignAction, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
         fedManager.resignFederationExecution(FederateId,FederationName,theAction); 
    }

    /**
    */
    public
    void resignFederationExecution2(short theFederate, 
                                    RTIcap.ResignAction theAction)
         throws RTIcap.FederateOwnsAttributes, RTIcap.FederateDoesNotExist, 
                RTIcap.FederationExecutionDoesNotExist, 
                RTIcap.FederateNotExecutionMember, RTIcap.InvalidResignAction, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
         fedManager.resignFederationExecution2(theFederate,theAction);
    }

    /**
    */
    public
    void requestPause(String label)
         throws RTIcap.FederationAlreadyPaused, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.requestPause(label);
    }

    /**
    */
    public
    void requestPause(short FederateId, String FederationName, String label)
         throws RTIcap.FederationAlreadyPaused, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.requestPause(FederateId,FederationName,label);
    }

    /**
    */
    public
    void pauseAchieved(String label)
         throws RTIcap.UnknownLabel, RTIcap.NoPauseRequested, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.pauseAchieved(label);
    }

    /**
    */
    public
    void requestResume()
         throws RTIcap.FederationNotPaused, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.requestResume();
    }

    /**
    */
    public
    void requestResume(short FederateId, String FederationName)
         throws RTIcap.FederationNotPaused, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.requestResume(FederateId,FederationName);
    }

    /**
    */
    public
    void resumeAchieved()
         throws RTIcap.NoResumeRequested, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.resumeAchieved();
    }

    /**
    */
    public
    void requestFederationSave1(String label, double theTime)
         throws RTIcap.FederationTimeAlreadyPassed, 
                RTIcap.InvalidFederationTime, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.requestFederationSave1(label,theTime);
    }

    /**
    */
    public
    void requestFederationSave2(String label)
         throws RTIcap.SaveInProgress, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.requestFederationSave2(label);
    }

    /**
    */
    public
    void federateSaveBegun1()
         throws RTIcap.SaveNotInitiated, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.federateSaveBegun1();
    }

    /**
    */
    public
    void federateSaveBegun2(double theTime)
         throws RTIcap.SaveNotInitiated, RTIcap.InvalidFederationTime, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.federateSaveBegun2(theTime);
    }

    /**
    */
    public
    void federateSaveAchieved()
         throws RTIcap.SaveNotInitiated, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.federateSaveAchieved();
    }

    /**
    */
    public
    void federateSaveNotAchieved()
         throws RTIcap.SaveNotInitiated, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.federateSaveNotAchieved();
    }

    /**
    */
    public
    void requestRestore(String label)
         throws RTIcap.SpecifiedSaveLabelDoesNotExist, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.requestRestore(label);
    }

    /**
    */
    public
    void restoreAchieved(String label)
         throws RTIcap.UnknownLabel, RTIcap.RestoreNotRequested, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.restoreAchieved(label);
    }

    /**
    */
    public
    void restoreNotAchieved(String label)
         throws RTIcap.UnknownLabel, RTIcap.RestoreNotRequested, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
        fedManager.restoreNotAchieved(label);
    }

    /**
    */
    public
    void publishObjectClass(short theClass, short[] attributeList)
         throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void unpublishObjectClass(short theClass)
         throws RTIcap.ObjectClassNotDefined, RTIcap.FederateOwnsAttributes, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    } 

    /**
    */
    public
    void publishInteractionClass(short theInteraction)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void unpublishInteractionClass(short theInteraction)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void subscribeObjectClassAttribute1(short theClass, short[] attributeList)
         throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void subscribeObjectClassAttribute2(short theClass, short theAttribute, 
                int theRegion)
         throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                RTIcap.RegionNotKnown, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void unsubscribeObjectClassAttribute1(short theClass)
         throws RTIcap.ObjectClassNotDefined, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void unsubscribeObjectClassAttribute2(short theClass, int theRegion)
         throws RTIcap.ObjectClassNotDefined, RTIcap.RegionNotKnown, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void subscribeInteractionClass1(short theClass)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void subscribeInteractionClass2(short theClass, int theRegion)
         throws RTIcap.InteractionClassNotDefined, RTIcap.RegionNotKnown, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void unsubscribeInteractionClass1(short theClass)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void unsubscribeInteractionClass2(short theClass, int theRegion)
         throws RTIcap.InteractionClassNotDefined, RTIcap.RegionNotKnown, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void requestID(short idCount, org.omg.CORBA.IntHolder firstID, 
                   org.omg.CORBA.IntHolder lastID)
         throws RTIcap.TooManyIDsRequested, RTIcap.IDsupplyExhausted, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void registerObject(short theClass, int theObject)
         throws RTIcap.ObjectClassNotDefined, RTIcap.ObjectClassNotPublished, 
                RTIcap.InvalidObjectID, RTIcap.ObjectAlreadyRegistered, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    RTIcap.EventRetractionHandle updateAttributeValues(int theObject, 
                RTIcap.AttributeHandleValuePair[] theAttributes, 
                double theTime, String theTag)
         throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotDefined, 
                RTIcap.AttributeNotOwned, RTIcap.InvalidFederationTime, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
       return null;
    }

    /**
    */
    public
    RTIcap.EventRetractionHandle sendInteraction(short theInteraction, 
                             RTIcap.ParameterHandleValuePair[] theParameters, 
                             double theTime, String theTag)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.InteractionClassNotPublished, 
                RTIcap.InteractionParameterNotDefined, 
                RTIcap.InvalidFederationTime, RTIcap.FederateNotExecutionMember,
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
       return null;
    }

    /**
    */
    public
    RTIcap.EventRetractionHandle deleteObject(int objectID, double theTime, String theTag)
         throws RTIcap.ObjectNotKnown, RTIcap.DeletePrivilegeNotHeld, 
                RTIcap.InvalidFederationTime, RTIcap.FederateNotExecutionMember,  
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
       return null;
    }

    /**
    */
    public
    void changeAttributeTransportType(int theObject, short[] theAttributes, 
                                      RTIcap.TransportType theType)
         throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotDefined, 
                RTIcap.AttributeNotOwned, RTIcap.InvalidTransportType, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void changeAttributeOrderType(int theObject, short[] theAttributes, 
                                  RTIcap.OrderType theType)
         throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotDefined, 
                RTIcap.AttributeNotOwned, RTIcap.InvalidOrderType, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void changeInteractionTransportType(short theClass, RTIcap.TransportType theType)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.InteractionClassNotPublished, 
                RTIcap.InvalidTransportType, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void changeInteractionOrderType(short theClass, RTIcap.OrderType theType)
         throws RTIcap.InteractionClassNotDefined, 
                RTIcap.InteractionClassNotPublished, RTIcap.InvalidOrderType, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void requestObjectAttributeValueUpdate1(int theObject, short[] theAttributes)
         throws RTIcap.AttributeNotDefined, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void requestObjectAttributeValueUpdate2(int theObject)
         throws RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void requestClassAttributeValueUpdate1(short theClass, short[] theAttributes)
         throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {

    }

    /**
    */
    public
    void requestClassAttributeValueUpdate2(short theClass)
         throws RTIcap.ObjectClassNotDefined, RTIcap.FederateNotExecutionMember,
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void retract(RTIcap.EventRetractionHandle theHandle)
         throws RTIcap.InvalidRetractionHandle, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void requestAttributeOwnershipDivestiture1(int theObject, 
                short[] theAttributes, 
                RTIcap.OwnershipDivestitureCondition theCondition, String theTag)
         throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotDefined, 
                RTIcap.AttributeNotOwned, RTIcap.InvalidDivestitureCondition, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void requestAttributeOwnershipDivestiture2(int theObject, 
                short[] theAttributes, 
                RTIcap.OwnershipDivestitureCondition theCondition, 
                String theTag, short[] theCandidates)
         throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotDefined, 
                RTIcap.AttributeNotOwned, RTIcap.InvalidDivestitureCondition, 
                RTIcap.FederateDoesNotExist, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void requestAttributeOwnershipAcquisition(int theObject, 
                                      short[] desiredAttributes, String theTag)
         throws RTIcap.ObjectNotKnown, RTIcap.ObjectClassNotPublished, 
                RTIcap.ObjectClassNotSubscribed, RTIcap.AttributeNotDefined, 
                RTIcap.AttributeNotPublished, RTIcap.AttributeNotSubscribed, 
                RTIcap.FederateOwnsAttributes, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, 
                RTIcap.RTIinternalError, RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void queryAttributeOwnership(int theObject, short theAttribute)
         throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotDefined, 
                RTIcap.AttributeNotKnown, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    RTIcap._Boolean attributeIsOwnedByFederate(int theObject, short theAttribute)
                    throws RTIcap.ObjectNotKnown, RTIcap.AttributeNotDefined, 
                           RTIcap.AttributeNotKnown, 
                           RTIcap.FederateNotExecutionMember, 
                           RTIcap.ConcurrentAccessAttempted, 
                           RTIcap.RTIinternalError, RTIcap.Deadlock
    {
        _Boolean ret = RTIcap._Boolean.RTI_FALSE;

        return ret;
    }

    /**
    */
    public
    double requestFederationTime()
           throws RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       double ret=0;

       return ret;
    }

    /**
    */
    public
    double requestLBTS()
           throws RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       double ret=0;

       return ret;
    }

    /**
    */
    public
    double requestFederateTime()
           throws RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       double ret=0;

       return ret;
    }

    /**
    */
    public
    double requestMinNextEventTime()
           throws RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       double ret=0;

       return ret;
    }

    /**
    */
    public
    void setLookahead(double theLookahead)
         throws RTIcap.InvalidFederationTimeDelta, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    double requestLookahead()
           throws RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       double ret=0;

       return ret;
    }

    /**
    */
    public
    void timeAdvanceRequest(double theTime)
         throws RTIcap.TimeAdvanceAlreadyInProgress, 
                RTIcap.FederationTimeAlreadyPassed, 
                RTIcap.InvalidFederationTime, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void nextEventRequest1(double theTime)
         throws RTIcap.TimeAdvanceAlreadyInProgress, 
                RTIcap.FederationTimeAlreadyPassed, 
                RTIcap.InvalidFederationTime, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void nextEventRequest2(double theTime, double deltaTime)
         throws RTIcap.TimeAdvanceAlreadyInProgress, 
                RTIcap.FederationTimeAlreadyPassed, 
                RTIcap.InvalidFederationTime, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void flushQueueRequest(double theTime)
         throws RTIcap.TimeAdvanceAlreadyInProgress, 
                RTIcap.FederationTimeAlreadyPassed, 
                RTIcap.InvalidFederationTime, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void createUpdateRegion(int theSpace, RTIcap.Range[][] theExtents, int theRegion)
         throws RTIcap.SpaceNotDefined, RTIcap.InvalidExtents, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void createSubscriptionRegion(String theSpace, RTIcap.Range[][] theExtents, int theRegion)
         throws RTIcap.SpaceNotDefined, RTIcap.InvalidExtents, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void associateUpdateRegion1(int theRegion, int theObject, short[] theAttributes)
         throws RTIcap.RegionNotKnown, RTIcap.ObjectNotKnown, 
                RTIcap.AttributeNotDefined, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void disassociateUpdateRegion1(int theRegion, int theObject, short[] theAttributes)
         throws RTIcap.RegionNotKnown, RTIcap.ObjectNotKnown, 
                RTIcap.AttributeNotDefined, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void associateUpdateRegion2(int theRegion, short theClass)
         throws RTIcap.RegionNotKnown, RTIcap.InteractionClassNotKnown, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void disassociateUpdateRegion2(int theRegion, short theClass)
         throws RTIcap.RegionNotKnown, RTIcap.InteractionClassNotKnown, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void modifyRegion(int theRegion, RTIcap.Range[][] theExtents)
         throws RTIcap.RegionNotKnown, RTIcap.InvalidExtents, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    void deleteRegion(int theRegion)
         throws RTIcap.RegionNotKnown, RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock, RTIcap.UnimplementedService
    {
    }

    /**
    */
    public
    short getObjectClassHandle(String theName)
          throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
    {
       short ret=0;

       return ret;
    }

    /**
    */
    public
    String getObjectClassName(short theHandle)
           throws RTIcap.ObjectClassNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       String ret = null;

       return ret;
    } 

    /**
    */
    public
    short getAttributeHandle(String theName, short whichClass)
          throws RTIcap.ObjectClassNotDefined, RTIcap.NameNotFound, 
                 RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
    {
       short ret=0;

       return ret;
    }

    /**
    */
    public
    String getAttributeName(short theHandle, short whichClass)
           throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       String ret = null;

       return ret;
    }

    /**
    */
    public
    short getInteractionClassHandle(String theName)
          throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
    {
       short ret=0;

       return ret;
    }

    /**
    */
    public
    String getInteractionClassName(short theHandle)
           throws RTIcap.InteractionClassNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       String ret = null;

       return ret;
    }

    /**
    */
    public
    short getParameterHandle(String theName, short whichClass)
          throws RTIcap.InteractionClassNotDefined, RTIcap.NameNotFound, 
                 RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
    {
       short ret=0;

       return ret;
    }

    /**
    */
    public
    String getParameterName(short theHandle, short whichClass)
           throws RTIcap.InteractionClassNotDefined, 
                  RTIcap.InteractionParameterNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       String ret = null;

       return ret;
    }

    /**
    */
    public
    int getSpaceHandle(String theName)
        throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
               RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
               RTIcap.Deadlock, RTIcap.UnimplementedService
    {
       int ret=0;

       return ret;
    }

    /**
    */
    public
    String getSpaceName(int theHandle)
           throws RTIcap.SpaceNotDefined, RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock, RTIcap.UnimplementedService
    {
       String ret = null;

       return ret;
    }

    /**
    */
    public
    short getFederateHandle(String theName)
          throws RTIcap.FederateDoesNotExist, RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, 
                 RTIcap.RTIinternalError, RTIcap.Deadlock, 
                 RTIcap.UnimplementedService
    {
        short ret=0;
        
        return ret;
    }

    /**
    */
    public
    String getFederateName(short theHandle)
           throws RTIcap.FederateDoesNotExist, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, 
                  RTIcap.RTIinternalError, RTIcap.Deadlock, 
                  RTIcap.UnimplementedService
    {
       String ret = null;

       return ret;
    }

    /**
    */
    public
    void turnRegulationOn()
         throws RTIcap.FederationTimeAlreadyPassed, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }
 

    /**
    */
    public
    double turnRegulationOnNow()
           throws RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       double ret=0;

       return ret;
    }

    /**
    */
    public
    void turnRegulationOff()
         throws RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void setTimeConstrained(RTIcap._Boolean state)
         throws RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

}// end of RTIAmb
