/**
* Starts the RTI Kernel Object
*/

import java.io.*;

// The package containing our stubs.
import RTIcap.*;
import npacrti.*;

// RTIKernel will use the naming service.
import org.omg.CosNaming.*;

// The package containing special exceptions thrown by the name service.
import org.omg.CosNaming.NamingContextPackage.*;

// All CORBA applications need these classes.
import org.omg.CORBA.*;

public class startRTIKernel 
{

   public static void
   writeIOR(String fileName, String IOR)
   {
      try
      {
         File f = new File(fileName);
     
         PrintWriter out = new PrintWriter(new FileWriter(f));
         out.print(IOR);
         out.close();

      } catch(IOException ioe) {}
      
   }// end of writeIOR()

   /**
   */
   public static void 
   main(String args[])
   {
      String path = new String("/project/speedes/users/timucin/omniORB_2.5.0/src/examples/hello");
      try
      {
    
         // Create and initialize the ORB
         ORB orb = ORB.init(args, null);
      
         // Create the servant and register it with the ORB
         RTIKernel rtiKernel = new RTIKernel();
         orb.connect(rtiKernel);
      
         /*
         // Get the root naming context
         org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
         NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
         // Bind the object reference in naming
         NameComponent nc = new NameComponent("RTIKernel", " ");
         NameComponent path[] = {nc};
         ncRef.rebind(path, rtiKernel);
         */
      
         System.out.println("IOR "+orb.object_to_string(rtiKernel));
         if(args.length>0) path = args[0];
         String fName = new String(path+"/IOR");
         System.out.println("at "+fName);
         startRTIKernel.writeIOR(fName,orb.object_to_string(rtiKernel));
         // Wait for invocations from clients
         java.lang.Object sync = new java.lang.Object();
         synchronized(sync){ sync.wait(); }
      
       } catch(Exception e) 
         {
            System.err.println("ERROR: " + e);
            e.printStackTrace(System.out);
         }  

    }// end of main

}// end of startRTIKernel

