
package owrti.util;

import java.io.*;
import java.net.*;
import java.util.StringTokenizer;

/**
* Utility object to figure out where the RTIKernel object is.
*
* @author H. Timucin Ozdemir
* @date August 11, 1998 ( Last Update August 11, 1998 ) 
*
*/
public class KernelLocator
{
   
   static final String DEFAULT_FILE_NAME = new String("kernel.srv");

   /**
   */
   public static final String
   getRTIKernelIOR() throws java.io.FileNotFoundException
   {
      return getRTIKernelIOR(KernelLocator.DEFAULT_FILE_NAME);

   }// end of getRTIKernelIOR()

   /**
   */
   public static final String
   getRTIKernelIOR(String cnfFile) throws java.io.FileNotFoundException
   {
      String  ret = null;
      String  hostName;
      String  portNumber;
      int     port;
      boolean notFound = true;
      String fileName = new String(KernelLocator.DEFAULT_FILE_NAME);
      if(cnfFile!=null) fileName = cnfFile;

      try
      {
        BufferedReader input = new BufferedReader(new FileReader(fileName));
        String line = input.readLine();

        while( ret==null && line!=null )
        {
           if( !line.startsWith("#") || !line.startsWith("%") ||
               !line.startsWith("/") || !line.startsWith("$") ) 
           {
               StringTokenizer sToken = new StringTokenizer(line);
               if(sToken.countTokens()>1)
               {
                 hostName   = (String) sToken.nextElement(); 
                 portNumber = (String) sToken.nextElement(); 

                 try
                 {
                   port = Integer.parseInt(portNumber);
                   
                   ret = askIOR(hostName,port,"IDL:npacrti/RTIKernelInterface:1.0");
                 } catch(java.lang.NumberFormatException nfe) {}

               }// end of if

           }// end of if

           line = input.readLine();

        }// end of while

      } catch(java.io.IOException fnf) { }
      
      return ret; 

   }// end of getRTIKernelIOR()

   /**
   */
   private static String 
   askIOR(String host, int port, String interfaceName)
   {

      String retIOR=null;

      try
      {
         String query = new String("http://"+host+":"+port+"/servlet/naming?");
         query += "cmd=getIOR&";
         query += ("IDL="+interfaceName);
         System.out.println(" query :"+query);

         URL namingURL = new URL(query);

         DataInputStream dis = new DataInputStream( namingURL.openStream());

         retIOR = dis.readLine();

         if(retIOR!=null && !retIOR.startsWith("IOR:")) retIOR = null;

         dis.close();

      } catch(java.net.MalformedURLException mfue) {}
        catch(java.io.IOException ioe) {}

      return retIOR;

   }// end of askIOR()

}// end of KernelLocator
