package owrti.xml;

import java.io.PrintStream;


/**
*
* @date   August 11, 1998 ( Last Updated August 11, 1998 )
* @author H. Timucin Ozdemir
*
*/
public class 
AttributeDef
{
   /** Attribute Name */
   String aname;

   /** Transportation Type */
   TransportType tType ;

   /** Order */
   OrderType oType ;

   /**
   */
   public AttributeDef(String _aname)
   {
      this(_aname, OrderType.RECEIVE, TransportType.RELIABLE);

   }// end of CONSTRUCTOR

   /**
   */
   public AttributeDef(String _aname, OrderType _oType)
   {
      this(_aname, _oType, TransportType.RELIABLE);

   }// end of CONSTRUCTOR

   /**
   */
   public AttributeDef(String _aname, TransportType tType)
   {
      this(_aname, OrderType.RECEIVE, tType);

   }// end of CONSTRUCTOR

   /**
   */
   public AttributeDef(String _aname, OrderType _oType, TransportType _tType)
   {
      aname = _aname; 
      tType = _tType;
      oType = _oType;

   }// end of CONSTRUCTOR

   /**
   */
   public String getName() { return aname; }

   /**
   */
   public TransportType getTransportType() { return tType; }

   /**
   */
   public void setToReliable()   { tType=TransportType.RELIABLE; }
   public void setToBestEffort() { tType=TransportType.BEST_EFFORT; }

   /**
   */
   public OrderType getOrderType() { return oType; }

   /**
   */
   public void setToRO()  { oType=OrderType.RECEIVE; }
   public void setToTSO() { oType=OrderType.TIMESTAMP; }

   /**
   */
   public final void
   printDIF(PrintStream o)
   {
      o.println( DIF_CONSTANTS.pfx_attribute+aname+" "+tType.toString()+
                 " "+oType.toString()+DIF_CONSTANTS.sfx_attribute);

   }// end of printDIF

   /**
   */
   public final void
   printXML(PrintStream o)
   {
      o.println(HLAML_CONSTANTS.pfx_attribute);

      o.println(HLAML_CONSTANTS.pfx_name+aname+HLAML_CONSTANTS.sfx_name);

      o.println(HLAML_CONSTANTS.pfx_transport+tType.toString()+ 
                HLAML_CONSTANTS.sfx_transport);

      o.println(HLAML_CONSTANTS.pfx_order+oType.toString()+ 
                HLAML_CONSTANTS.sfx_order);

      o.println(HLAML_CONSTANTS.sfx_attribute);

   }// end of printXML

}// end of AttributeDef
