package owrti.xml;

import java.util.Vector;
import java.util.Enumeration;
import java.io.PrintStream;


/**
*
* @date   August 11, 1998 ( Last Updated August 11, 1998 )
* @author H. Timucin Ozdemir
*
*/
public class 
SpaceDef
{
   /** Space Name */
   String sname;

   /** Dimensions */
   Vector dimensions;

   /**
   */
   public SpaceDef(String _sname)
   {
      sname = _sname;
      dimensions = new Vector();

   }// end of CONSTRUCTOR

   /**
   */
   public SpaceDef()
   {
      this(null);

   }// end of CONSTRUCTOR

   /**
   */
   public String getSpaceName() { return sname; }
   public String getName() { return sname; }
   public void setName(String _name) { sname = new String(_name); }

   /**
   */
   public Enumeration getDimensions() { return dimensions.elements(); }

   /**
   */
   public void addDimension(String _dimName) 
   { 
      if(!dimensions.contains(_dimName)) dimensions.addElement(_dimName);

   }// end of addDimension

   public final void 
   printDIF(PrintStream o)
   {
      o.println(DIF_CONSTANTS.pfx_space+sname);
      printDIFDims(o,true);
      o.println(DIF_CONSTANTS.sfx_space);

   }// end of printDIF

   final void 
   printDIFDims( PrintStream o, boolean idDIF)
   {
      String current ;
      Enumeration e = dimensions.elements();

      if(e!=null &&  e.hasMoreElements())
      {
        for(;e.hasMoreElements();)
        {
           current = (String) e.nextElement();
           if(current!=null) 
           {
              if(idDIF) o.println( DIF_CONSTANTS.pfx_dimension+current+
                                   DIF_CONSTANTS.sfx_dimension); 
              else      o.println( HLAML_CONSTANTS.pfx_dimension+current+
                                   HLAML_CONSTANTS.sfx_dimension); 
            
           }// end of if

        }// end of for

      }// end of if

   }// end of printDIFDims

   public final void 
   printXML(PrintStream o)
   {
      o.println(HLAML_CONSTANTS.pfx_space);
      o.println(HLAML_CONSTANTS.pfx_name+sname+HLAML_CONSTANTS.sfx_name);
      printDIFDims(o,false);
      o.println(HLAML_CONSTANTS.sfx_space);

   }// end of printXML

}// end of SpaceDef
