
package owrti.xml;

/**
*
* @date   August 11, 1998 ( Last Updated August 11, 1998 )
* @author H. Timucin Ozdemir
*
*/
public final class 
TransportType 
{
     public static final int _RELIABLE = 0, _BEST_EFFORT = 1;

     public static final TransportType RELIABLE = new TransportType(_RELIABLE);

     public static final TransportType BEST_EFFORT = new TransportType(_BEST_EFFORT);

     public int value() { return _value; }

     public final String toString() 
     { 
        String ret;

        switch (_value) 
        {
             case _BEST_EFFORT: ret = new String("best_effort"); break;
             case _RELIABLE: 
             default: ret = new String("reliable"); break;

        }// end of switch

        return ret;

     }// endof toString()

     public static final TransportType 
     from_int(int i)  throws  UnknownTransportationType
     {

        switch (i) 
        {
             case _RELIABLE: return RELIABLE;
             case _BEST_EFFORT: return BEST_EFFORT;
             default: throw new UnknownTransportationType();

        }// end of switch

     }// end of from_int()

     private TransportType(int _value){
         this._value = _value;
     }

     private int _value;
}

