
import RTIcap.*;           // The package containing our stubs.
import npacrti.*;           // The package containing our stubs.
import org.omg.CosNaming.*;  // HelloClient will use the naming service.
import org.omg.CORBA.*;      // All CORBA applications need these classes.


public class startRTIKernelClient
{
  public static void main(String args[])
  {
    try{
      
      // Create and initialize the ORB
      ORB orb = ORB.init(args, null);
      
      // Get the root naming context
      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
      // Resolve the object reference in naming
      NameComponent nc = new NameComponent("RTIKernel", " ");
      NameComponent path[] = {nc};
      RTIKernelInterface rtiKernel = RTIKernelInterfaceHelper.narrow(ncRef.resolve(path));
      
      // Call the Hello server object and print results
      String version = rtiKernel.getVersion();
      System.out.println(" Version is : "+version);      

      RTIambassador rtiAmb = rtiKernel.createRTIAmbassador();
      rtiAmb.beginTicking(10);
          
    } catch(Exception e) {
        System.out.println("ERROR : " + e);
        e.printStackTrace(System.out);
      }  
  }
}


